/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case AND:
      return pattern0 (x1, pnum_clobbers); /* [-1, 0] */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_V8QImode)
      || GET_MODE (x1) != E_V8QImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern21 (x3, pnum_clobbers); /* [-1, 1] */

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!nonimmediate_operand (operands[2], E_QImode))
        return -1;
      res = pattern20 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_QImode))
        return -1;
      res = pattern19 (x3);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 6;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 8
      || GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 9
      || GET_MODE (x5) != E_XFmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 10
      || GET_MODE (x7) != E_XFmode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 11
      || GET_MODE (x9) != E_XFmode)
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 12
      || GET_MODE (x11) != E_XFmode)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 13
      || GET_MODE (x13) != E_XFmode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 14
      || GET_MODE (x15) != E_XFmode)
    return -1;
  x16 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 15
      || GET_MODE (x17) != E_XFmode)
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!nonimmediate_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 3;

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode))
            return -1;
          return 4;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!nonimmediate_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  return pattern69 (x3); /* [-1, 8] */
}

int
pattern74 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_hilo_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCZmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  if (!memory_operand (operands[1], E_XImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern95 (x1, 
E_V2QImode); /* [-1, 0] */

    case E_V4QImode:
      res = pattern96 (x1, 
E_V4QImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_V8QImode:
      if (!memory_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || GET_MODE (x2) != E_V8QImode)
        return -1;
      res = pattern97 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4HImode:
      res = pattern96 (x1, 
E_V4HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_V2HImode:
      if (pattern95 (x1, 
E_V2HImode) != 0)
        return -1;
      return 8;

    case E_V2SImode:
      if (pattern95 (x1, 
E_V2SImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || GET_MODE (x2) != E_V16QImode
          || !nonimm_or_0_operand (operands[2], E_V16QImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V16HImode:
      if (pattern129 (x1, 
E_V16HImode, 
E_HImode, 
E_V16SImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern129 (x1, 
E_V8SImode, 
E_QImode, 
E_V8DImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode
          || !nonimm_or_0_operand (operands[2], E_V8HImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode))
            return -1;
          return 4;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V32QImode:
      if (pattern129 (x1, 
E_V32QImode, 
E_SImode, 
E_V32HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern129 (x1, 
E_V4SImode, 
E_QImode, 
E_V4DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!vector_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern168 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern171 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern171 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern171 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern171 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern171 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern171 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern171 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern171 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern171 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    case E_V64QImode:
      if (pattern171 (x1, 
E_V64QImode) != 0)
        return -1;
      return 9;

    case E_V32QImode:
      if (pattern171 (x1, 
E_V32QImode) != 0)
        return -1;
      return 10;

    case E_V16QImode:
      if (pattern171 (x1, 
E_V16QImode) != 0)
        return -1;
      return 11;

    case E_V32HImode:
      if (pattern171 (x1, 
E_V32HImode) != 0)
        return -1;
      return 12;

    case E_V16HImode:
      if (pattern171 (x1, 
E_V16HImode) != 0)
        return -1;
      return 13;

    case E_V8HImode:
      if (pattern171 (x1, 
E_V8HImode) != 0)
        return -1;
      return 14;

    case E_V16SImode:
      if (pattern171 (x1, 
E_V16SImode) != 0)
        return -1;
      return 15;

    case E_V8SImode:
      if (pattern171 (x1, 
E_V8SImode) != 0)
        return -1;
      return 16;

    case E_V4SImode:
      if (pattern171 (x1, 
E_V4SImode) != 0)
        return -1;
      return 17;

    case E_V8DImode:
      if (pattern171 (x1, 
E_V8DImode) != 0)
        return -1;
      return 18;

    case E_V4DImode:
      if (pattern171 (x1, 
E_V4DImode) != 0)
        return -1;
      return 19;

    case E_V2DImode:
      if (pattern171 (x1, 
E_V2DImode) != 0)
        return -1;
      return 20;

    case E_V32BFmode:
      if (pattern27 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 21;

    case E_V16BFmode:
      if (pattern27 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 22;

    case E_V8BFmode:
      if (pattern27 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern187 (x3); /* [-1, 1] */
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      return pattern191 (x4); /* [-1, 7] */

    case ASHIFT:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x5, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern202 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 110)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern201 (x5, 
E_V2SFmode); /* [-1, 0] */
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern218 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const_vector_duplicate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCCmode)
    return -1;
  return 0;
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern238 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  return pattern41 (x4); /* [-1, 1] */
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      return pattern240 (x2); /* [-1, 1] */

    case PLUS:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern240 (x2);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern2 (x2);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern260 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  return pattern259 (x1); /* [-1, 2] */
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  x10 = XEXP (x1, 1);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern265 (x1, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern265 (x1, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern265 (x1, 
E_DFmode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return 0;

        case E_V16SImode:
          return 1;

        case E_V8DImode:
          return 2;

        case E_V16HImode:
          return 3;

        case E_V8SImode:
          return 4;

        case E_V4DImode:
          return 5;

        case E_V8HImode:
          return 6;

        case E_V4SImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern287 (x1, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern287 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern293 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ASHIFT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ZERO_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != ZERO_EXTEND
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCmode)
    return -1;
  return pattern301 (x2); /* [-1, 1] */
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XVECEXP (x5, 0, 0);
  operands[0] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  operands[1] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x10, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x9, 0);
  if (!rtx_equal_p (x13, operands[0]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      return pattern308 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern308 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern308 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  return pattern318 (x3); /* [-1, 2] */
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return pattern322 (x4, 
E_DImode); /* [-1, 0] */

        case E_TImode:
          if (pattern322 (x4, 
E_TImode) != 0)
            return -1;
          return 1;

        case E_QImode:
          if (pattern322 (x4, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_HImode:
          if (pattern322 (x4, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_SImode:
          if (pattern322 (x4, 
E_SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case USE:
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      return 5;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_QImode
          || !memory_operand (operands[1], E_QImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!memory_operand (operands[1], E_QImode)
              || !const_int_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!memory_operand (operands[1], E_HImode)
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 7)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7)
    return -1;
  return 0;
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern362 (x2, 
E_TImode); /* [-1, 0] */
}

int
pattern369 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_no_SP_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !immediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern380 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!const_0_to_63_operand (operands[3], E_QImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_TImode
          || GET_MODE (x4) != E_TImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!const_0_to_255_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (!const_0_to_31_operand (x7, E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern405 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern404 (x1, 
E_SImode, 
E_V32QImode, 
E_V32HFmode, 
E_V64QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern404 (x1, 
E_HImode, 
E_V16QImode, 
E_V16HFmode, 
E_V32QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern413 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern420 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || pattern419 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern426 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[4] = x2;
      x3 = XEXP (x1, 1);
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern425 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern425 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern425 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern425 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern425 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern425 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern425 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern425 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern425 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        case E_V16SImode:
          if (pattern120 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 9;

        case E_V8SImode:
          if (pattern120 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern120 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 11;

        case E_V8DImode:
          if (pattern120 (x1, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          return 12;

        case E_V4DImode:
          if (pattern120 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 13;

        case E_V2DImode:
          if (pattern120 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 14;

        case E_V64QImode:
          if (pattern120 (x1, 
E_V64QImode, 
E_DImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern120 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern120 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 17;

        case E_V32HImode:
          if (pattern120 (x1, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern120 (x1, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 19;

        case E_V8HImode:
          if (pattern120 (x1, 
E_V8HImode, 
E_QImode) != 0)
            return -1;
          return 20;

        case E_V32BFmode:
          if (pattern122 (x1, 
E_V32BFmode, 
E_SImode) != 0)
            return -1;
          return 21;

        case E_V16BFmode:
          if (pattern122 (x1, 
E_V16BFmode, 
E_HImode) != 0)
            return -1;
          return 22;

        case E_V8BFmode:
          if (pattern122 (x1, 
E_V8BFmode, 
E_QImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern124 (x1);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    default:
      return -1;
    }
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!nonimmediate_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const0_operand (operands[2], i2)
      || !const0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern469 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern468 (x1, 
E_V64QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern468 (x1, 
E_V32QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern468 (x1, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern468 (x1, 
E_V32HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern468 (x1, 
E_V16HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern468 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    case E_V16SImode:
      if (pattern468 (x1, 
E_V16SImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern468 (x1, 
E_V8SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern468 (x1, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pattern468 (x1, 
E_V8DImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern468 (x1, 
E_V4DImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern468 (x1, 
E_V2DImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern478 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V4QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern481 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_XFmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_XFmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_XFmode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  x9 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

int
pattern487 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern492 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      res = pattern491 (x1, 
E_SImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_DImode:
      res = pattern491 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern503 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern502 (x4); /* [-1, 1] */
}

int
pattern508 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern512 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_hilo_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern515 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_or_x86_64_const_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_QImode)
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER
      || !register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  switch (GET_MODE (operands[3]))
    {
    case E_SFmode:
      return pattern521 (
E_V4SFmode, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern521 (
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern529 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x7, 1);
  operands[3] = x9;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x13))
    {
    case UNSPEC:
      return pattern526 (x1); /* [-1, 0] */

    case USE:
      res = pattern528 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern539 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != SUBREG
          || maybe_ne (SUBREG_BYTE (x11), 0))
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != i1
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != SUBREG
          || maybe_ne (SUBREG_BYTE (x13), 0)
          || GET_MODE (x13) != E_QImode)
        return -1;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x14, operands[3]))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != ZERO_EXTRACT)
            return -1;
          x16 = XEXP (x15, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x15, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x18 = XEXP (x2, 0);
          operands[4] = x18;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode))
            return -1;
          return pattern538 (x1); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern562 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x1, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  return 0;
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern576 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[3] = x3;
      return pattern575 (x1); /* [-1, 28] */

    case NEG:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      return 29;

    default:
      return -1;
    }
}

int
pattern579 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern584 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern588 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const48_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return pattern587 (x1); /* [-1, 5] */

    case CONST_INT:
      res = pattern585 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          return pattern592 (x1, 
E_V8SFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern592 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V4DFmode:
          if (pattern592 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 2;

        case E_V2DFmode:
          if (pattern592 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern593 (x1, 
E_V8SImode, 
E_V8SFmode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern593 (x1, 
E_V4SImode, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V4DFmode:
          if (pattern593 (x1, 
E_V4DImode, 
E_V4DFmode) != 0)
            return -1;
          return 6;

        case E_V2DFmode:
          if (pattern593 (x1, 
E_V2DImode, 
E_V2DFmode) != 0)
            return -1;
          return 7;

        case E_V32QImode:
          if (pattern594 (x1, 
E_V32QImode) != 0)
            return -1;
          return 8;

        case E_V16QImode:
          if (pattern594 (x1, 
E_V16QImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern616 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  return 0;
}

int
pattern624 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1
      || pattern623 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern627 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern627 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern628 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern628 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern635 (x5, 
E_TFmode); /* [-1, 0] */

    case E_HFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern209 (x5, 
E_V8HFmode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_SFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern209 (x5, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 2;

    case E_DFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern209 (x5, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      return 3;

    case E_V2BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern636 (x5, 
E_V2BFmode) != 0)
        return -1;
      return 4;

    case E_V2HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern636 (x5, 
E_V2HFmode) != 0)
        return -1;
      return 5;

    case E_V32BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V32BFmode) != 0)
        return -1;
      return 6;

    case E_V16BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16BFmode) != 0)
        return -1;
      return 7;

    case E_V8BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8BFmode) != 0)
        return -1;
      return 8;

    case E_V32HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V32HFmode) != 0)
        return -1;
      return 9;

    case E_V16HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16HFmode) != 0)
        return -1;
      return 10;

    case E_V8HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8HFmode) != 0)
        return -1;
      return 11;

    case E_V16SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16SFmode) != 0)
        return -1;
      return 12;

    case E_V8SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8SFmode) != 0)
        return -1;
      return 13;

    case E_V4SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V4SFmode) != 0)
        return -1;
      return 14;

    case E_V8DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8DFmode) != 0)
        return -1;
      return 15;

    case E_V4DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V4DFmode) != 0)
        return -1;
      return 16;

    case E_V2DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V2DFmode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern680 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != EQ)
    return -1;
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  operands[5] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4QImode:
      return pattern679 (x1, 
E_V4QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern679 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern679 (x1, 
E_V2HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern693 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern699 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_QImode)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern709 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern716 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern723 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern731 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern742 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !pmovzx_parallel (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern752 (rtx x1, machine_mode i1, int i2, int i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || XVECLEN (x1, 0) != i3
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern755 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern768 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern775 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern779 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != VEC_SELECT)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern784 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern788 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !binary_fp_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern800 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern807 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern816 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V16SImode
      || !nonimm_or_0_operand (operands[2], E_V16SImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern825 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || GET_MODE (x3) != i2)
    return -1;
  x9 = XEXP (x3, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern127 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern127 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern837 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern840 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern844 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern846 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern851 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  return 0;
}

int
pattern860 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern859 (x3, 
E_DImode, 
E_SImode); /* [-1, 0] */

    case E_TImode:
      if (pattern859 (x3, 
E_TImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern869 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != SUBREG
          || maybe_ne (SUBREG_BYTE (x10), 0))
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != i1
          || GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG
          || maybe_ne (SUBREG_BYTE (x12), 0)
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          x14 = XEXP (x9, 0);
          if (GET_CODE (x14) != ZERO_EXTRACT)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x14, 2);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x2, 0);
          operands[4] = x17;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode)
              || GET_MODE (x4) != E_QImode)
            return -1;
          x18 = XEXP (x6, 0);
          operands[1] = x18;
          if (!int248_register_operand (operands[1], E_VOIDmode))
            return -1;
          return pattern537 (x9); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern894 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_HFmode)
      || GET_MODE (x1) != E_HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      return 0;

    case E_V16HFmode:
      if (!nonimmediate_operand (operands[1], E_V16HFmode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern897 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      return pattern11 (x1, 
E_V2HFmode, 
E_V4HFmode); /* [-1, 0] */

    case E_V2BFmode:
      if (pattern11 (x1, 
E_V2BFmode, 
E_V4BFmode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern11 (x1, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern903 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimm_or_0_operand (operands[1], E_V64QImode)
          || !nonimm_or_0_operand (operands[2], E_V64QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!nonimm_or_0_operand (operands[1], E_V32QImode)
              || !nonimm_or_0_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!nonimm_or_0_operand (operands[1], E_V32HImode)
              || !nonimm_or_0_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern914 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern919 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern928 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern939 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern948 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x5, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != ZERO_EXTRACT)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x10 = XEXP (x8, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x11 = XEXP (x8, 0);
  operands[0] = x11;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern958 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern961 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_CODE (x3))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x3), 0))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern317 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern317 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern317 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern317 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern990 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1000 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1004 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern1011 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1018 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i3
      || !vector_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1027 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[1], i3)
      || !register_operand (operands[2], i3)
      || !register_operand (operands[3], i3)
      || !const0_operand (operands[4], i3))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1035 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1039 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1046 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern1045 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern1045 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern1045 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern1045 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1059 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1068 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1074 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[4]))
    {
    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1083 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_MODE (x7) != E_CCCmode
      || GET_MODE (x3) != E_CCCmode)
    return -1;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  if (!memory_operand (operands[2], i1))
    return -1;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x3, 1);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  x11 = XEXP (x6, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x6, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

int
pattern1093 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !const_0_to_31_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1099 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1132 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!const_0_to_63_operand (operands[3], E_QImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_TImode
          || GET_MODE (x4) != E_TImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!const_0_to_255_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (!const_0_to_31_operand (x7, E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern1145 (x2, 
E_DImode); /* [-1, 2] */
}

int
pattern1151 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != IF_THEN_ELSE)
    return -1;
  x8 = XEXP (x7, 0);
  if (!bt_comparison_operator (x8, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x1, 0);
  switch (GET_CODE (x9))
    {
    case STRICT_LOW_PART:
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (!extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (!extract_operator (operands[3], E_DImode)
              || !extract_operator (operands[4], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1190 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1193 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XVECEXP (x4, 0, 4);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x10 = XVECEXP (x4, 0, 5);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x11 = XVECEXP (x4, 0, 6);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x12 = XVECEXP (x4, 0, 7);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x13 = XEXP (x1, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 1);
  return pattern1211 (x15, 
8); /* [-1, 0] */
}

int
pattern1230 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CALL)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  return 0;
}

int
pattern1246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1255 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !vector_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1265 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V8HFmode)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 223
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 2);
  if (XWINT (x6, 0) != 3LL
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || GET_MODE (x3) != E_V8HFmode
      || !register_operand (operands[1], E_V8HFmode)
      || !register_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_V8HFmode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  if (!register_operand (x7, E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x8, E_SImode))
    return -1;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x3, 1);
  switch (GET_CODE (x10))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x10;
      if (!const0_operand (operands[4], E_V8HFmode))
        return -1;
      operands[5] = x7;
      operands[6] = x8;
      return 0;

    case REG:
    case SUBREG:
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      operands[4] = x7;
      operands[5] = x8;
      return 1;

    default:
      return -1;
    }
}

int
pattern1311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1328 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1337 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1347 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V4DImode
      || !nonimm_or_0_operand (operands[2], E_V4DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1366 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1373 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1380 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern1379 (x3, 
i1); /* [-1, 0] */
}

int
pattern1386 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1395 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 2);
  return pattern1344 (x2, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1401 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 109
      || GET_MODE (x6) != E_CCZmode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCZmode)
    return -1;
  x9 = XVECEXP (x1, 0, 0);
  x10 = XEXP (x9, 1);
  x11 = XVECEXP (x10, 0, 0);
  operands[2] = x11;
  return 0;
}

int
pattern1412 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1418 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1427 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern1439 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern1439 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1448 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1455 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1463 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 2);
  return pattern1456 (x5, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1471 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1470 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1470 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1483 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 4)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1493 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1509 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (XWINT (x2, 0) != 2LL)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (XWINT (x3, 0) != 2LL)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (XWINT (x4, 0) != 4LL)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (XWINT (x5, 0) != 4LL)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (XWINT (x6, 0) != 6LL)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (XWINT (x7, 0) != 6LL)
    return -1;
  return 0;
}

int
pattern1531 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (XWINT (x2, 0) != 2LL)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (XWINT (x3, 0) != 2LL)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (XWINT (x4, 0) != 4LL)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (XWINT (x5, 0) != 4LL)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (XWINT (x6, 0) != 6LL)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (XWINT (x7, 0) != 6LL)
    return -1;
  return 0;
}

int
pattern1542 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != STRICT_LOW_PART)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  return pattern1486 (); /* [-1, 2] */
}

int
pattern1550 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NEG
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = PATTERN (peep2_next_insn (2));
  return pattern1441 (x9, 
i1); /* [-1, 0] */
}

int
pattern1559 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      if (!register_operand (operands[2], E_V16SImode)
          || !register_operand (operands[6], E_HImode)
          || !register_operand (operands[3], E_V16SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode)
          || !register_operand (operands[6], E_QImode)
          || !register_operand (operands[3], E_V8SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1570 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1569 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1569 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1583 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1582 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1582 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1594 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1601 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1600 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1600 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1613 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SFmode)
      || GET_MODE (x1) != E_V8SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V8HFmode:
      if (!memory_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!memory_operand (operands[1], E_V16BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1622 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1632 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1638 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 12);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 13);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 15);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 16);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XVECEXP (x1, 0, 17);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x8 = XVECEXP (x1, 0, 18);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x9 = XVECEXP (x1, 0, 19);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  return 0;
}

int
pattern1654 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 17);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 18);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 19);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 20);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 21);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1664 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  x7 = XEXP (x1, 1);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  return 0;
}

int
pattern1673 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode)
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode)
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1681 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x1, 0);
      switch (GET_MODE (x9))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !extract_operator (operands[3], E_DImode)
              || !extract_operator (operands[4], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1697 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_scalar_int_operand (operands[6], i2)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1706 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (XWINT (x2, 0) != 12LL)
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (XWINT (x3, 0) != 28LL)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (XWINT (x4, 0) != 13LL)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (XWINT (x5, 0) != 29LL)
    return -1;
  return 0;
}

int
pattern1712 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          return 0;

        case E_SImode:
          return 1;

        case E_DImode:
          return 2;

        case E_TImode:
          return 3;

        default:
          return -1;
        }

    case CONST_INT:
      operands[6] = x5;
      x7 = XEXP (x3, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      operands[2] = x9;
      x10 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          return 4;

        case E_SImode:
          return 5;

        case E_DImode:
          return 6;

        case E_TImode:
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1726 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !sext_operand (operands[2], i1)
      || pattern1725 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1734 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 28);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 29);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 30);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 31);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1741 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode))
        {
          if (const0_operand (operands[1], E_QImode))
            {
              if ((
#line 1563 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512F && ix86_match_ccmode (insn, CCZmode)) && 
#line 1555 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                return 4; /* *cmpqi_ccz_1 */
              if (
#line 1577 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return 8; /* *cmpqi_ccno_1 */
            }
          if (general_operand (operands[1], E_QImode)
              && 
#line 1589 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
            return 12; /* *cmpqi_1 */
        }
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode))
        {
          if (const0_operand (operands[1], E_HImode))
            {
              if (
#line 1563 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512F && ix86_match_ccmode (insn, CCZmode)))
                return 5; /* *cmphi_ccz_1 */
              if (
#line 1577 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return 9; /* *cmphi_ccno_1 */
            }
          if (general_operand (operands[1], E_HImode)
              && 
#line 1589 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
            return 13; /* *cmphi_1 */
        }
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          if (const0_operand (operands[1], E_SImode))
            {
              if ((
#line 1563 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512F && ix86_match_ccmode (insn, CCZmode)) && 
#line 1556 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                return 6; /* *cmpsi_ccz_1 */
              if (
#line 1577 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return 10; /* *cmpsi_ccno_1 */
            }
          if (x86_64_general_operand (operands[1], E_SImode)
              && 
#line 1589 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
            return 14; /* *cmpsi_1 */
        }
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode))
        {
          if (const0_operand (operands[1], E_DImode))
            {
              if ((
#line 1563 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512F && ix86_match_ccmode (insn, CCZmode)) && 
#line 1556 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)))
                return 7; /* *cmpdi_ccz_1 */
              if ((
#line 1577 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 11; /* *cmpdi_ccno_1 */
            }
          if (x86_64_general_operand (operands[1], E_DImode)
              && (
#line 1589 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 15; /* *cmpdi_1 */
        }
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_CCZmode:
      if (GET_MODE (x2) == E_CCZmode)
        {
          switch (pattern777 ())
            {
            case 0:
              if ((
#line 1682 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 32; /* *cmpdi_doubleword */
              break;

            case 1:
              if ((
#line 1682 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 33; /* *cmpti_doubleword */
              break;

            default:
              break;
            }
        }
      break;

    case E_CCFPmode:
      if (GET_MODE (x2) == E_CCFPmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_XFmode:
              if (register_operand (operands[0], E_XFmode)
                  && register_operand (operands[1], E_XFmode)
                  && 
#line 2029 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
                return 47; /* *cmpixf_i387 */
              break;

            case E_SFmode:
              if (register_operand (operands[0], E_SFmode)
                  && register_ssemem_operand (operands[1], E_SFmode)
                  && 
#line 2069 "../../../gcc/config/i386/i386.md"
((SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   || (TARGET_80387 && TARGET_CMOVE)))
                return 55; /* *cmpisf */
              break;

            case E_DFmode:
              if (register_operand (operands[0], E_DFmode)
                  && register_ssemem_operand (operands[1], E_DFmode)
                  && 
#line 2069 "../../../gcc/config/i386/i386.md"
((SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   || (TARGET_80387 && TARGET_CMOVE)))
                return 57; /* *cmpidf */
              break;

            case E_HFmode:
              if (register_operand (operands[0], E_HFmode)
                  && nonimmediate_operand (operands[1], E_HFmode)
                  && 
#line 2106 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return 59; /* *cmpihf */
              break;

            case E_BFmode:
              if (register_operand (operands[0], E_BFmode)
                  && nonimmediate_operand (operands[1], E_BFmode)
                  && 
#line 2117 "../../../gcc/config/i386/i386.md"
(TARGET_AVX10_2_256))
                return 61; /* *cmpibf */
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  if (!nonimmediate_operand (operands[0], E_QImode)
      || pattern551 (x3) != 0)
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x5, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!extract_operator (operands[2], E_HImode)
          || !
#line 1614 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
        return -1;
      return 20; /* *cmpqi_exthi_1 */

    case E_SImode:
      if (!extract_operator (operands[2], E_SImode)
          || !
#line 1614 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
        return -1;
      return 21; /* *cmpqi_extsi_1 */

    case E_DImode:
      if (!extract_operator (operands[2], E_DImode)
          || !(
#line 1614 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 22; /* *cmpqi_extdi_1 */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x4 = XEXP (x2, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[1] = x6;
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!general_operand (operands[1], E_HImode))
        return -1;
      return 115; /* insvhi_1 */

    case E_SImode:
      if (!general_operand (operands[1], E_SImode))
        return -1;
      return 116; /* insvsi_1 */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_14 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      res = recog_15 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_16 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (indirect_branch_operand (operands[0], E_SImode)
              && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode))
            return 1205; /* *indirect_jump */
          break;

        case E_DImode:
          if (indirect_branch_operand (operands[0], E_DImode)
              && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode))
            return 1206; /* *indirect_jump */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      operands[0] = x2;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!x86_64_movabs_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !
#line 3319 "../../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 1)))
            return -1;
          return 94; /* *movabsqi_2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !
#line 3319 "../../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 1)))
            return -1;
          return 95; /* *movabshi_2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 3319 "../../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 1)))
            return -1;
          return 96; /* *movabssi_2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 3319 "../../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 1)))
            return -1;
          return 97; /* *movabsdi_2 */

        default:
          return -1;
        }

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x3), 0))
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[2] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x3) != E_QImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!int248_register_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_CODE (x2))
            {
            case STRICT_LOW_PART:
              x8 = XEXP (x2, 0);
              operands[0] = x8;
              if (!register_operand (operands[0], E_QImode))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_HImode:
                  if (!extract_operator (operands[2], E_HImode)
                      || !
#line 3464 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return -1;
                  return 105; /* *movstrictqi_exthi_1 */

                case E_SImode:
                  if (!extract_operator (operands[2], E_SImode)
                      || !
#line 3464 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return -1;
                  return 106; /* *movstrictqi_extsi_1 */

                case E_DImode:
                  if (!extract_operator (operands[2], E_DImode)
                      || !(
#line 3464 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 107; /* *movstrictqi_extdi_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x2;
              if (!nonimmediate_operand (operands[0], E_QImode))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_HImode:
                  if (!extract_operator (operands[2], E_HImode))
                    return -1;
                  return 113; /* *extzvqi */

                case E_SImode:
                  if (!extract_operator (operands[2], E_SImode))
                    return -1;
                  return 114; /* *extzvqi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x4;
          if (!general_operand (operands[1], E_QImode)
              || pattern361 (x2) != 0)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (GET_MODE (x3) != E_HImode)
                return -1;
              return 117; /* *insvqi_1 */

            case E_SImode:
              if (GET_MODE (x3) != E_SImode)
                return -1;
              return 118; /* *insvqi_1 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern228 (x1, pnum_clobbers) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern230 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 267; /* *addqi_exthi_1 */

                case 1:
                  *pnum_clobbers = 1;
                  return 268; /* *addqi_extsi_1 */

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern1589 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 269; /* *addqi_exthi_2 */

            case 1:
              *pnum_clobbers = 1;
              return 271; /* *addqi_extsi_2 */

            default:
              return -1;
            }

        case MINUS:
          if (pattern228 (x1, pnum_clobbers) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) == SUBREG)
            {
              switch (pattern1589 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 270; /* *subqi_exthi_2 */

                case 1:
                  *pnum_clobbers = 1;
                  return 272; /* *subqi_extsi_2 */

                default:
                  break;
                }
            }
          operands[2] = x5;
          if (!general_operand (operands[2], E_QImode))
            return -1;
          switch (pattern230 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 347; /* *subqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 348; /* *subqi_extsi_1 */

            default:
              return -1;
            }

        case AND:
          if (pattern228 (x1, pnum_clobbers) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern230 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 627; /* *andqi_exthi_1 */

                case 1:
                  *pnum_clobbers = 1;
                  return 630; /* *andqi_extsi_1 */

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern1589 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 642; /* *andqi_exthi_2 */

            case 1:
              *pnum_clobbers = 1;
              return 645; /* *andqi_extsi_2 */

            default:
              return -1;
            }

        case IOR:
          if (pattern228 (x1, pnum_clobbers) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern230 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 628; /* *iorqi_exthi_1 */

                case 1:
                  *pnum_clobbers = 1;
                  return 631; /* *iorqi_extsi_1 */

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern1589 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 643; /* *iorqi_exthi_2 */

            case 1:
              *pnum_clobbers = 1;
              return 646; /* *iorqi_extsi_2 */

            default:
              return -1;
            }

        case XOR:
          if (pattern228 (x1, pnum_clobbers) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern230 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 629; /* *xorqi_exthi_1 */

                case 1:
                  *pnum_clobbers = 1;
                  return 632; /* *xorqi_extsi_1 */

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern1589 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 644; /* *xorqi_exthi_2 */

            case 1:
              *pnum_clobbers = 1;
              return 647; /* *xorqi_extsi_2 */

            default:
              return -1;
            }

        case NEG:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern229 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 799; /* *negqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 800; /* *negqi_extsi_1 */

            default:
              return -1;
            }

        case NOT:
          switch (pattern229 (x1))
            {
            case 0:
              return 857; /* *one_cmplqi_exthi_1 */

            case 1:
              return 858; /* *one_cmplqi_extsi_1 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern231 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 911; /* *ashlqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 912; /* *ashlqi_extsi_1 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern231 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1005; /* *lshrqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 1007; /* *lshrqi_extsi_1 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern231 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1006; /* *ashrqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 1008; /* *ashrqi_extsi_1 */

            default:
              return -1;
            }

        case SS_TRUNCATE:
          if (pattern232 (x1) != 0
              || !
#line 15425 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6719; /* *avx512vl_ss_truncatev2div2qi2_store_2 */

        case TRUNCATE:
          if (pattern232 (x1) != 0
              || !
#line 15425 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6720; /* *avx512vl_truncatev2div2qi2_store_2 */

        case US_TRUNCATE:
          if (pattern232 (x1) != 0
              || !
#line 15425 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6721; /* *avx512vl_us_truncatev2div2qi2_store_2 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 17
          || pattern59 (x1, 
E_CCCmode) != 0
          || !
#line 9883 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
        return -1;
      return 442; /* *setccc */

    case CONST_INT:
      if (pnum_clobbers == NULL
          || XWINT (x3, 0) != 0LL
          || GET_CODE (x2) != ZERO_EXTRACT
          || GET_MODE (x2) != E_HImode)
        return -1;
      x9 = XEXP (x2, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x10 = XEXP (x2, 2);
      operands[1] = x10;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !
#line 18963 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1162; /* *btrqi_2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !
#line 18963 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1163; /* *btrhi_2 */

        default:
          return -1;
        }

    case LABEL_REF:
      if (GET_CODE (x2) != PC)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      return 1204; /* jump */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (nonimm_ssenomem_operand (operands[0], E_DFmode)
          && nonimmediate_operand (operands[1], E_SFmode)
          && 
#line 5295 "../../../gcc/config/i386/i386.md"
(TARGET_80387 || (TARGET_SSE2 && TARGET_SSE_MATH)))
        return 161; /* *extendsfdf2 */
      if (!register_operand (operands[0], E_DFmode)
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 5451 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 163; /* *extendhfdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 5451 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 162; /* *extendhfsf2 */

    case E_XFmode:
      if (!nonimmediate_operand (operands[0], E_XFmode))
        return -1;
      switch (pattern364 (x3, 
E_XFmode))
        {
        case 0:
          if (!
#line 5513 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 165; /* *extendsfxf2_i387 */

        case 1:
          if (!
#line 5513 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 166; /* *extenddfxf2_i387 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (register_operand (operands[0], E_SImode))
        {
          switch (pattern365 ())
            {
            case 0:
              if (
#line 5769 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return 173; /* fix_trunchfsi2 */
              break;

            case 1:
              if (
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 179; /* fix_truncsfsi_sse */
              break;

            case 2:
              if (
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 180; /* fix_truncdfsi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 182; /* fix_truncsi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 185; /* *fix_truncsi_i387_1 */

    case E_HImode:
      if (pattern237 (x3, pnum_clobbers, 
E_VOIDmode, 
E_HImode) != 0)
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 181; /* fix_trunchi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 184; /* *fix_trunchi_i387_1 */

    case E_DImode:
      if (pattern237 (x3, pnum_clobbers, 
E_VOIDmode, 
E_DImode) != 0)
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 183; /* fix_truncdi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 186; /* *fix_truncdi_i387_1 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !vector_operand (operands[1], E_V2DFmode)
          || !
#line 8945 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4346; /* sse2_cvttpd2pi */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern976 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !nonimmediate_operand (operands[2], E_V16SImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2758; /* avx512f_cmpv16si3_mask */

            case E_V16HFmode:
              if (!register_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[2], E_V16HFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2782; /* avx512vl_cmpv16hf3_mask */

            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[2], E_V16SFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2788; /* avx512f_cmpv16sf3_mask */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !nonimmediate_operand (operands[2], E_V16QImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4486 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2914; /* avx512vl_cmpv16qi3_mask */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !nonimmediate_operand (operands[2], E_V16HImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4486 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2920; /* avx512vl_cmpv16hi3_mask */

            case E_V16BFmode:
              if (!register_operand (operands[1], E_V16BFmode)
                  || !nonimmediate_operand (operands[2], E_V16BFmode)
                  || !const_0_to_31_operand (operands[3], E_VOIDmode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32459 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10087; /* avx10_2_cmpbf16_v16bf_mask */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !nonimmediate_operand (operands[2], E_V8SImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2762; /* avx512vl_cmpv8si3_mask */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !nonimmediate_operand (operands[2], E_V4SImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2765; /* avx512vl_cmpv4si3_mask */

            case E_V8DImode:
              if (!register_operand (operands[1], E_V8DImode)
                  || !nonimmediate_operand (operands[2], E_V8DImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2768; /* avx512f_cmpv8di3_mask */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !nonimmediate_operand (operands[2], E_V4DImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2772; /* avx512vl_cmpv4di3_mask */

            case E_V2DImode:
              if (!register_operand (operands[1], E_V2DImode)
                  || !nonimmediate_operand (operands[2], E_V2DImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2775; /* avx512vl_cmpv2di3_mask */

            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[2], E_V8HFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2785; /* avx512fp16_cmpv8hf3_mask */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[2], E_V8SFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2792; /* avx512vl_cmpv8sf3_mask */

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[2], E_V4SFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2795; /* avx512vl_cmpv4sf3_mask */

            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[2], E_V8DFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2798; /* avx512f_cmpv8df3_mask */

            case E_V4DFmode:
              if (!register_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[2], E_V4DFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2802; /* avx512vl_cmpv4df3_mask */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[2], E_V2DFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2805; /* avx512vl_cmpv2df3_mask */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !nonimmediate_operand (operands[2], E_V8HImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4486 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2922; /* avx512vl_cmpv8hi3_mask */

            case E_V8BFmode:
              if (!register_operand (operands[1], E_V8BFmode)
                  || !nonimmediate_operand (operands[2], E_V8BFmode)
                  || !const_0_to_31_operand (operands[3], E_VOIDmode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32459 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10089; /* avx10_2_cmpbf16_v8bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1LL
          || pattern1093 (x2) != 0)
        return -1;
      switch (pattern1378 ())
        {
        case 0:
          if (!(
#line 4818 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3133; /* avx512f_vmcmpv8hf3 */

        case 1:
          if (!
#line 4818 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 3135; /* avx512f_vmcmpv4sf3 */

        case 2:
          if (!(
#line 4818 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3137; /* avx512f_vmcmpv2df3 */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern1093 (x2) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[4] = x5;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      switch (pattern1378 ())
        {
        case 0:
          if (!(
#line 4836 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3139; /* avx512f_vmcmpv8hf3_mask */

        case 1:
          if (!
#line 4836 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 3141; /* avx512f_vmcmpv4sf3_mask */

        case 2:
          if (!(
#line 4836 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3143; /* avx512f_vmcmpv2df3_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      res = recog_51 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x1, 0);
          switch (GET_CODE (x8))
            {
            case STRICT_LOW_PART:
              x9 = XEXP (x8, 0);
              operands[0] = x9;
              if (!register_operand (operands[0], E_QImode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_HImode:
                  if (!extract_operator (operands[3], E_HImode)
                      || !
#line 8215 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 333; /* *subqi_exthi_1_slp */

                case E_SImode:
                  if (!extract_operator (operands[3], E_SImode)
                      || !
#line 8215 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 334; /* *subqi_extsi_1_slp */

                case E_DImode:
                  if (!extract_operator (operands[3], E_DImode)
                      || !(
#line 8215 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 335; /* *subqi_extdi_1_slp */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x8;
              if (!nonimmediate_operand (operands[0], E_QImode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_HImode:
                  if (!extract_operator (operands[3], E_HImode))
                    return -1;
                  *pnum_clobbers = 1;
                  return 343; /* *subqi_exthi_0 */

                case E_SImode:
                  if (!extract_operator (operands[3], E_SImode))
                    return -1;
                  *pnum_clobbers = 1;
                  return 344; /* *subqi_extsi_0 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_TImode)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (pattern698 (x2, 
E_DImode, 
E_TImode) != 0
          || !(
#line 8103 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 312; /* *subti3_doubleword_zext */

    case LTU:
    case UNLT:
      switch (pattern374 (x1, pnum_clobbers))
        {
        case 0:
          if (pattern1099 (x2, 
E_QImode) != 0
              || !
#line 9349 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 410; /* *subqi3_carry_0 */

        case 1:
          if (pattern1099 (x2, 
E_HImode) != 0
              || !
#line 9349 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 411; /* *subhi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern374 (x1, pnum_clobbers))
        {
        case 0:
          if (pattern1100 (x2, 
E_QImode) != 0
              || !
#line 9363 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 414; /* *subqi3_carry_0r */

        case 1:
          if (pattern1100 (x2, 
E_HImode) != 0
              || !
#line 9363 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 415; /* *subhi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern376 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 10307 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *subqi3_eq_0 */

        case 1:
          if (!
#line 10307 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 492; /* *subhi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern376 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 10328 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 495; /* *subqi3_ne_0 */

        case 1:
          if (!
#line 10328 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 496; /* *subhi3_ne_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern43 (x3))
        {
        case 0:
          if (!
#line 3323 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (SS_PLUS, V8QImode, operands)))
            return -1;
          return 1678; /* *mmx_ssaddv8qi3 */

        case 1:
          if (!
#line 3323 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (SS_PLUS, V4HImode, operands)))
            return -1;
          return 1682; /* *mmx_ssaddv4hi3 */

        case 2:
          if (!
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1686; /* ssaddv4qi3 */

        case 3:
          if (!
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1690; /* ssaddv2qi3 */

        case 4:
          if (!
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1694; /* ssaddv2hi3 */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pattern94 (x3) != 0
          || !
#line 22628 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 7963; /* ssse3_phaddswv4hi3 */

    case MULT:
      if (GET_MODE (x4) != E_V4HImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ZERO_EXTEND
          || GET_MODE (x5) != E_V4HImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_V4QImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 4
          || pattern981 (x7, 
6, 
4, 
2, 
0) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      if (pattern1168 (x8, 
E_V4QImode, 
E_V4HImode) != 0)
        return -1;
      x9 = XEXP (x8, 0);
      x10 = XEXP (x9, 1);
      if (pattern1483 (x10, 
6, 
4, 
2, 
0) != 0)
        return -1;
      x11 = XEXP (x3, 1);
      if (pattern1637 (x11, 
E_V4QImode, 
E_V4HImode, 
ZERO_EXTEND) != 0
          || !register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      x13 = XEXP (x9, 0);
      operands[2] = x13;
      if (!register_mmxmem_operand (operands[2], E_V8QImode))
        return -1;
      x14 = XEXP (x11, 0);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x17 = XEXP (x11, 1);
      x18 = XEXP (x17, 0);
      x19 = XEXP (x18, 0);
      if (!rtx_equal_p (x19, operands[2])
          || !
#line 22912 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 7982; /* ssse3_pmaddubsw */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (x3))
    {
    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !const_0_to_3_operand (operands[2], E_SImode)
              || !
#line 5437 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return -1;
          return 1830; /* *mmx_pextrw_zext */

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !const_0_to_1_operand (operands[2], E_SImode)
              || !
#line 6098 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1852; /* *pextrw_zext */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !const_0_to_7_operand (operands[2], E_SImode)
              || !
#line 21127 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 7877; /* *vec_extractv8hi_zext */

        default:
          return -1;
        }

    case E_QImode:
      switch (pattern974 ())
        {
        case 0:
          if (!
#line 6130 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return -1;
          return 1855; /* *pextrb_zext */

        case 1:
          if (!(
#line 21127 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 21070 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
            return -1;
          return 7876; /* *vec_extractv16qi_zext */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern105 (x2))
        {
        case 0:
          if (
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 573; /* *andqi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 574; /* *andqi_1_zextsi */

        case 1:
          if (
#line 12640 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 577; /* *andhi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12640 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 578; /* *andhi_1_zextsi */

        case 2:
          if (
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 575; /* *andqi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 576; /* *andqi_1_zextdi */

        case 3:
          if (
#line 12640 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 579; /* *andhi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12640 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 580; /* *andhi_1_zextdi */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (XINT (x4, 1))
        {
        case 158:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              switch (pattern985 (x2, 
E_DImode))
                {
                case 0:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (DImode))) && 
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7609; /* *avx512bw_testmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (SImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7612; /* *avx512vl_testmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (SImode))) && 
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7618; /* *avx512bw_testmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7615; /* *avx512vl_testmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7621; /* *avx512vl_testmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7627; /* *avx512f_testmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7624; /* *avx512vl_testmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7630; /* *avx512vl_testmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7633; /* *avx512vl_testmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7636; /* *avx512f_testmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7639; /* *avx512vl_testmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7642; /* *avx512vl_testmv2di3_zext_mask */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern985 (x2, 
E_SImode))
                {
                case 0:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (DImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7610; /* *avx512bw_testmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (SImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7613; /* *avx512vl_testmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (SImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7619; /* *avx512bw_testmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7616; /* *avx512vl_testmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7622; /* *avx512vl_testmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7628; /* *avx512f_testmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7625; /* *avx512vl_testmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7631; /* *avx512vl_testmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7634; /* *avx512vl_testmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7637; /* *avx512f_testmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7640; /* *avx512vl_testmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19104 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7643; /* *avx512vl_testmv2di3_zext_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 159:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              switch (pattern985 (x2, 
E_DImode))
                {
                case 0:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (DImode))) && 
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7681; /* *avx512bw_testnmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (SImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7684; /* *avx512vl_testnmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (SImode))) && 
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7690; /* *avx512bw_testnmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7687; /* *avx512vl_testnmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7693; /* *avx512vl_testnmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7699; /* *avx512f_testnmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7696; /* *avx512vl_testnmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7702; /* *avx512vl_testnmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7705; /* *avx512vl_testnmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7708; /* *avx512f_testnmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7711; /* *avx512vl_testnmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7714; /* *avx512vl_testnmv2di3_zext_mask */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern985 (x2, 
E_SImode))
                {
                case 0:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (DImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7682; /* *avx512bw_testnmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (SImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7685; /* *avx512vl_testnmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (SImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7691; /* *avx512bw_testnmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7688; /* *avx512vl_testnmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7694; /* *avx512vl_testnmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7700; /* *avx512f_testnmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7697; /* *avx512vl_testnmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7703; /* *avx512vl_testnmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7706; /* *avx512vl_testnmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7709; /* *avx512f_testnmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7712; /* *avx512vl_testnmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19057 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7715; /* *avx512vl_testnmv2di3_zext_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern48 (x3, pnum_clobbers))
    {
    case 0:
      if (pnum_clobbers != NULL
          && pattern386 (x3) == 0
          && (
#line 16582 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 913; /* *lshrdi3_doubleword_mask */
        }
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      res = recog_86 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern389 (x3))
        {
        case 0:
          if (!
#line 17840 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1010; /* *lshrsi3_mask */

        case 1:
          if (!(
#line 17840 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1013; /* *lshrdi3_mask */

        case 2:
          if (!
#line 17888 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1022; /* *lshrsi3_add */

        case 3:
          if (!(
#line 17888 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1025; /* *lshrdi3_add */

        case 4:
          if (!
#line 17934 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1034; /* *lshrsi3_sub */

        case 5:
          if (!(
#line 17934 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1037; /* *lshrdi3_sub */

        default:
          return -1;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 16643 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 917; /* *lshrdi3_doubleword_mask_1 */
        }
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !(
#line 17865 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1019; /* *lshrdi3_mask_1 */

    case 2:
      if (!
#line 17865 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1016; /* *lshrsi3_mask_1 */

    case 3:
      if (!
#line 17912 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1028; /* *lshrsi3_add_1 */

    case 4:
      if (!(
#line 17912 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1031; /* *lshrdi3_add_1 */

    case 5:
      if (!
#line 17964 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1040; /* *lshrsi3_sub_1 */

    case 6:
      if (!(
#line 17964 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1043; /* *lshrdi3_sub_1 */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == SUBREG
      && known_eq (SUBREG_BYTE (x2), 0))
    {
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x1, 1);
          x5 = XEXP (x4, 2);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (x2))
                {
                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 19324 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1181; /* *btsi_setcqi */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 19324 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1182; /* *btdi_setcqi */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND)
    return -1;
  operands[0] = x2;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1328 (x4, 
E_SImode) != 0
          || !
#line 19405 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1189; /* *btsi_setcsi_mask */

    case E_DImode:
      if (pattern1328 (x4, 
E_DImode) != 0
          || !(
#line 19405 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1190; /* *btdi_setcdi_mask */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  if (call_insn_operand (operands[1], E_SImode)
      && (
#line 20326 "../../../gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode)))
    return 1220; /* *call_value */
  if (call_insn_operand (operands[1], E_DImode)
      && (
#line 20326 "../../../gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode)))
    return 1221; /* *call_value */
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) == E_DImode)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (GOT_memory_operand (operands[1], E_SImode))
            {
              operands[2] = x6;
              if (
#line 20337 "../../../gcc/config/i386/i386.md"
(TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER))
                return 1222; /* *call_value_got_x32 */
            }
        }
      break;

    case MEM:
      if (GET_MODE (x5) == E_SImode)
        {
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) == PLUS
              && GET_MODE (x7) == E_SImode)
            {
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (register_no_elim_operand (operands[1], E_SImode))
                {
                  x9 = XEXP (x7, 1);
                  operands[2] = x9;
                  if (GOT32_symbol_operand (operands[2], E_SImode))
                    {
                      operands[3] = x6;
                      if (
#line 20353 "../../../gcc/config/i386/i386.md"
(!TARGET_MACHO
   && !TARGET_64BIT && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (insn)))
                        return 1223; /* *sibcall_value_GOT_32 */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x5;
  operands[2] = x6;
  if (sibcall_insn_operand (operands[1], E_SImode)
      && (
#line 20367 "../../../gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode)))
    return 1224; /* *sibcall_value */
  if (!sibcall_insn_operand (operands[1], E_DImode)
      || !(
#line 20367 "../../../gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode)))
    return -1;
  return 1225; /* *sibcall_value */
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern904 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1934; /* *avx512f_loadv16si_mask */

    case E_V8SImode:
      if (pattern904 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1935; /* *avx512vl_loadv8si_mask */

    case E_V4SImode:
      if (pattern904 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1936; /* *avx512vl_loadv4si_mask */

    case E_V8DImode:
      if (pattern904 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1937; /* *avx512f_loadv8di_mask */

    case E_V4DImode:
      if (pattern904 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1938; /* *avx512vl_loadv4di_mask */

    case E_V2DImode:
      if (pattern904 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1939; /* *avx512vl_loadv2di_mask */

    case E_V16SFmode:
      if (pattern904 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1940; /* *avx512f_loadv16sf_mask */

    case E_V8SFmode:
      if (pattern904 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1941; /* *avx512vl_loadv8sf_mask */

    case E_V4SFmode:
      if (pattern904 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1942; /* *avx512vl_loadv4sf_mask */

    case E_V8DFmode:
      if (pattern904 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1943; /* *avx512f_loadv8df_mask */

    case E_V4DFmode:
      if (pattern904 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1944; /* *avx512vl_loadv4df_mask */

    case E_V2DFmode:
      if (pattern904 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1945; /* *avx512vl_loadv2df_mask */

    case E_V64QImode:
      if (pattern904 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1958; /* *avx512bw_loadv64qi_mask */

    case E_V16QImode:
      if (pattern904 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1959; /* *avx512vl_loadv16qi_mask */

    case E_V32QImode:
      if (pattern904 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1960; /* *avx512vl_loadv32qi_mask */

    case E_V32HImode:
      if (pattern904 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1961; /* *avx512bw_loadv32hi_mask */

    case E_V16HImode:
      if (pattern904 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1962; /* *avx512vl_loadv16hi_mask */

    case E_V8HImode:
      if (pattern904 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1963; /* *avx512vl_loadv8hi_mask */

    case E_V32HFmode:
      if (pattern904 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1964; /* *avx512bw_loadv32hf_mask */

    case E_V16HFmode:
      if (pattern904 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1965; /* *avx512vl_loadv16hf_mask */

    case E_V8HFmode:
      if (pattern904 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1966; /* *avx512fp16_loadv8hf_mask */

    case E_V32BFmode:
      if (pattern904 (x2, 
E_V32BFmode, 
E_SImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1967; /* *avx512bw_loadv32bf_mask */

    case E_V16BFmode:
      if (pattern904 (x2, 
E_V16BFmode, 
E_HImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1968; /* *avx512vl_loadv16bf_mask */

    case E_V8BFmode:
      if (pattern904 (x2, 
E_V8BFmode, 
E_QImode) != 0
          || !(
#line 1666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1969; /* *avx512vl_loadv8bf_mask */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern910 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 6460; /* avx512bw_getexpv32hf_mask */

    case E_V16HFmode:
      if (pattern910 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 6464; /* avx512vl_getexpv16hf_mask */

    case E_V8HFmode:
      if (pattern910 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 6467; /* avx512fp16_getexpv8hf_mask */

    case E_V16SFmode:
      if (pattern910 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 6470; /* avx512f_getexpv16sf_mask */

    case E_V8SFmode:
      if (pattern910 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 6474; /* avx512vl_getexpv8sf_mask */

    case E_V4SFmode:
      if (pattern910 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 6477; /* avx512vl_getexpv4sf_mask */

    case E_V8DFmode:
      if (pattern910 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 6480; /* avx512f_getexpv8df_mask */

    case E_V4DFmode:
      if (pattern910 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 6484; /* avx512vl_getexpv4df_mask */

    case E_V2DFmode:
      if (pattern910 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 6487; /* avx512vl_getexpv2df_mask */

    case E_V32BFmode:
      if (pattern564 (x2, 
E_V32BFmode, 
E_SImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10055; /* avx10_2_getexpbf16_v32bf_mask */

    case E_V16BFmode:
      if (pattern564 (x2, 
E_V16BFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 10057; /* avx10_2_getexpbf16_v16bf_mask */

    case E_V8BFmode:
      if (pattern564 (x2, 
E_V8BFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 10059; /* avx10_2_getexpbf16_v8bf_mask */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[5] = x7;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern411 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 531 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10290; /* avx10_2_minmaxpv32hf_mask */

        case E_V16HFmode:
          if (pattern411 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10294; /* avx10_2_minmaxpv16hf_mask */

        case E_V8HFmode:
          if (pattern411 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10298; /* avx10_2_minmaxpv8hf_mask */

        case E_V16SFmode:
          if (pattern411 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 532 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10302; /* avx10_2_minmaxpv16sf_mask */

        case E_V8SFmode:
          if (pattern411 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10306; /* avx10_2_minmaxpv8sf_mask */

        case E_V4SFmode:
          if (pattern411 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10310; /* avx10_2_minmaxpv4sf_mask */

        case E_V8DFmode:
          if (pattern411 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 533 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10314; /* avx10_2_minmaxpv8df_mask */

        case E_V4DFmode:
          if (pattern411 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10318; /* avx10_2_minmaxpv4df_mask */

        case E_V2DFmode:
          if (pattern411 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10322; /* avx10_2_minmaxpv2df_mask */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x7, 0) != 1LL)
        return -1;
      switch (pattern396 (x2))
        {
        case 0:
          if (!(
#line 32663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 10324; /* avx10_2_minmaxsv8hf */

        case 1:
          if (!
#line 32663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10328; /* avx10_2_minmaxsv4sf */

        case 2:
          if (!(
#line 32663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 10332; /* avx10_2_minmaxsv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[4] = x7;
  x8 = XEXP (x2, 2);
  operands[5] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern416 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 6501; /* avx512f_alignv16si_mask */

    case E_V8SImode:
      if (pattern416 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 6503; /* avx512vl_alignv8si_mask */

    case E_V4SImode:
      if (pattern416 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 6505; /* avx512vl_alignv4si_mask */

    case E_V8DImode:
      if (pattern416 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 6507; /* avx512f_alignv8di_mask */

    case E_V4DImode:
      if (pattern416 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 6509; /* avx512vl_alignv4di_mask */

    case E_V2DImode:
      if (pattern416 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 6511; /* avx512vl_alignv2di_mask */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 2);
  if (!register_operand (x5, E_QImode))
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x9;
          switch (pattern1109 (x2))
            {
            case 0:
              if (pattern1334 (x2, 
E_V8HFmode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1]))
                {
                  x11 = XEXP (x2, 1);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 6671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return 3723; /* avx512f_vmfmadd_v8hf_mask */
                }
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !(
#line 6691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3729; /* avx512f_vmfmadd_v8hf_mask3 */

            case 1:
              if (pattern1334 (x2, 
E_V4SFmode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1]))
                {
                  x11 = XEXP (x2, 1);
                  if (rtx_equal_p (x11, operands[1])
                      && 
#line 6671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                    return 3725; /* avx512f_vmfmadd_v4sf_mask */
                }
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !
#line 6691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 3731; /* avx512f_vmfmadd_v4sf_mask3 */

            case 2:
              if (pattern1334 (x2, 
E_V2DFmode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1]))
                {
                  x11 = XEXP (x2, 1);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 6671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3727; /* avx512f_vmfmadd_v2df_mask */
                }
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !(
#line 6691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3733; /* avx512f_vmfmadd_v2df_mask3 */

            case 3:
              if (pattern1407 (x2, 
E_V8HFmode) != 0
                  || !(
#line 6723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3735; /* avx512f_vmfmadd_v8hf_maskz_1 */

            case 4:
              if (pattern1407 (x2, 
E_V4SFmode) != 0
                  || !
#line 6723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 3737; /* avx512f_vmfmadd_v4sf_maskz_1 */

            case 5:
              if (pattern1407 (x2, 
E_V2DFmode) != 0
                  || !(
#line 6723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3739; /* avx512f_vmfmadd_v2df_maskz_1 */

            default:
              return -1;
            }

        case NEG:
          x12 = XEXP (x9, 0);
          operands[3] = x12;
          switch (pattern1109 (x2))
            {
            case 0:
              if (pattern1335 (x2, 
E_V8HFmode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1]))
                {
                  x11 = XEXP (x2, 1);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 6744 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return 3741; /* *avx512f_vmfmsub_v8hf_mask */
                }
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !(
#line 6765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3747; /* avx512f_vmfmsub_v8hf_mask3 */

            case 1:
              if (pattern1335 (x2, 
E_V4SFmode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1]))
                {
                  x11 = XEXP (x2, 1);
                  if (rtx_equal_p (x11, operands[1])
                      && 
#line 6744 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                    return 3743; /* *avx512f_vmfmsub_v4sf_mask */
                }
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !
#line 6765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 3749; /* avx512f_vmfmsub_v4sf_mask3 */

            case 2:
              if (pattern1335 (x2, 
E_V2DFmode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1]))
                {
                  x11 = XEXP (x2, 1);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 6744 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3745; /* *avx512f_vmfmsub_v2df_mask */
                }
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !(
#line 6765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3751; /* avx512f_vmfmsub_v2df_mask3 */

            case 3:
              if (pattern1408 (x2, 
E_V8HFmode) != 0
                  || !(
#line 6784 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3753; /* *avx512f_vmfmsub_v8hf_maskz_1 */

            case 4:
              if (pattern1408 (x2, 
E_V4SFmode) != 0
                  || !
#line 6784 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 3755; /* *avx512f_vmfmsub_v4sf_maskz_1 */

            case 5:
              if (pattern1408 (x2, 
E_V2DFmode) != 0
                  || !(
#line 6784 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3757; /* *avx512f_vmfmsub_v2df_maskz_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x9;
          switch (pattern916 (x2))
            {
            case 0:
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x13 = XEXP (x7, 0);
              operands[1] = x13;
              if (nonimmediate_operand (operands[3], E_V8HFmode))
                {
                  x10 = XEXP (x4, 1);
                  if (rtx_equal_p (x10, operands[1]))
                    {
                      x11 = XEXP (x2, 1);
                      if (rtx_equal_p (x11, operands[1])
                          && (
#line 6805 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return 3759; /* avx512f_vmfnmadd_v8hf_mask */
                    }
                }
              operands[1] = x8;
              operands[2] = x13;
              if (!nonimmediate_operand (operands[3], E_V8HFmode))
                return -1;
              x10 = XEXP (x4, 1);
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !(
#line 6826 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3765; /* avx512f_vmfnmadd_v8hf_mask3 */

            case 1:
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x13 = XEXP (x7, 0);
              operands[1] = x13;
              if (nonimmediate_operand (operands[3], E_V4SFmode))
                {
                  x10 = XEXP (x4, 1);
                  if (rtx_equal_p (x10, operands[1]))
                    {
                      x11 = XEXP (x2, 1);
                      if (rtx_equal_p (x11, operands[1])
                          && 
#line 6805 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                        return 3761; /* avx512f_vmfnmadd_v4sf_mask */
                    }
                }
              operands[1] = x8;
              operands[2] = x13;
              if (!nonimmediate_operand (operands[3], E_V4SFmode))
                return -1;
              x10 = XEXP (x4, 1);
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !
#line 6826 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 3767; /* avx512f_vmfnmadd_v4sf_mask3 */

            case 2:
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x13 = XEXP (x7, 0);
              operands[1] = x13;
              if (nonimmediate_operand (operands[3], E_V2DFmode))
                {
                  x10 = XEXP (x4, 1);
                  if (rtx_equal_p (x10, operands[1]))
                    {
                      x11 = XEXP (x2, 1);
                      if (rtx_equal_p (x11, operands[1])
                          && (
#line 6805 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return 3763; /* avx512f_vmfnmadd_v2df_mask */
                    }
                }
              operands[1] = x8;
              operands[2] = x13;
              if (!nonimmediate_operand (operands[3], E_V2DFmode))
                return -1;
              x10 = XEXP (x4, 1);
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              x11 = XEXP (x2, 1);
              if (!rtx_equal_p (x11, operands[3])
                  || !(
#line 6826 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3769; /* avx512f_vmfnmadd_v2df_mask3 */

            case 3:
              if (pattern1409 (x2, 
E_V8HFmode) != 0
                  || !(
#line 6859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3771; /* avx512f_vmfnmadd_v8hf_maskz_1 */

            case 4:
              if (pattern1409 (x2, 
E_V4SFmode) != 0
                  || !
#line 6859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 3773; /* avx512f_vmfnmadd_v4sf_maskz_1 */

            case 5:
              if (pattern1409 (x2, 
E_V2DFmode) != 0
                  || !(
#line 6859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3775; /* avx512f_vmfnmadd_v2df_maskz_1 */

            default:
              return -1;
            }

        case NEG:
          x12 = XEXP (x9, 0);
          operands[3] = x12;
          switch (pattern916 (x2))
            {
            case 0:
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (pattern1554 (x2, 
E_V8HFmode) == 0
                  && (
#line 6881 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return 3777; /* *avx512f_vmfnmsub_v8hf_mask */
              operands[1] = x8;
              if (pattern1555 (x2, 
E_V8HFmode) != 0
                  || !(
#line 6903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3783; /* *avx512f_vmfnmsub_v8hf_mask3 */

            case 1:
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (pattern1554 (x2, 
E_V4SFmode) == 0
                  && 
#line 6881 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return 3779; /* *avx512f_vmfnmsub_v4sf_mask */
              operands[1] = x8;
              if (pattern1555 (x2, 
E_V4SFmode) != 0
                  || !
#line 6903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 3785; /* *avx512f_vmfnmsub_v4sf_mask3 */

            case 2:
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (pattern1554 (x2, 
E_V2DFmode) == 0
                  && (
#line 6881 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return 3781; /* *avx512f_vmfnmsub_v2df_mask */
              operands[1] = x8;
              if (pattern1555 (x2, 
E_V2DFmode) != 0
                  || !(
#line 6903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3787; /* *avx512f_vmfnmsub_v2df_mask3 */

            case 3:
              if (pattern1410 (x2, 
E_V8HFmode) != 0
                  || !(
#line 6923 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3789; /* *avx512f_vmfnmsub_v8hf_maskz_1 */

            case 4:
              if (pattern1410 (x2, 
E_V4SFmode) != 0
                  || !
#line 6923 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 3791; /* *avx512f_vmfnmsub_v4sf_maskz_1 */

            case 5:
              if (pattern1410 (x2, 
E_V2DFmode) != 0
                  || !(
#line 6923 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3793; /* *avx512f_vmfnmsub_v2df_maskz_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_HImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V16SImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V16SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V16SImode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 1991; /* avx512f_blendmv16si */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V16SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2015; /* *avx512f_storev16si_mask */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V8SImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V8SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V8SImode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 1992; /* avx512vl_blendmv8si */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V8SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2016; /* *avx512vl_storev8si_mask */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V4SImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V4SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V4SImode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 1993; /* avx512vl_blendmv4si */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2017; /* *avx512vl_storev4si_mask */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V8DImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V8DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V8DImode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 1994; /* avx512f_blendmv8di */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V8DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2018; /* *avx512f_storev8di_mask */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V4DImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V4DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V4DImode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 1995; /* avx512vl_blendmv4di */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2019; /* *avx512vl_storev4di_mask */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V2DImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V2DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V2DImode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 1996; /* avx512vl_blendmv2di */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2020; /* *avx512vl_storev2di_mask */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SFmode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_HImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V16SFmode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V16SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V16SFmode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 1997; /* avx512f_blendmv16sf */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V16SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2021; /* *avx512f_storev16sf_mask */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SFmode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V8SFmode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V8SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V8SFmode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 1998; /* avx512vl_blendmv8sf */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V8SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2022; /* *avx512vl_storev8sf_mask */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V4SFmode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V4SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V4SFmode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 1999; /* avx512vl_blendmv4sf */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2023; /* *avx512vl_storev4sf_mask */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DFmode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V8DFmode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V8DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V8DFmode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 2000; /* avx512f_blendmv8df */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V8DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2024; /* *avx512f_storev8df_mask */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DFmode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V4DFmode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V4DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V4DFmode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 2001; /* avx512vl_blendmv4df */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V4DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2025; /* *avx512vl_storev4df_mask */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V2DFmode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V2DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V2DFmode)
                  && (
#line 1749 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 2002; /* avx512vl_blendmv2df */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2026; /* *avx512vl_storev2df_mask */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_DImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V64QImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V64QImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V64QImode)
                  && (
#line 1780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 2003; /* avx512bw_blendmv64qi */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V64QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2027; /* *avx512bw_storev64qi_mask */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_HImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V16QImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V16QImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V16QImode)
                  && (
#line 1780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 2004; /* avx512vl_blendmv16qi */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2028; /* *avx512vl_storev16qi_mask */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_SImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V32QImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V32QImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V32QImode)
                  && (
#line 1780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 2005; /* avx512vl_blendmv32qi */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V32QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2029; /* *avx512vl_storev32qi_mask */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_SImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V32HImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V32HImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V32HImode)
                  && (
#line 1780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 2006; /* avx512bw_blendmv32hi */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V32HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2030; /* *avx512bw_storev32hi_mask */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_HImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V16HImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V16HImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V16HImode)
                  && (
#line 1780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 2007; /* avx512vl_blendmv16hi */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V16HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2031; /* *avx512vl_storev16hi_mask */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_QImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V8HImode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V8HImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V8HImode)
                  && (
#line 1780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 2008; /* avx512vl_blendmv8hi */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V8HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2032; /* *avx512vl_storev8hi_mask */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HFmode)
        return -1;
      x3 = XEXP (x2, 2);
      if (!register_operand (x3, E_SImode))
        return -1;
      operands[3] = x3;
      if (register_operand (operands[0], E_V32HFmode))
        {
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (nonimmediate_operand (operands[2], E_V32HFmode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (nonimm_or_0_operand (operands[1], E_V32HFmode)
                  && (
#line 1780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 2009; /* avx512bw_blendmv32hf */
            }
        }
      operands[2] = x3;
      if (!memory_operand (operands[0], E_V32HFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V32HFmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 1822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2033; /* *avx512bw_storev32hf_mask */

    case E_V16HFmode:
      return recog_139 (x1, insn, pnum_clobbers);

    case E_V8HFmode:
      return recog_138 (x1, insn, pnum_clobbers);

    case E_V32BFmode:
      return recog_137 (x1, insn, pnum_clobbers);

    case E_V16BFmode:
      return recog_136 (x1, insn, pnum_clobbers);

    case E_V8BFmode:
      return recog_135 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[4] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[5] = x7;
  x8 = XVECEXP (x4, 0, 5);
  operands[7] = x8;
  x9 = XVECEXP (x4, 0, 6);
  operands[8] = x9;
  x10 = XVECEXP (x4, 0, 7);
  operands[9] = x10;
  x11 = XEXP (x2, 1);
  operands[10] = x11;
  x12 = XEXP (x2, 2);
  operands[11] = x12;
  if (!register_operand (operands[11], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode)
          || pattern1661 () != 0
          || !nonimm_or_0_operand (operands[10], E_V8DFmode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 1) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && (INTVAL (operands[4]) & 1) == 0
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1
   && (INTVAL (operands[6]) & 1) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && (INTVAL (operands[8]) & 1) == 0
   && INTVAL (operands[8]) == INTVAL (operands[9]) - 1) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7838; /* *avx512f_shuf_f64x2_1_mask_1 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x2) != E_V8DImode
          || GET_MODE (x3) != E_V8DImode
          || !nonimm_or_0_operand (operands[10], E_V8DImode))
        return -1;
      if (register_operand (operands[1], E_V8DImode)
          && pattern1661 () == 0
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 1) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && (INTVAL (operands[4]) & 1) == 0
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1
   && (INTVAL (operands[6]) & 1) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && (INTVAL (operands[8]) & 1) == 0
   && INTVAL (operands[8]) == INTVAL (operands[9]) - 1) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7840; /* *avx512f_shuf_i64x2_1_mask_1 */
      if (!nonimmediate_operand (operands[1], E_V8DImode)
          || pattern1662 () != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL)
   && (INTVAL (operands[2]) == (INTVAL (operands[6]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4))) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8543; /* avx512f_permv8di_1_mask */

    case E_V8SImode:
      if (pattern1413 (x2, 
E_V8SImode) != 0
          || pattern1662 () != 0
          || !nonimm_or_0_operand (operands[10], E_V8SImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20641 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2
   && TARGET_AVX512VL
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9]))))
        return -1;
      return 7856; /* avx2_pshufd_1_mask */

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      x9 = XEXP (x2, 2);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern1020 (x2, 
E_HImode, 
E_V16QImode, 
E_V8HImode, 
E_V8QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19225 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7718; /* sse2_packsswb_mask */

        case E_V8HImode:
          if (pattern1020 (x2, 
E_QImode, 
E_V8HImode, 
E_V4SImode, 
E_V4HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19319 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7724; /* sse2_packssdw_mask */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != VEC_SELECT)
        return -1;
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != PARALLEL)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      x9 = XEXP (x2, 2);
      operands[4] = x9;
      switch (XVECLEN (x10, 0))
        {
        case 8:
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x12 = XVECEXP (x10, 0, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
            return -1;
          x13 = XVECEXP (x10, 0, 2);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 10]
              || pattern1301 (x10, 
15, 
14, 
13, 
12, 
11) != 0
              || !register_operand (operands[4], E_HImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1383 (x2, 
E_V16SFmode, 
E_V8SFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7814; /* vec_set_lo_v16sf_mask */

            case E_V16SImode:
              if (pattern1383 (x2, 
E_V16SImode, 
E_V8SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7816; /* vec_set_lo_v16si_mask */

            default:
              return -1;
            }

        case 4:
          if (pattern1111 (x10, 
7, 
6, 
5, 
4) != 0
              || !register_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1383 (x2, 
E_V8DFmode, 
E_V4DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20140 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7822; /* vec_set_lo_v8df_mask */

            case E_V8DImode:
              if (pattern1383 (x2, 
E_V8DImode, 
E_V4DImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20140 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7824; /* vec_set_lo_v8di_mask */

            case E_V8SImode:
              if (pattern1383 (x2, 
E_V8SImode, 
E_V4SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28494 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8837; /* vec_set_lo_v8si_mask */

            case E_V8SFmode:
              if (pattern1383 (x2, 
E_V8SFmode, 
E_V4SFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28494 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8839; /* vec_set_lo_v8sf_mask */

            default:
              return -1;
            }

        case 2:
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x12 = XVECEXP (x10, 0, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || !register_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern1383 (x2, 
E_V4DImode, 
E_V2DImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28445 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512DQ)))
                return -1;
              return 8829; /* vec_set_lo_v4di_mask */

            case E_V4DFmode:
              if (pattern1383 (x2, 
E_V4DFmode, 
E_V2DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28445 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512DQ)))
                return -1;
              return 8831; /* vec_set_lo_v4df_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      x9 = XEXP (x2, 2);
      operands[4] = x9;
      switch (XVECLEN (x14, 0))
        {
        case 8:
          if (pattern577 (x14) != 0)
            return -1;
          x15 = XVECEXP (x14, 0, 4);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x16 = XVECEXP (x14, 0, 5);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x17 = XVECEXP (x14, 0, 6);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x18 = XVECEXP (x14, 0, 7);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[4], E_HImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1347 (x2, 
E_V16SFmode, 
E_V8SFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7818; /* vec_set_hi_v16sf_mask */

            case E_V16SImode:
              if (pattern1347 (x2, 
E_V16SImode, 
E_V8SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7820; /* vec_set_hi_v16si_mask */

            default:
              return -1;
            }

        case 4:
          if (pattern577 (x14) != 0
              || !register_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1347 (x2, 
E_V8DFmode, 
E_V4DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7826; /* vec_set_hi_v8df_mask */

            case E_V8DImode:
              if (pattern1347 (x2, 
E_V8DImode, 
E_V4DImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7828; /* vec_set_hi_v8di_mask */

            case E_V8SImode:
              if (pattern1347 (x2, 
E_V8SImode, 
E_V4SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28517 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8841; /* vec_set_hi_v8si_mask */

            case E_V8SFmode:
              if (pattern1347 (x2, 
E_V8SFmode, 
E_V4SFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28517 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8843; /* vec_set_hi_v8sf_mask */

            default:
              return -1;
            }

        case 2:
          x19 = XVECEXP (x14, 0, 0);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x14, 0, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern1347 (x2, 
E_V4DImode, 
E_V2DImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28469 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512DQ)))
                return -1;
              return 8833; /* vec_set_hi_v4di_mask */

            case E_V4DFmode:
              if (pattern1347 (x2, 
E_V4DFmode, 
E_V2DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28469 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512DQ)))
                return -1;
              return 8835; /* vec_set_hi_v4df_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 150
          || GET_MODE (x4) != E_V4HImode
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      x21 = XVECEXP (x4, 0, 0);
      operands[1] = x21;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x22 = XVECEXP (x4, 0, 1);
      operands[2] = x22;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const0_operand (operands[3], E_V4HImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      if (!nonimm_or_0_operand (operands[4], E_V8HImode))
        return -1;
      x9 = XEXP (x2, 2);
      operands[5] = x9;
      if (!register_operand (operands[5], E_QImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29158 "../../../gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL) && TARGET_AVX512VL)))
        return -1;
      return 9026; /* *vcvtps2ph_mask */

    case FLOAT_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      x9 = XEXP (x2, 2);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern1022 (x2, 
E_SImode, 
E_V32BFmode, 
E_V16SFmode, 
E_V16BFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9697; /* avx512f_cvtne2ps2bf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern1022 (x2, 
E_HImode, 
E_V16BFmode, 
E_V8SFmode, 
E_V8BFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9699; /* avx512f_cvtne2ps2bf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern1022 (x2, 
E_QImode, 
E_V8BFmode, 
E_V4SFmode, 
E_V4BFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9701; /* avx512f_cvtne2ps2bf16_v8bf_mask */

        case E_V32HFmode:
          if (pattern1023 (x2, 
E_SImode, 
E_V32HFmode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 9797; /* avx10_2_cvt2ps2phx_v32hf_mask */

        case E_V16HFmode:
          if (pattern1023 (x2, 
E_HImode, 
E_V16HFmode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1)))
            return -1;
          return 9801; /* avx10_2_cvt2ps2phx_v16hf_mask */

        case E_V8HFmode:
          if (pattern1023 (x2, 
E_QImode, 
E_V8HFmode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1)))
            return -1;
          return 9804; /* avx10_2_cvt2ps2phx_v8hf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern712 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4171; /* avx512fp16_float_extend_phv8df2_mask */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 10234 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 4609; /* avx512f_cvtps2pd512_mask */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern713 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16HFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4175; /* avx512fp16_float_extend_phv16sf2_mask */

        case E_V8SFmode:
          if (pattern713 (x2, 
E_V8SFmode, 
E_QImode, 
E_V8HFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4179; /* avx512fp16_float_extend_phv8sf2_mask */

        case E_V4DFmode:
          if (pattern712 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!memory_operand (operands[1], E_V4HFmode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8070 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4188; /* *avx512fp16_float_extend_phv4df2_load_mask */

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10234 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL) && 1)))
                return -1;
              return 4613; /* avx_cvtps2pd256_mask */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern140 (x2, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8070 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4190; /* *avx512fp16_float_extend_phv4sf2_load_mask */

        case E_V2DFmode:
          if (pattern712 (x2, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2HFmode:
              if (!memory_operand (operands[1], E_V2HFmode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8109 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4194; /* *avx512fp16_float_extend_phv2df2_load_mask */

            case E_V2SFmode:
              if (!memory_operand (operands[1], E_V2SFmode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10416 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
                return -1;
              return 4662; /* sse2_cvtps2pd_mask_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PARALLEL)
        return -1;
      switch (XVECLEN (x7, 0))
        {
        case 4:
          if (pattern577 (x7) != 0
              || GET_MODE (x4) != E_V4HFmode)
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          x6 = XEXP (x2, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DFmode:
              if (pattern127 (x2, 
E_V4DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8060 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1)))
                return -1;
              return 4183; /* avx512fp16_float_extend_phv4df2_mask */

            case E_V4SFmode:
              if (pattern127 (x2, 
E_V4SFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8060 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1)))
                return -1;
              return 4186; /* avx512fp16_float_extend_phv4sf2_mask */

            default:
              return -1;
            }

        case 2:
          x9 = XVECEXP (x7, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x7, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          x6 = XEXP (x2, 2);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[3] = x6;
              if (!register_operand (operands[3], E_QImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!nonimm_or_0_operand (operands[2], E_V2DFmode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V2HFmode:
                  if (!register_operand (operands[1], E_V8HFmode)
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8099 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 4192; /* avx512fp16_float_extend_phv2df2_mask */

                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10402 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
                    return -1;
                  return 4660; /* sse2_cvtps2pd_mask */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x6, 0) != 1LL
                  || GET_MODE (x4) != E_V2SFmode)
                return -1;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!nonimmediate_operand (operands[2], E_V4SFmode))
                return -1;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 10060 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 4591; /* sse2_cvtss2sd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern125 (x2))
    {
    case 0:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 2475; /* *sminv32hf3_mask */

    case 1:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2483; /* *sminv16hf3_mask */

    case 2:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2488; /* *sminv8hf3_mask */

    case 3:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 2495; /* *sminv16sf3_mask */

    case 4:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 2503; /* *sminv8sf3_mask */

    case 5:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
        return -1;
      return 2508; /* *sminv4sf3_mask */

    case 6:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 2515; /* *sminv8df3_mask */

    case 7:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 2523; /* *sminv4df3_mask */

    case 8:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 2528; /* *sminv2df3_mask */

    case 9:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7189; /* *avx512f_sminv16si3_mask */

    case 10:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7197; /* *avx512f_sminv8si3_mask */

    case 11:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7205; /* *avx512f_sminv4si3_mask */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17824 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7289; /* *sse4_1_sminv4si3_mask */

    case 12:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7213; /* *avx512f_sminv8di3_mask */

    case 13:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7221; /* *avx512f_sminv4di3_mask */

    case 14:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7229; /* *avx512f_sminv2di3_mask */

    case 15:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7237; /* *avx512bw_sminv64qi3_mask */

    case 16:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7245; /* *avx512bw_sminv16qi3_mask */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17824 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7285; /* *sse4_1_sminv16qi3_mask */

    case 17:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7253; /* *avx512bw_sminv32qi3_mask */

    case 18:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7261; /* *avx512bw_sminv32hi3_mask */

    case 19:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7269; /* *avx512bw_sminv16hi3_mask */

    case 20:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7277; /* *avx512bw_sminv8hi3_mask */

    case 21:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32113 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 9955; /* avx10_2_sminbf16_v32bf_mask */

    case 22:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32113 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 9959; /* avx10_2_sminbf16_v16bf_mask */

    case 23:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32113 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 9963; /* avx10_2_sminbf16_v8bf_mask */

    case 24:
      if (!(
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 2612; /* *avx512fp16_vmsminv8hf3 */

    case 25:
      if (!
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 2620; /* *sse_vmsminv4sf3 */

    case 26:
      if (!(
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2628; /* *sse2_vmsminv2df3 */

    default:
      return -1;
    }
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4031; /* unspec_avx512fp16_fix_truncv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4035; /* unspec_avx512fp16_fix_truncv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4043; /* unspec_avx512fp16_fix_truncv32hi2 */

    case E_V8SImode:
      switch (pattern578 (x2))
        {
        case 0:
          if (!(
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4051; /* unspec_avx512fp16_fix_truncv8si2 */

        case 1:
          if (!
#line 8796 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
  && (!false || TARGET_AVX10_2_256)))
            return -1;
          return 4333; /* unspec_fix_truncv8sfv8si2 */

        case 2:
          if (!
#line 9571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4446; /* unspec_fix_truncv8dfv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern579 (x2, 
E_V16SImode))
        {
        case 0:
          if (!(
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4059; /* unspec_avx512fp16_fix_truncv16si2 */

        case 1:
          if (!
#line 8776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4317; /* unspec_fix_truncv16sfv16si2 */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern580 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4067; /* unspec_avx512fp16_fix_truncv8di2 */

        case 1:
          if (!(
#line 9702 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4479; /* unspec_fix_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4539; /* unspec_fix_truncv8sfv8di2 */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !
#line 7906 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
            return -1;
          return 4119; /* unspec_avx512fp16_fix_truncv4si2 */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8816 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4339; /* unspec_fix_truncv4sfv4si2 */

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode)
              || !
#line 9661 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && (!false || TARGET_AVX10_2_256)))
            return -1;
          return 4467; /* unspec_fix_truncv4dfv4si2 */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !
#line 9945 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4581; /* unspec_sse2_cvttpd2dq */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern581 (x2, 
E_V4DImode))
        {
        case 0:
          if (!
#line 7906 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
            return -1;
          return 4123; /* unspec_avx512fp16_fix_truncv4di2 */

        case 1:
          if (!(
#line 9702 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4487; /* unspec_fix_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4547; /* unspec_fix_truncv4sfv4di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern582 (x2))
        {
        case 0:
          if (!
#line 7956 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4147; /* unspec_avx512fp16_fix_truncv2di2 */

        case 1:
          if (!(
#line 9702 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4495; /* unspec_fix_truncv2dfv2di2 */

        case 2:
          if (!
#line 9766 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4563; /* unspec_avx512dq_fix_truncv2sfv2di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 1);
  if (!const_4_or_8_to_11_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      switch (pattern1031 (x2))
        {
        case 0:
          if (pattern1454 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 5927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 3284; /* fma_fmadd_v32hf_maskz_1_round */

        case 1:
          if (pattern1454 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 5928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 3288; /* fma_fmadd_v16hf_maskz_1_round */

        case 2:
          if (pattern1454 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 5931 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3296; /* fma_fmadd_v16sf_maskz_1_round */

        case 3:
          if (pattern1454 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 5932 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3300; /* fma_fmadd_v8sf_maskz_1_round */

        case 4:
          if (pattern1454 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 5933 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3307; /* fma_fmadd_v8df_maskz_1_round */

        case 5:
          if (pattern1454 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3311; /* fma_fmadd_v4df_maskz_1_round */

        case 6:
          if (pattern1455 (x2, 
E_V32HFmode, 
E_SImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V32HFmode)
              && register_operand (operands[3], E_V32HFmode))
            {
              x8 = XEXP (x3, 1);
              if (rtx_equal_p (x8, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return 3315; /* avx512bw_fmadd_v32hf_mask_round */
            }
          if (!register_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[3], E_V32HFmode))
            return -1;
          x8 = XEXP (x3, 1);
          if (!rtx_equal_p (x8, operands[3])
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 3330; /* avx512bw_fmadd_v32hf_mask3_round */

        case 7:
          if (pattern1455 (x2, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16HFmode)
              && register_operand (operands[3], E_V16HFmode))
            {
              x8 = XEXP (x3, 1);
              if (rtx_equal_p (x8, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return 3317; /* avx512vl_fmadd_v16hf_mask_round */
            }
          if (!register_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[3], E_V16HFmode))
            return -1;
          x8 = XEXP (x3, 1);
          if (!rtx_equal_p (x8, operands[3])
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 3332; /* avx512vl_fmadd_v16hf_mask3_round */

        case 8:
          if (pattern1455 (x2, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16SFmode)
              && register_operand (operands[3], E_V16SFmode))
            {
              x8 = XEXP (x3, 1);
              if (rtx_equal_p (x8, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 3320; /* avx512f_fmadd_v16sf_mask_round */
            }
          if (!register_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[3], E_V16SFmode))
            return -1;
          x8 = XEXP (x3, 1);
          if (!rtx_equal_p (x8, operands[3])
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3335; /* avx512f_fmadd_v16sf_mask3_round */

        case 9:
          if (pattern1455 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && register_operand (operands[3], E_V8SFmode))
            {
              x8 = XEXP (x3, 1);
              if (rtx_equal_p (x8, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3322; /* avx512vl_fmadd_v8sf_mask_round */
            }
          if (!register_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[3], E_V8SFmode))
            return -1;
          x8 = XEXP (x3, 1);
          if (!rtx_equal_p (x8, operands[3])
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3337; /* avx512vl_fmadd_v8sf_mask3_round */

        case 10:
          if (pattern1455 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8DFmode)
              && register_operand (operands[3], E_V8DFmode))
            {
              x8 = XEXP (x3, 1);
              if (rtx_equal_p (x8, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 3325; /* avx512f_fmadd_v8df_mask_round */
            }
          if (!register_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[3], E_V8DFmode))
            return -1;
          x8 = XEXP (x3, 1);
          if (!rtx_equal_p (x8, operands[3])
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3340; /* avx512f_fmadd_v8df_mask3_round */

        case 11:
          if (pattern1455 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && register_operand (operands[3], E_V4DFmode))
            {
              x8 = XEXP (x3, 1);
              if (rtx_equal_p (x8, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3327; /* avx512vl_fmadd_v4df_mask_round */
            }
          if (!register_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[3], E_V4DFmode))
            return -1;
          x8 = XEXP (x3, 1);
          if (!rtx_equal_p (x8, operands[3])
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3342; /* avx512vl_fmadd_v4df_mask3_round */

        case 12:
          if (pattern1508 (x2, 
E_V8HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6596 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3700; /* *fmai_fmadd_v8hf */

        case 13:
          if (pattern1508 (x2, 
E_V4SFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6596 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F)))
            return -1;
          return 3702; /* *fmai_fmadd_v4sf */

        case 14:
          if (pattern1508 (x2, 
E_V2DFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6596 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3704; /* *fmai_fmadd_v2df */

        case 15:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[4] = x8;
              x9 = XEXP (x3, 2);
              operands[5] = x9;
              operands[6] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1457 (x2, 
E_V32HFmode, 
E_SImode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6045 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 5927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 3353; /* fma_fmsub_v32hf_maskz_1_round */

                case E_V16HFmode:
                  if (pattern1457 (x2, 
E_V16HFmode, 
E_HImode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6045 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 5928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                    return -1;
                  return 3357; /* fma_fmsub_v16hf_maskz_1_round */

                case E_V16SFmode:
                  if (pattern1457 (x2, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6045 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 5931 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3365; /* fma_fmsub_v16sf_maskz_1_round */

                case E_V8SFmode:
                  if (pattern1457 (x2, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6045 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 5932 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3369; /* fma_fmsub_v8sf_maskz_1_round */

                case E_V8DFmode:
                  if (pattern1457 (x2, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6045 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 5933 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3376; /* fma_fmsub_v8df_maskz_1_round */

                case E_V4DFmode:
                  if (pattern1457 (x2, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6045 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3380; /* fma_fmsub_v4df_maskz_1_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              switch (pattern1030 (x2))
                {
                case 0:
                  if (pattern1458 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V32HFmode)
                      && register_operand (operands[3], E_V32HFmode)
                      && rtx_equal_p (x8, operands[1])
                      && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return 3384; /* avx512bw_fmsub_v32hf_mask_round */
                  if (!register_operand (operands[1], E_V32HFmode)
                      || !nonimmediate_operand (operands[3], E_V32HFmode)
                      || !rtx_equal_p (x8, operands[3])
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6106 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 3399; /* avx512bw_fmsub_v32hf_mask3_round */

                case 1:
                  if (pattern1458 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V16HFmode)
                      && register_operand (operands[3], E_V16HFmode)
                      && rtx_equal_p (x8, operands[1])
                      && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                    return 3386; /* avx512vl_fmsub_v16hf_mask_round */
                  if (!register_operand (operands[1], E_V16HFmode)
                      || !nonimmediate_operand (operands[3], E_V16HFmode)
                      || !rtx_equal_p (x8, operands[3])
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6106 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                    return -1;
                  return 3401; /* avx512vl_fmsub_v16hf_mask3_round */

                case 2:
                  if (pattern1458 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V16SFmode)
                      && register_operand (operands[3], E_V16SFmode)
                      && rtx_equal_p (x8, operands[1])
                      && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return 3389; /* avx512f_fmsub_v16sf_mask_round */
                  if (!register_operand (operands[1], E_V16SFmode)
                      || !nonimmediate_operand (operands[3], E_V16SFmode)
                      || !rtx_equal_p (x8, operands[3])
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6106 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3404; /* avx512f_fmsub_v16sf_mask3_round */

                case 3:
                  if (pattern1458 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V8SFmode)
                      && register_operand (operands[3], E_V8SFmode)
                      && rtx_equal_p (x8, operands[1])
                      && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return 3391; /* avx512vl_fmsub_v8sf_mask_round */
                  if (!register_operand (operands[1], E_V8SFmode)
                      || !nonimmediate_operand (operands[3], E_V8SFmode)
                      || !rtx_equal_p (x8, operands[3])
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6106 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3406; /* avx512vl_fmsub_v8sf_mask3_round */

                case 4:
                  if (pattern1458 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V8DFmode)
                      && register_operand (operands[3], E_V8DFmode)
                      && rtx_equal_p (x8, operands[1])
                      && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return 3394; /* avx512f_fmsub_v8df_mask_round */
                  if (!register_operand (operands[1], E_V8DFmode)
                      || !nonimmediate_operand (operands[3], E_V8DFmode)
                      || !rtx_equal_p (x8, operands[3])
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6106 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3409; /* avx512f_fmsub_v8df_mask3_round */

                case 5:
                  if (pattern1458 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V4DFmode)
                      && register_operand (operands[3], E_V4DFmode)
                      && rtx_equal_p (x8, operands[1])
                      && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return 3396; /* avx512vl_fmsub_v4df_mask_round */
                  if (!register_operand (operands[1], E_V4DFmode)
                      || !nonimmediate_operand (operands[3], E_V4DFmode)
                      || !rtx_equal_p (x8, operands[3])
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6106 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3411; /* avx512vl_fmsub_v4df_mask3_round */

                case 6:
                  if (pattern1509 (x2, 
E_V8HFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6614 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3706; /* *fmai_fmsub_v8hf */

                case 7:
                  if (pattern1509 (x2, 
E_V4SFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6614 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F)))
                    return -1;
                  return 3708; /* *fmai_fmsub_v4sf */

                case 8:
                  if (pattern1509 (x2, 
E_V2DFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6614 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 3710; /* *fmai_fmsub_v2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_206 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern720 (x3, 
E_V32HFmode) != 0
          || !(
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 6562; /* avx512bw_rndscalev32hf */

    case E_V16HFmode:
      if (pattern720 (x3, 
E_V16HFmode) != 0
          || !(
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 6566; /* avx512vl_rndscalev16hf */

    case E_V8HFmode:
      if (pattern720 (x3, 
E_V8HFmode) != 0
          || !(
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 6570; /* avx512fp16_rndscalev8hf */

    case E_V16SFmode:
      if (pattern720 (x3, 
E_V16SFmode) != 0
          || !(
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6572; /* avx512f_rndscalev16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6576; /* avx512vl_rndscalev8sf */
      if (!vector_operand (operands[1], E_V8SFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8334; /* avx_roundps256 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6580; /* avx512vl_rndscalev4sf */
      if (!vector_operand (operands[1], E_V4SFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !
#line 25489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return -1;
      return 8335; /* sse4_1_roundps */

    case E_V8DFmode:
      if (pattern720 (x3, 
E_V8DFmode) != 0
          || !(
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6582; /* avx512f_rndscalev8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6586; /* avx512vl_rndscalev4df */
      if (!vector_operand (operands[1], E_V4DFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8336; /* avx_roundpd256 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6590; /* avx512vl_rndscalev2df */
      if (!vector_operand (operands[1], E_V2DFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25489 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 8337; /* sse4_1_roundpd */

    default:
      return -1;
    }
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_15_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !nonimmediate_operand (operands[1], E_V32HFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 9378; /* avx512bw_getmantv32hf */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !nonimmediate_operand (operands[1], E_V16HFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 9382; /* avx512vl_getmantv16hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 9386; /* avx512fp16_getmantv8hf */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9388; /* avx512f_getmantv16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9392; /* avx512vl_getmantv8sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9396; /* avx512vl_getmantv4sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9398; /* avx512f_getmantv8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9402; /* avx512vl_getmantv4df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode)
          || !(
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9406; /* avx512vl_getmantv2df */

    default:
      return -1;
    }
}

 int
recog_224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (register_operand (operands[0], E_QImode)
          && register_operand (operands[1], E_QImode)
          && (
#line 2346 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
        return 2098; /* *kortestqi */
      break;

    case E_HImode:
      if (register_operand (operands[0], E_HImode)
          && register_operand (operands[1], E_HImode)
          && 
#line 2346 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
        return 2099; /* *kortesthi */
      break;

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_SImode)
          && (
#line 2346 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 2100; /* *kortestsi */
      break;

    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 2346 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 2101; /* *kortestdi */
      break;

    default:
      break;
    }
  switch (GET_MODE (x2))
    {
    case E_CCCmode:
      if (GET_MODE (x3) != E_CCCmode)
        return -1;
      switch (pattern885 ())
        {
        case 0:
          if (!(
#line 2358 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return -1;
          return 2102; /* kortestqi_ccc */

        case 1:
          if (!
#line 2358 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2103; /* kortesthi_ccc */

        case 2:
          if (!(
#line 2358 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2104; /* kortestsi_ccc */

        case 3:
          if (!(
#line 2358 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2105; /* kortestdi_ccc */

        default:
          return -1;
        }

    case E_CCZmode:
      if (GET_MODE (x3) != E_CCZmode)
        return -1;
      switch (pattern885 ())
        {
        case 0:
          if (!(
#line 2366 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return -1;
          return 2106; /* kortestqi_ccz */

        case 1:
          if (!
#line 2366 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2107; /* kortesthi_ccz */

        case 2:
          if (!(
#line 2366 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2108; /* kortestsi_ccz */

        case 3:
          if (!(
#line 2366 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2109; /* kortestdi_ccz */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      if (register_operand (operands[0], E_V8HImode)
          && 
#line 29180 "../../../gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
        return 9028; /* vcvtps2ph256 */
      if (!memory_operand (operands[0], E_V8HImode)
          || !
#line 29192 "../../../gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
        return -1;
      return 9030; /* *vcvtps2ph256 */

    case E_V16HImode:
      if (GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      if (register_operand (operands[0], E_V16HImode)
          && 
#line 29231 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return 9032; /* *avx512f_vcvtps2ph512 */
      if (!memory_operand (operands[0], E_V16HImode)
          || !
#line 29243 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 9036; /* *avx512f_vcvtps2ph512 */

    default:
      return -1;
    }
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 154)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x4, 0, 2);
  if (!const1248_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XVECEXP (x2, 0, 1);
      operands[7] = x8;
      operands[6] = x3;
      x9 = XVECEXP (x4, 0, 0);
      operands[4] = x9;
      x10 = XVECEXP (x4, 0, 1);
      operands[3] = x10;
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || !vsib_mem_operator (operands[6], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !register_operand (operands[7], E_HImode))
                return -1;
              switch (pattern1639 (x4, 
E_V16SImode))
                {
                case 0:
                  if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9110; /* *avx512f_gathersiv16si */

                case 1:
                  if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9122; /* *avx512f_gathersiv16si */

                default:
                  return -1;
                }

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !register_operand (operands[7], E_QImode))
                return -1;
              switch (pattern1639 (x4, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9158; /* *avx512f_gatherdiv16si */

                case 1:
                  if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9170; /* *avx512f_gatherdiv16si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x2) != E_V16SFmode
              || !vsib_mem_operator (operands[6], E_SFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !register_operand (operands[7], E_HImode))
                return -1;
              switch (pattern1639 (x4, 
E_V16SImode))
                {
                case 0:
                  if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9111; /* *avx512f_gathersiv16sf */

                case 1:
                  if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9123; /* *avx512f_gathersiv16sf */

                default:
                  return -1;
                }

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !register_operand (operands[7], E_QImode))
                return -1;
              switch (pattern1639 (x4, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9159; /* *avx512f_gatherdiv16sf */

                case 1:
                  if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9171; /* *avx512f_gatherdiv16sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1513 (x2, 
E_DImode, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9112; /* *avx512f_gathersiv8di */

            case 1:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9160; /* *avx512f_gatherdiv8di */

            case 2:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9124; /* *avx512f_gathersiv8di */

            case 3:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9172; /* *avx512f_gatherdiv8di */

            default:
              return -1;
            }

        case E_V8DFmode:
          switch (pattern1513 (x2, 
E_DFmode, 
E_V8DFmode))
            {
            case 0:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9113; /* *avx512f_gathersiv8df */

            case 1:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9161; /* *avx512f_gatherdiv8df */

            case 2:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9125; /* *avx512f_gathersiv8df */

            case 3:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9173; /* *avx512f_gatherdiv8df */

            default:
              return -1;
            }

        case E_V8SImode:
          if (pattern1514 (x2, 
E_SImode, 
E_V8SImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode))
                return -1;
              switch (pattern1639 (x4, 
E_V8SImode))
                {
                case 0:
                  if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9114; /* *avx512f_gathersiv8si */

                case 1:
                  if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9126; /* *avx512f_gathersiv8si */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode))
                return -1;
              switch (pattern1639 (x4, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9162; /* *avx512f_gatherdiv8si */

                case 1:
                  if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9174; /* *avx512f_gatherdiv8si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V8SFmode:
          if (pattern1514 (x2, 
E_SFmode, 
E_V8SFmode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode))
                return -1;
              switch (pattern1639 (x4, 
E_V8SImode))
                {
                case 0:
                  if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9115; /* *avx512f_gathersiv8sf */

                case 1:
                  if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9127; /* *avx512f_gathersiv8sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode))
                return -1;
              switch (pattern1639 (x4, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9163; /* *avx512f_gatherdiv8sf */

                case 1:
                  if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9175; /* *avx512f_gatherdiv8sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1516 (x2, 
E_DImode, 
E_V4DImode))
            {
            case 0:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9116; /* *avx512f_gathersiv4di */

            case 1:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9164; /* *avx512f_gatherdiv4di */

            case 2:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9128; /* *avx512f_gathersiv4di */

            case 3:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9176; /* *avx512f_gatherdiv4di */

            default:
              return -1;
            }

        case E_V4DFmode:
          switch (pattern1516 (x2, 
E_DFmode, 
E_V4DFmode))
            {
            case 0:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9117; /* *avx512f_gathersiv4df */

            case 1:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9165; /* *avx512f_gatherdiv4df */

            case 2:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9129; /* *avx512f_gathersiv4df */

            case 3:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9177; /* *avx512f_gatherdiv4df */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern1518 (x2, 
E_SImode, 
E_V4SImode))
            {
            case 0:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9118; /* *avx512f_gathersiv4si */

            case 1:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9166; /* *avx512f_gatherdiv4si */

            case 2:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9130; /* *avx512f_gathersiv4si */

            case 3:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9178; /* *avx512f_gatherdiv4si */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1518 (x2, 
E_SFmode, 
E_V4SFmode))
            {
            case 0:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9119; /* *avx512f_gathersiv4sf */

            case 1:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9167; /* *avx512f_gatherdiv4sf */

            case 2:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9131; /* *avx512f_gathersiv4sf */

            case 3:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9179; /* *avx512f_gatherdiv4sf */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern1518 (x2, 
E_DImode, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9120; /* *avx512f_gathersiv2di */

            case 1:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9168; /* *avx512f_gatherdiv2di */

            case 2:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9132; /* *avx512f_gathersiv2di */

            case 3:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9180; /* *avx512f_gatherdiv2di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern1518 (x2, 
E_DFmode, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9121; /* *avx512f_gathersiv2df */

            case 1:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9169; /* *avx512f_gatherdiv2df */

            case 2:
              if (!(
#line 29480 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9133; /* *avx512f_gathersiv2df */

            case 3:
              if (!(
#line 29542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9181; /* *avx512f_gatherdiv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PC:
      x8 = XVECEXP (x2, 0, 1);
      operands[6] = x8;
      operands[5] = x3;
      x9 = XVECEXP (x4, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x4, 0, 1);
      operands[2] = x10;
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          switch (pattern1473 (x2, 
E_SImode, 
E_V16SImode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9134; /* *avx512f_gathersiv16si_2 */

            case 1:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9146; /* *avx512f_gathersiv16si_2 */

            case 2:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9182; /* *avx512f_gatherdiv16si_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9194; /* *avx512f_gatherdiv16si_2 */

            default:
              return -1;
            }

        case E_V16SFmode:
          switch (pattern1473 (x2, 
E_SFmode, 
E_V16SFmode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9135; /* *avx512f_gathersiv16sf_2 */

            case 1:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9147; /* *avx512f_gathersiv16sf_2 */

            case 2:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9183; /* *avx512f_gatherdiv16sf_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9195; /* *avx512f_gatherdiv16sf_2 */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1475 (x2, 
E_DImode, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9136; /* *avx512f_gathersiv8di_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9184; /* *avx512f_gatherdiv8di_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9148; /* *avx512f_gathersiv8di_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9196; /* *avx512f_gatherdiv8di_2 */

            default:
              return -1;
            }

        case E_V8DFmode:
          switch (pattern1475 (x2, 
E_DFmode, 
E_V8DFmode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9137; /* *avx512f_gathersiv8df_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9185; /* *avx512f_gatherdiv8df_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9149; /* *avx512f_gathersiv8df_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9197; /* *avx512f_gatherdiv8df_2 */

            default:
              return -1;
            }

        case E_V8SImode:
          switch (pattern1477 (x2, 
E_SImode, 
E_V8SImode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9138; /* *avx512f_gathersiv8si_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9186; /* *avx512f_gatherdiv8si_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9150; /* *avx512f_gathersiv8si_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9198; /* *avx512f_gatherdiv8si_2 */

            default:
              return -1;
            }

        case E_V8SFmode:
          switch (pattern1477 (x2, 
E_SFmode, 
E_V8SFmode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9139; /* *avx512f_gathersiv8sf_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9187; /* *avx512f_gatherdiv8sf_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9151; /* *avx512f_gathersiv8sf_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9199; /* *avx512f_gatherdiv8sf_2 */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1479 (x2, 
E_DImode, 
E_V4DImode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9140; /* *avx512f_gathersiv4di_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9188; /* *avx512f_gatherdiv4di_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9152; /* *avx512f_gathersiv4di_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9200; /* *avx512f_gatherdiv4di_2 */

            default:
              return -1;
            }

        case E_V4DFmode:
          switch (pattern1479 (x2, 
E_DFmode, 
E_V4DFmode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9141; /* *avx512f_gathersiv4df_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9189; /* *avx512f_gatherdiv4df_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9153; /* *avx512f_gathersiv4df_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9201; /* *avx512f_gatherdiv4df_2 */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern1481 (x2, 
E_SImode, 
E_V4SImode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9142; /* *avx512f_gathersiv4si_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9190; /* *avx512f_gatherdiv4si_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9154; /* *avx512f_gathersiv4si_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9202; /* *avx512f_gatherdiv4si_2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1481 (x2, 
E_SFmode, 
E_V4SFmode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9143; /* *avx512f_gathersiv4sf_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9191; /* *avx512f_gatherdiv4sf_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9155; /* *avx512f_gathersiv4sf_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9203; /* *avx512f_gatherdiv4sf_2 */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern1481 (x2, 
E_DImode, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9144; /* *avx512f_gathersiv2di_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9192; /* *avx512f_gatherdiv2di_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9156; /* *avx512f_gathersiv2di_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9204; /* *avx512f_gatherdiv2di_2 */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern1481 (x2, 
E_DFmode, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9145; /* *avx512f_gathersiv2df_2 */

            case 1:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9193; /* *avx512f_gatherdiv2df_2 */

            case 2:
              if (!(
#line 29501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9157; /* *avx512f_gathersiv2df_2 */

            case 3:
              if (!(
#line 29563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return -1;
              *pnum_clobbers = 1;
              return 9205; /* *avx512f_gatherdiv2df_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern851 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 0LL:
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 1LL:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 2LL)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 3LL)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 8LL)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 9LL)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 10LL)
            return -1;
          x11 = XVECEXP (x3, 0, 7);
          if (XWINT (x11, 0) != 11LL)
            return -1;
          x12 = XEXP (x2, 0);
          x13 = XEXP (x12, 1);
          operands[2] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern1361 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                  || !
#line 11140 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (UNKNOWN, V8HImode, operands)))
                return -1;
              return 4665; /* sse_movlhps_v8hi */

            case E_V8HFmode:
              if (pattern1361 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
                  || !
#line 11140 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (UNKNOWN, V8HFmode, operands)))
                return -1;
              return 4666; /* sse_movlhps_v8hf */

            case E_V8BFmode:
              if (pattern1361 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
                  || !
#line 11140 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (UNKNOWN, V8BFmode, operands)))
                return -1;
              return 4667; /* sse_movlhps_v8bf */

            default:
              return -1;
            }

        case 8LL:
          x6 = XVECEXP (x3, 0, 2);
          switch (XWINT (x6, 0))
            {
            case 1LL:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 9LL)
                return -1;
              x12 = XEXP (x2, 0);
              x13 = XEXP (x12, 1);
              operands[2] = x13;
              x8 = XVECEXP (x3, 0, 4);
              switch (XWINT (x8, 0))
                {
                case 4LL:
                  x9 = XVECEXP (x3, 0, 5);
                  if (XWINT (x9, 0) != 12LL)
                    return -1;
                  x10 = XVECEXP (x3, 0, 6);
                  if (XWINT (x10, 0) != 5LL)
                    return -1;
                  x11 = XVECEXP (x3, 0, 7);
                  if (XWINT (x11, 0) != 13LL)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8SFmode:
                      if (pattern1302 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                          || !
#line 11270 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                        return -1;
                      return 4676; /* avx_unpcklps256 */

                    case E_V8SImode:
                      if (pattern1302 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                          || !
#line 19792 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
                        return -1;
                      return 7789; /* avx2_interleave_lowv8si */

                    default:
                      return -1;
                    }

                case 2LL:
                  x9 = XVECEXP (x3, 0, 5);
                  if (XWINT (x9, 0) != 10LL)
                    return -1;
                  x10 = XVECEXP (x3, 0, 6);
                  if (XWINT (x10, 0) != 3LL)
                    return -1;
                  x11 = XVECEXP (x3, 0, 7);
                  if (XWINT (x11, 0) != 11LL)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1362 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                          || !
#line 19717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                        return -1;
                      return 7777; /* vec_interleave_lowv8hi */

                    case E_V8HFmode:
                      if (pattern1362 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
                          || !
#line 19717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                        return -1;
                      return 7779; /* vec_interleave_lowv8hf */

                    case E_V8BFmode:
                      if (pattern1362 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
                          || !
#line 19717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                        return -1;
                      return 7781; /* vec_interleave_lowv8bf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2LL:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 10LL)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 4LL)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 12LL)
                return -1;
              x10 = XVECEXP (x3, 0, 6);
              if (XWINT (x10, 0) != 6LL)
                return -1;
              x11 = XVECEXP (x3, 0, 7);
              if (XWINT (x11, 0) != 14LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8DFmode:
                  if (!register_operand (operands[0], E_V8DFmode)
                      || GET_MODE (x2) != E_V8DFmode)
                    return -1;
                  x12 = XEXP (x2, 0);
                  if (GET_MODE (x12) != E_V16DFmode)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V8DFmode))
                    {
                      x13 = XEXP (x12, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && 
#line 13451 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                        return 4828; /* avx512f_movddup512 */
                    }
                  if (!register_operand (operands[1], E_V8DFmode))
                    return -1;
                  x13 = XEXP (x12, 1);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_V8DFmode)
                      || !
#line 13467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                    return -1;
                  return 4830; /* avx512f_unpcklpd512 */

                case E_V8DImode:
                  if (pattern1482 (x2, 
E_V8DImode, 
E_V16DImode) != 0
                      || !
#line 14544 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                    return -1;
                  return 6625; /* *avx512f_interleave_lowv8di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0LL:
          if (pattern1519 (x3) != 0
              || pattern1642 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !
#line 11409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4686; /* avx_movsldup256 */

        default:
          return -1;
        }

    case 2LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 10LL)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 3LL)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 11LL
          || pattern1566 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1302 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !
#line 11182 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4670; /* avx_unpckhps256 */

        case E_V8SImode:
          if (pattern1302 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !
#line 19737 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return -1;
          return 7783; /* avx2_interleave_highv8si */

        default:
          return -1;
        }

    case 1LL:
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 3LL)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 5LL)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 7LL)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 1LL:
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 3LL)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 5LL)
            return -1;
          x11 = XVECEXP (x3, 0, 7);
          if (XWINT (x11, 0) != 7LL
              || pattern1642 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !
#line 11356 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4680; /* avx_movshdup256 */

        case 9LL:
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 11LL)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 13LL)
            return -1;
          x11 = XVECEXP (x3, 0, 7);
          if (XWINT (x11, 0) != 15LL)
            return -1;
          x12 = XEXP (x2, 0);
          x13 = XEXP (x12, 1);
          operands[2] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1302 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0
                  || !
#line 13337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 4822; /* *avx512f_unpckhpd512 */

            case E_V8DImode:
              if (pattern1302 (x2, 
E_V8DImode, 
E_V16DImode) != 0
                  || !
#line 14494 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 6619; /* *avx512f_interleave_highv8di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 12LL)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 5LL)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 13LL
          || pattern1566 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern1362 (x2, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 19649 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
            return -1;
          return 7759; /* vec_interleave_highv8hi */

        case E_V8HFmode:
          if (pattern1362 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
              || !
#line 19649 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
            return -1;
          return 7761; /* vec_interleave_highv8hf */

        case E_V8BFmode:
          if (pattern1362 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
              || !
#line 19649 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
            return -1;
          return 7763; /* vec_interleave_highv8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[3] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[5] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || pattern1363 (
E_V16SFmode) != 0
          || !(
#line 12534 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL (operands[2]) % 4 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4764; /* *avx512f_vextractf32x4_1 */

    case E_V4SImode:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && pattern1363 (
E_V16SImode) == 0
          && (
#line 12534 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL (operands[2]) % 4 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 4765; /* *avx512f_vextracti32x4_1 */
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || pattern1389 () != 0
          || !
#line 20703 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
        return -1;
      return 7857; /* sse2_pshufd_1 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V4DImode)
          || pattern1389 () != 0
          || !
#line 27564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8536; /* avx2_permv4di_1 */

    default:
      return -1;
    }
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[6] = x4;
  res = recog_274 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 4LL)
    return -1;
  x5 = XVECEXP (x3, 0, 5);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x6 = XVECEXP (x3, 0, 6);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x7 = XVECEXP (x3, 0, 7);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || !register_operand (operands[0], E_V8HImode)
      || GET_MODE (x2) != E_V8HImode
      || !vector_operand (operands[1], E_V8HImode)
      || pattern612 (x3) != 0
      || !
#line 20859 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
    return -1;
  return 7863; /* sse2_pshuflw_1 */
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern852 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 0LL:
      if (pattern1623 (x3) != 0)
        return -1;
      switch (pattern1635 (x2))
        {
        case 0:
          if (!(
#line 13038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4798; /* vec_extract_lo_v32hi */

        case 1:
          if (!(
#line 13038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4799; /* vec_extract_lo_v32hf */

        case 2:
          if (!(
#line 13038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4800; /* vec_extract_lo_v32bf */

        case 3:
          if (!
#line 13208 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 4812; /* vec_extract_lo_v32qi */

        default:
          return -1;
        }

    case 16LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 17LL)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 18LL)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 19LL)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 20LL)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 21LL)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 22LL)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 23LL)
        return -1;
      x12 = XVECEXP (x3, 0, 8);
      if (XWINT (x12, 0) != 24LL)
        return -1;
      x13 = XVECEXP (x3, 0, 9);
      if (XWINT (x13, 0) != 25LL)
        return -1;
      x14 = XVECEXP (x3, 0, 10);
      if (XWINT (x14, 0) != 26LL)
        return -1;
      x15 = XVECEXP (x3, 0, 11);
      if (XWINT (x15, 0) != 27LL)
        return -1;
      x16 = XVECEXP (x3, 0, 12);
      if (XWINT (x16, 0) != 28LL)
        return -1;
      x17 = XVECEXP (x3, 0, 13);
      if (XWINT (x17, 0) != 29LL)
        return -1;
      x18 = XVECEXP (x3, 0, 14);
      if (XWINT (x18, 0) != 30LL)
        return -1;
      x19 = XVECEXP (x3, 0, 15);
      if (XWINT (x19, 0) != 31LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (!nonimmediate_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || !register_operand (operands[1], E_V32HImode)
              || !(
#line 13079 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4801; /* vec_extract_hi_v32hi */

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[0], E_V16HFmode)
              || GET_MODE (x2) != E_V16HFmode
              || !register_operand (operands[1], E_V32HFmode)
              || !(
#line 13079 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4802; /* vec_extract_hi_v32hf */

        case E_V16BFmode:
          if (!nonimmediate_operand (operands[0], E_V16BFmode)
              || GET_MODE (x2) != E_V16BFmode
              || !register_operand (operands[1], E_V32BFmode)
              || !(
#line 13079 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4803; /* vec_extract_hi_v32bf */

        case E_V16QImode:
          if (!nonimmediate_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_V32QImode)
              || !
#line 13226 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 4813; /* vec_extract_hi_v32qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BFmode:
      if (GET_MODE (x2) != E_V16BFmode)
        return -1;
      if (register_operand (operands[0], E_V16BFmode)
          && vector_operand (operands[1], E_V16BFmode)
          && vector_operand (operands[2], E_V16BFmode)
          && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3188; /* *andv16bf3 */
      if (!nonimmediate_operand (operands[0], E_V16BFmode)
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16BFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3243; /* *bit_and_float_vector_all_ones */

    case E_V8BFmode:
      if (GET_MODE (x2) != E_V8BFmode)
        return -1;
      if (register_operand (operands[0], E_V8BFmode)
          && vector_operand (operands[1], E_V8BFmode)
          && vector_operand (operands[2], E_V8BFmode)
          && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3191; /* *andv8bf3 */
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8BFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3244; /* *bit_and_float_vector_all_ones */

    case E_V16HFmode:
      if (GET_MODE (x2) != E_V16HFmode)
        return -1;
      if (register_operand (operands[0], E_V16HFmode)
          && vector_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[2], E_V16HFmode)
          && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3194; /* *andv16hf3 */
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !nonimmediate_operand (operands[1], E_V16HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16HFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3246; /* *bit_and_float_vector_all_ones */

    case E_V8HFmode:
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      if (register_operand (operands[0], E_V8HFmode)
          && vector_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[2], E_V8HFmode)
          && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3197; /* *andv8hf3 */
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8HFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3247; /* *bit_and_float_vector_all_ones */

    case E_V8SFmode:
      if (GET_MODE (x2) != E_V8SFmode)
        return -1;
      if (register_operand (operands[0], E_V8SFmode)
          && vector_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[2], E_V8SFmode)
          && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3200; /* *andv8sf3 */
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8SFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3249; /* *bit_and_float_vector_all_ones */

    case E_V4SFmode:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (register_operand (operands[0], E_V4SFmode)
          && vector_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[2], E_V4SFmode)
          && 
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 3206; /* *andv4sf3 */
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !nonimmediate_operand (operands[1], E_V4SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()))
        return -1;
      return 3250; /* *bit_and_float_vector_all_ones */

    case E_V4DFmode:
      if (GET_MODE (x2) != E_V4DFmode)
        return -1;
      if (register_operand (operands[0], E_V4DFmode)
          && vector_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[2], E_V4DFmode)
          && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3212; /* *andv4df3 */
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V4DFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3252; /* *bit_and_float_vector_all_ones */

    case E_V2DFmode:
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      if (register_operand (operands[0], E_V2DFmode)
          && vector_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[2], E_V2DFmode)
          && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3218; /* *andv2df3 */
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !nonimmediate_operand (operands[1], E_V2DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V2DFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3253; /* *bit_and_float_vector_all_ones */

    case E_V32BFmode:
      if (GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      if (register_operand (operands[0], E_V32BFmode)
          && nonimmediate_operand (operands[2], E_V32BFmode)
          && (
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 491 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3224; /* *andv32bf3 */
      if (!nonimmediate_operand (operands[0], E_V32BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V32BFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 411 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3242; /* *bit_and_float_vector_all_ones */

    case E_V32HFmode:
      if (GET_MODE (x2) != E_V32HFmode
          || !nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      if (register_operand (operands[0], E_V32HFmode)
          && nonimmediate_operand (operands[2], E_V32HFmode)
          && (
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 492 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3227; /* *andv32hf3 */
      if (!nonimmediate_operand (operands[0], E_V32HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V32HFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 413 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3245; /* *bit_and_float_vector_all_ones */

    case E_V16SFmode:
      if (GET_MODE (x2) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode))
        return -1;
      if (register_operand (operands[0], E_V16SFmode)
          && nonimmediate_operand (operands[2], E_V16SFmode)
          && (
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3230; /* *andv16sf3 */
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16SFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3248; /* *bit_and_float_vector_all_ones */

    case E_V8DFmode:
      if (GET_MODE (x2) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      if (register_operand (operands[0], E_V8DFmode)
          && nonimmediate_operand (operands[2], E_V8DFmode)
          && (
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3236; /* *andv8df3 */
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8DFmode)
          || !(
#line 5470 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 416 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3251; /* *bit_and_float_vector_all_ones */

    case E_V16SImode:
      if (pattern171 (x2, 
E_V16SImode) != 0
          || !(
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V16SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7420; /* *andv16si3 */

    case E_V8SImode:
      if (pattern171 (x2, 
E_V8SImode) != 0
          || !(
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V8SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7426; /* *andv8si3 */

    case E_V4SImode:
      if (pattern171 (x2, 
E_V4SImode) != 0
          || !
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V4SImode, operands)))
        return -1;
      return 7432; /* *andv4si3 */

    case E_V8DImode:
      if (pattern171 (x2, 
E_V8DImode) != 0
          || !(
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V8DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7438; /* *andv8di3 */

    case E_V4DImode:
      if (pattern171 (x2, 
E_V4DImode) != 0
          || !(
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V4DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7444; /* *andv4di3 */

    case E_V2DImode:
      if (pattern171 (x2, 
E_V2DImode) != 0
          || !
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V2DImode, operands)))
        return -1;
      return 7450; /* *andv2di3 */

    case E_V64QImode:
      if (pattern26 (x2, 
E_V64QImode) != 0
          || !(
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7456; /* *andv64qi3 */

    case E_V32QImode:
      if (pattern26 (x2, 
E_V32QImode) != 0
          || !(
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7459; /* *andv32qi3 */

    case E_V16QImode:
      if (pattern26 (x2, 
E_V16QImode) != 0
          || !
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7462; /* *andv16qi3 */

    case E_V32HImode:
      if (pattern26 (x2, 
E_V32HImode) != 0
          || !(
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7465; /* *andv32hi3 */

    case E_V16HImode:
      if (pattern26 (x2, 
E_V16HImode) != 0
          || !(
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7468; /* *andv16hi3 */

    case E_V8HImode:
      if (pattern26 (x2, 
E_V8HImode) != 0
          || !
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7471; /* *andv8hi3 */

    case E_V1TImode:
      if (pattern608 (x2, 
E_V1TImode) != 0
          || !
#line 18943 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7474; /* andv1ti3 */

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern475 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5282; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5309; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5336; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5363; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5390; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5417; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5444; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5471; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5498; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5525; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5552; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5579; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5285; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5312; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5339; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5366; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5393; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5420; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5447; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5474; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5501; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5528; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5555; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5582; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5288; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5315; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5342; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5369; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5396; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5423; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5450; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5477; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5504; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5531; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5558; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5585; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6350; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6359; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6368; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6377; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6386; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6395; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6404; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6413; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6422; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6431; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6440; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6449; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern476 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5930; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5957; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5984; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6011; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6038; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6065; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6092; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6119; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6146; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6173; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6200; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6227; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern476 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5933; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5960; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5987; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6014; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6041; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6068; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6095; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6122; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6149; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6176; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6203; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6230; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern476 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5936; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5963; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5990; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6017; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6044; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6071; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6098; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6125; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6152; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6179; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6206; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6233; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_255 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          switch (pattern285 (x3, 
PLUS))
            {
            case 0:
              if (!
#line 3666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2660; /* avx_haddv4df3 */

            case 1:
              if (!
#line 3842 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2668; /* sse3_haddv4sf3 */

            default:
              return -1;
            }

        case MINUS:
          switch (pattern285 (x3, 
MINUS))
            {
            case 0:
              if (!
#line 3666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2661; /* avx_hsubv4df3 */

            case 1:
              if (!
#line 3842 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2669; /* sse3_hsubv4sf3 */

            default:
              return -1;
            }

        case VEC_CONCAT:
          if (GET_MODE (x5) != E_V2SFmode)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != VEC_CONCAT
              || GET_MODE (x6) != E_V2SFmode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != VEC_CONCAT
              || GET_MODE (x7) != E_V4SFmode
              || pattern944 (x7, 
E_V2SFmode, 
VEC_CONCAT) != 0
              || !register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x4) != E_V4SFmode
              || pattern1420 (x3, 
E_SFmode) != 0)
            return -1;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pattern1669 (x3, 
PLUS) != 0
                  || !
#line 3814 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2666; /* avx_haddv8sf3 */

            case MINUS:
              if (pattern1669 (x3, 
MINUS) != 0
                  || !
#line 3814 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2667; /* avx_hsubv8sf3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (pattern349 (x3) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1359 (x3, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0
                  || !(
#line 30151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9469; /* avx512f_si512_si */

            case E_V16SFmode:
              if (pattern1359 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_V16SFmode) != 0
                  || !(
#line 30151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9470; /* avx512f_ps512_ps */

            case E_V8DFmode:
              if (pattern1359 (x3, 
E_V4DFmode, 
E_V2DFmode, 
E_V8DFmode) != 0
                  || !(
#line 30151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9471; /* avx512f_pd512_pd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pattern92 (x3, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!vector_operand (operands[2], E_V2DFmode)
          || pattern1705 (x3) != 0
          || !
#line 3705 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && INTVAL (operands[3]) != INTVAL (operands[4])
   && INTVAL (operands[5]) != INTVAL (operands[6])))
        return -1;
      return 2662; /* *sse3_haddv2df3 */

    case MINUS:
      if (pattern93 (x4, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != MINUS
          || GET_MODE (x7) != E_DFmode
          || pattern1421 (x7, 
E_DFmode) != 0
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XEXP (x4, 0);
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!vector_operand (operands[2], E_V2DFmode))
        return -1;
      x6 = XEXP (x4, 1);
      x11 = XEXP (x6, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x7, 1);
      x13 = XEXP (x12, 0);
      if (!rtx_equal_p (x13, operands[2])
          || !
#line 3730 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
        return -1;
      return 2663; /* sse3_hsubv2df3 */

    case FLOAT:
      switch (pattern169 (x3))
        {
        case 0:
          if (!
#line 7678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4001; /* *avx512fp16_vcvtdq2ph_v4si */

        case 1:
          if (!
#line 7678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4003; /* *avx512fp16_vcvtqq2ph_v4di */

        case 2:
          if (!
#line 7767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4015; /* *avx512fp16_vcvtqq2ph_v2di */

        case 3:
          if (!
#line 9217 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4407; /* *avx512dq_floatv2div2sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern169 (x3))
        {
        case 0:
          if (!
#line 7678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4002; /* *avx512fp16_vcvtudq2ph_v4si */

        case 1:
          if (!
#line 7678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4004; /* *avx512fp16_vcvtuqq2ph_v4di */

        case 2:
          if (!
#line 7767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4016; /* *avx512fp16_vcvtuqq2ph_v2di */

        case 3:
          if (!
#line 9217 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4408; /* *avx512dq_floatunsv2div2sf2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_254 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[2] = x7;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x3) != E_V8HFmode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V4HFmode:
                  if (!const0_operand (operands[2], E_V4HFmode))
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4DFmode:
                      if (!vector_operand (operands[1], E_V4DFmode)
                          || !
#line 8158 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4207; /* *avx512fp16_vcvtpd2ph_v4df */

                    case E_V4SFmode:
                      if (!vector_operand (operands[1], E_V4SFmode)
                          || !
#line 8158 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4208; /* *avx512fp16_vcvtps2ph_v4sf */

                    default:
                      return -1;
                    }

                case E_V2HFmode:
                  if (!vector_operand (operands[1], E_V2DFmode)
                      || !const0_operand (operands[2], E_V6HFmode)
                      || !
#line 8250 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                    return -1;
                  return 4214; /* *avx512fp16_vcvtpd2ph_v2df */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_V2SFmode
                  || !vector_operand (operands[1], E_V2DFmode)
                  || !const0_operand (operands[2], E_V2SFmode)
                  || !
#line 10146 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 4604; /* *sse2_cvtpd2ps */

            case E_V8BFmode:
              if (pattern168 (x3, 
E_V4BFmode, 
E_V4SFmode, 
E_V8BFmode) != 0
                  || !
#line 31061 "../../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT || (TARGET_AVX512BF16 && TARGET_AVX512VL)))
                return -1;
              return 9702; /* *vcvtneps2bf16_v4sf */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V32BFmode:
              if (pattern731 (x3, 
E_V16SFmode, 
E_V16BFmode, 
E_V32BFmode) != 0
                  || !(
#line 31022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9696; /* avx512f_cvtne2ps2bf16_v32bf */

            case E_V16BFmode:
              if (pattern731 (x3, 
E_V8SFmode, 
E_V8BFmode, 
E_V16BFmode) != 0
                  || !(
#line 31022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9698; /* avx512f_cvtne2ps2bf16_v16bf */

            case E_V8BFmode:
              if (pattern731 (x3, 
E_V4SFmode, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 31022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9700; /* avx512f_cvtne2ps2bf16_v8bf */

            case E_V32HFmode:
              if (pattern732 (x3, 
E_V16SFmode, 
E_V16HFmode, 
E_V32HFmode) != 0
                  || !(
#line 31719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 9795; /* avx10_2_cvt2ps2phx_v32hf */

            case E_V16HFmode:
              if (pattern732 (x3, 
E_V8SFmode, 
E_V8HFmode, 
E_V16HFmode) != 0
                  || !
#line 31719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 9799; /* avx10_2_cvt2ps2phx_v16hf */

            case E_V8HFmode:
              if (pattern732 (x3, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !
#line 31719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 9803; /* avx10_2_cvt2ps2phx_v8hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_256 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_VECTOR
          || XVECLEN (x7, 0) != 2
          || GET_MODE (x7) != E_V2SImode
          || pattern13 (x3, 
E_V2DFmode, 
E_V4SImode, 
0) != 0
          || !
#line 9604 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 4463; /* *fixuns_truncv2dfv2si2 */

    case FIX:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_VECTOR
          || pattern449 (x7, 
E_V2SImode, 
2) != 0
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!vector_operand (operands[1], E_V2DFmode)
          || !
#line 9964 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4583; /* sse2_cvttpd2dq */

    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          res = recog_252 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          res = recog_253 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSPEC:
          if (XVECLEN (x7, 0) == 1
              && XINT (x7, 1) == 147)
            {
              x14 = XVECEXP (x7, 0, 0);
              if (x14 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  operands[1] = x4;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8SImode:
                      if (pattern945 (x3, 
E_V4SImode, 
E_V8SImode) == 0
                          && 
#line 28824 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8916; /* avx_si256_si */
                      break;

                    case E_V8SFmode:
                      if (pattern945 (x3, 
E_V4SFmode, 
E_V8SFmode) == 0
                          && 
#line 28824 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8917; /* avx_ps256_ps */
                      break;

                    case E_V4DFmode:
                      if (pattern945 (x3, 
E_V2DFmode, 
E_V4DFmode) == 0
                          && 
#line 28824 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8918; /* avx_pd256_pd */
                      break;

                    case E_V16SImode:
                      if (pattern945 (x3, 
E_V8SImode, 
E_V16SImode) == 0
                          && (
#line 30168 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9472; /* avx512f_si512_256si */
                      break;

                    case E_V16SFmode:
                      if (pattern945 (x3, 
E_V8SFmode, 
E_V16SFmode) == 0
                          && (
#line 30168 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9473; /* avx512f_ps512_256ps */
                      break;

                    case E_V8DFmode:
                      if (pattern945 (x3, 
E_V4DFmode, 
E_V8DFmode) == 0
                          && (
#line 30168 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9474; /* avx512f_pd512_256pd */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern547 (x3) == 0)
        {
          x5 = XEXP (x4, 0);
          x15 = XVECEXP (x5, 0, 0);
          operands[1] = x15;
          if (memory_operand (operands[1], E_V16QImode))
            {
              x9 = XEXP (x7, 0);
              x16 = XVECEXP (x9, 0, 0);
              if (rtx_equal_p (x16, operands[1])
                  && 
#line 27921 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && ix86_pre_reload_split ()))
                return 8663; /* avx2_lddqu_inserti_to_bcasti */
            }
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      if (rtx_equal_p (x7, operands[1])
          && 
#line 28013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return 8681; /* avx_vbroadcastf128_v4di */
      operands[2] = x7;
      if (!nonimm_or_0_operand (operands[2], E_V2DImode)
          || !
#line 28958 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V2DImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8978; /* avx_vec_concatv4di */

    case ZERO_EXTEND:
      switch (pattern170 (x3))
        {
        case 0:
          if (!
#line 12110 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 4739; /* *vec_setv2di_0_zero_extendhi_1 */

        case 1:
          if (!
#line 12224 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 4751; /* *vec_setv2di_0_zero_extendsi_1 */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[2] = x7;
          switch (pattern451 (x3))
            {
            case 0:
              if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6700; /* avx512vl_ss_truncatev4div4qi2 */
              break;

            case 1:
              if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6709; /* avx512vl_ss_truncatev4siv4qi2 */
              break;

            case 2:
              if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6703; /* avx512vl_ss_truncatev2div2qi2 */
              break;

            case 3:
              if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6706; /* avx512vl_ss_truncatev8siv8qi2 */
              break;

            case 4:
              if ((
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 6712; /* avx512vl_ss_truncatev8hiv8qi2 */
              break;

            case 5:
              if ((
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15697 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return 6791; /* avx512vl_ss_truncatev4div4hi2 */
              break;

            case 6:
              if (
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6797; /* avx512vl_ss_truncatev4siv4hi2 */
              break;

            case 7:
              if (
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6794; /* avx512vl_ss_truncatev2div2hi2 */
              break;

            case 8:
              if (
#line 15976 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6846; /* avx512vl_ss_truncatev2div2si2 */
              break;

            default:
              break;
            }
          if (GET_CODE (x7) != CONST_VECTOR
              || pattern449 (x7, 
E_V8QImode, 
8) != 0)
            return -1;
          x17 = XVECEXP (x7, 0, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x7, 0, 3);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XVECEXP (x7, 0, 4);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x7, 0, 5);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XVECEXP (x7, 0, 6);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x22 = XVECEXP (x7, 0, 7);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern783 (x3, 
E_V8DImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 16112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6865; /* avx512f_ss_truncatev8div16qi2 */

        case SS_TRUNCATE:
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern737 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                  || !
#line 19225 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 7717; /* sse2_packsswb */

            case E_V8HImode:
              if (pattern737 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 19319 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 7723; /* sse2_packssdw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern451 (x3))
        {
        case 0:
          if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6701; /* avx512vl_truncatev4div4qi2 */
          break;

        case 1:
          if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6710; /* avx512vl_truncatev4siv4qi2 */
          break;

        case 2:
          if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6704; /* avx512vl_truncatev2div2qi2 */
          break;

        case 3:
          if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6707; /* avx512vl_truncatev8siv8qi2 */
          break;

        case 4:
          if ((
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 6713; /* avx512vl_truncatev8hiv8qi2 */
          break;

        case 5:
          if ((
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15697 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 6792; /* avx512vl_truncatev4div4hi2 */
          break;

        case 6:
          if (
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6798; /* avx512vl_truncatev4siv4hi2 */
          break;

        case 7:
          if (
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6795; /* avx512vl_truncatev2div2hi2 */
          break;

        case 8:
          if (
#line 15976 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6847; /* avx512vl_truncatev2div2si2 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_V8DImode)
          || pattern452 (x3) != 0
          || !
#line 16112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 6866; /* avx512f_truncatev8div16qi2 */

    case US_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern451 (x3))
        {
        case 0:
          if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6702; /* avx512vl_us_truncatev4div4qi2 */
          break;

        case 1:
          if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6711; /* avx512vl_us_truncatev4siv4qi2 */
          break;

        case 2:
          if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6705; /* avx512vl_us_truncatev2div2qi2 */
          break;

        case 3:
          if (
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6708; /* avx512vl_us_truncatev8siv8qi2 */
          break;

        case 4:
          if ((
#line 15380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 6714; /* avx512vl_us_truncatev8hiv8qi2 */
          break;

        case 5:
          if ((
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15697 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 6793; /* avx512vl_us_truncatev4div4hi2 */
          break;

        case 6:
          if (
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6799; /* avx512vl_us_truncatev4siv4hi2 */
          break;

        case 7:
          if (
#line 15735 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6796; /* avx512vl_us_truncatev2div2hi2 */
          break;

        case 8:
          if (
#line 15976 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6848; /* avx512vl_us_truncatev2div2si2 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_V8DImode)
          || pattern452 (x3) != 0
          || !
#line 16112 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 6867; /* avx512f_us_truncatev8div16qi2 */

    default:
      return -1;
    }
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern50 (x3))
        {
        case 0:
          if (!(
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6931; /* *avx512bw_ssaddv64qi3 */

        case 1:
          if (!(
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6939; /* *avx2_ssaddv32qi3 */

        case 2:
          if (!
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V16QImode, operands)))
            return -1;
          return 6947; /* *sse2_ssaddv16qi3 */

        case 3:
          if (!(
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6955; /* *avx512bw_ssaddv32hi3 */

        case 4:
          if (!(
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6963; /* *avx2_ssaddv16hi3 */

        case 5:
          if (!
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V8HImode, operands)))
            return -1;
          return 6971; /* *sse2_ssaddv8hi3 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern185 (x3))
        {
        case 0:
          if (!
#line 22580 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7955; /* avx2_phaddswv16hi3 */

        case 1:
          if (!
#line 22603 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 7959; /* ssse3_phaddswv8hi3 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PARALLEL)
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != SIGN_EXTEND)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL)
            return -1;
          x11 = XEXP (x3, 1);
          if (GET_CODE (x11) != MULT)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != VEC_SELECT)
            return -1;
          x14 = XEXP (x13, 1);
          if (GET_CODE (x14) != PARALLEL)
            return -1;
          x15 = XEXP (x11, 1);
          if (GET_CODE (x15) != SIGN_EXTEND)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != VEC_SELECT)
            return -1;
          x17 = XEXP (x16, 1);
          if (GET_CODE (x17) != PARALLEL)
            return -1;
          x18 = XEXP (x6, 0);
          operands[1] = x18;
          x19 = XEXP (x9, 0);
          operands[2] = x19;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x16, 0);
          if (!rtx_equal_p (x21, operands[2]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 16:
              if (pattern981 (x7, 
6, 
4, 
2, 
0) != 0)
                return -1;
              x22 = XVECEXP (x7, 0, 4);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return -1;
              x23 = XVECEXP (x7, 0, 5);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
                return -1;
              x24 = XVECEXP (x7, 0, 6);
              if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
                return -1;
              x25 = XVECEXP (x7, 0, 7);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
                return -1;
              x26 = XVECEXP (x7, 0, 8);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x27 = XVECEXP (x7, 0, 9);
              if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x28 = XVECEXP (x7, 0, 10);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x29 = XVECEXP (x7, 0, 11);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x30 = XVECEXP (x7, 0, 12);
              if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x31 = XVECEXP (x7, 0, 13);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x32 = XVECEXP (x7, 0, 14);
              if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x33 = XVECEXP (x7, 0, 15);
              if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 30]
                  || pattern1211 (x10, 
16) != 0)
                return -1;
              x34 = XVECEXP (x10, 0, 8);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x35 = XVECEXP (x10, 0, 9);
              if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x36 = XVECEXP (x10, 0, 10);
              if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x37 = XVECEXP (x10, 0, 11);
              if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x38 = XVECEXP (x10, 0, 12);
              if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x39 = XVECEXP (x10, 0, 13);
              if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x40 = XVECEXP (x10, 0, 14);
              if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x41 = XVECEXP (x10, 0, 15);
              if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 30]
                  || pattern1718 (x14, 
16) != 0)
                return -1;
              x42 = XVECEXP (x14, 0, 8);
              if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x43 = XVECEXP (x14, 0, 9);
              if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x44 = XVECEXP (x14, 0, 10);
              if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x45 = XVECEXP (x14, 0, 11);
              if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x46 = XVECEXP (x14, 0, 12);
              if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x47 = XVECEXP (x14, 0, 13);
              if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x48 = XVECEXP (x14, 0, 14);
              if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x49 = XVECEXP (x14, 0, 15);
              if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || pattern1736 (x17, 
16) != 0)
                return -1;
              x50 = XVECEXP (x17, 0, 8);
              if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x51 = XVECEXP (x17, 0, 9);
              if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x52 = XVECEXP (x17, 0, 10);
              if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x53 = XVECEXP (x17, 0, 11);
              if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x54 = XVECEXP (x17, 0, 12);
              if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x55 = XVECEXP (x17, 0, 13);
              if (x55 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x56 = XVECEXP (x17, 0, 14);
              if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x57 = XVECEXP (x17, 0, 15);
              if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || pattern1741 (x3, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0
                  || GET_MODE (x8) != E_V16HImode
                  || GET_MODE (x9) != E_V16QImode
                  || !nonimmediate_operand (operands[2], E_V32QImode)
                  || pattern290 (x11, 
E_V16QImode, 
E_V16HImode) != 0
                  || !
#line 22790 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 7972; /* avx2_pmaddubsw256 */

            case 8:
              if (pattern1212 (x4) != 0
                  || pattern1718 (x14, 
8) != 0
                  || pattern1736 (x17, 
8) != 0
                  || pattern1741 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0
                  || GET_MODE (x8) != E_V8HImode
                  || GET_MODE (x9) != E_V8QImode
                  || !vector_operand (operands[2], E_V16QImode)
                  || pattern290 (x11, 
E_V8QImode, 
E_V8HImode) != 0
                  || !
#line 22877 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
                return -1;
              return 7981; /* ssse3_pmaddubsw128 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern288 (x3))
            {
            case 0:
              if (!
#line 26118 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8353; /* xop_pmacssww */

            case 1:
              if (!
#line 26118 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8355; /* xop_pmacssdd */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern286 (x4) != 0)
            return -1;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 1);
          switch (XVECLEN (x7, 0))
            {
            case 2:
              if (pattern1213 (x3) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V2DImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_MODE (x9) != E_V2SImode
                  || !nonimmediate_operand (operands[2], E_V4SImode))
                return -1;
              switch (pattern1682 (x4))
                {
                case 0:
                  if (!
#line 26137 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8357; /* xop_pmacssdql */

                case 1:
                  if (!
#line 26156 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8359; /* xop_pmacssdqh */

                default:
                  return -1;
                }

            case 4:
              if (pattern981 (x7, 
7, 
5, 
3, 
1) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              x9 = XEXP (x8, 0);
              x10 = XEXP (x9, 1);
              if (pattern1483 (x10, 
7, 
5, 
3, 
1) != 0
                  || !register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || GET_MODE (x4) != E_V4SImode
                  || GET_MODE (x5) != E_V4SImode
                  || GET_MODE (x6) != E_V4HImode
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || GET_MODE (x8) != E_V4SImode
                  || GET_MODE (x9) != E_V4HImode
                  || !nonimmediate_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V4SImode)
                  || !
#line 26178 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8361; /* xop_pmacsswd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || pattern289 (x5) != 0)
        return -1;
      x58 = XEXP (x5, 1);
      if (GET_MODE (x58) != E_V4SImode)
        return -1;
      x59 = XEXP (x58, 0);
      if (GET_CODE (x59) != VEC_SELECT
          || GET_MODE (x59) != E_V4HImode)
        return -1;
      x60 = XEXP (x59, 1);
      if (GET_CODE (x60) != PARALLEL
          || XVECLEN (x60, 0) != 4)
        return -1;
      x61 = XVECEXP (x60, 0, 0);
      if (x61 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x62 = XVECEXP (x60, 0, 1);
      if (x62 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x63 = XVECEXP (x60, 0, 2);
      if (x63 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x64 = XVECEXP (x60, 0, 3);
      if (x64 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_V4SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_V4SImode)
        return -1;
      x19 = XEXP (x9, 0);
      if (GET_CODE (x19) != VEC_SELECT
          || GET_MODE (x19) != E_V4HImode)
        return -1;
      x65 = XEXP (x19, 1);
      if (GET_CODE (x65) != PARALLEL
          || XVECLEN (x65, 0) != 4)
        return -1;
      x66 = XVECEXP (x65, 0, 0);
      if (x66 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x67 = XVECEXP (x65, 0, 1);
      if (x67 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x68 = XVECEXP (x65, 0, 2);
      if (x68 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x69 = XVECEXP (x65, 0, 3);
      if (x69 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x70 = XEXP (x8, 1);
      if (GET_CODE (x70) != SIGN_EXTEND
          || GET_MODE (x70) != E_V4SImode)
        return -1;
      x71 = XEXP (x70, 0);
      if (GET_CODE (x71) != VEC_SELECT
          || GET_MODE (x71) != E_V4HImode)
        return -1;
      x72 = XEXP (x71, 1);
      if (GET_CODE (x72) != PARALLEL
          || XVECLEN (x72, 0) != 4)
        return -1;
      x73 = XVECEXP (x72, 0, 0);
      if (x73 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x74 = XVECEXP (x72, 0, 1);
      if (x74 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x75 = XVECEXP (x72, 0, 2);
      if (x75 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x76 = XVECEXP (x72, 0, 3);
      if (x76 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || pattern1738 (x3) != 0
          || !
#line 26211 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8363; /* xop_pmadcsswd */

    default:
      return -1;
    }
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17107 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7029; /* *ashrv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17121 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 743 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7039; /* ashrv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8933; /* avx512vl_ashrvv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17107 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7031; /* *ashrv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17121 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7040; /* ashrv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8931; /* avx512vl_ashrvv8hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17107 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7033; /* *ashrv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17121 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 744 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7041; /* ashrv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8921; /* avx2_ashrvv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17107 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7035; /* *ashrv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17121 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7042; /* ashrv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8919; /* avx2_ashrvv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17107 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7037; /* *ashrv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 26992 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !TARGET_AVX512VL && ix86_pre_reload_split ()))
        return 8419; /* *ashrv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8925; /* avx2_ashrvv2di */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 788 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7047; /* *ashrv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8935; /* avx512bw_ashrvv32hi */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7049; /* *ashrv4di3 */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8927; /* avx2_ashrvv4di */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7051; /* *ashrv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 680 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8923; /* avx512f_ashrvv16si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7053; /* *ashrv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 682 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8929; /* avx512f_ashrvv8di */

    default:
      return -1;
    }
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern171 (x3, 
E_V32HFmode) != 0
              || !(
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && 1 && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2260; /* *mulv32hf3 */

        case E_V16HFmode:
          if (pattern171 (x3, 
E_V16HFmode) != 0
              || !(
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && 1 && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2264; /* *mulv16hf3 */

        case E_V8HFmode:
          if (pattern171 (x3, 
E_V8HFmode) != 0
              || !(
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && 1 && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2268; /* *mulv8hf3 */

        case E_V16SFmode:
          if (pattern171 (x3, 
E_V16SFmode) != 0
              || !(
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2272; /* *mulv16sf3 */

        case E_V8SFmode:
          if (pattern171 (x3, 
E_V8SFmode) != 0
              || !(
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2276; /* *mulv8sf3 */

        case E_V4SFmode:
          if (pattern171 (x3, 
E_V4SFmode) != 0
              || !
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2280; /* *mulv4sf3 */

        case E_V8DFmode:
          if (pattern171 (x3, 
E_V8DFmode) != 0
              || !(
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2284; /* *mulv8df3 */

        case E_V4DFmode:
          if (pattern171 (x3, 
E_V4DFmode) != 0
              || !(
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2288; /* *mulv4df3 */

        case E_V2DFmode:
          if (pattern171 (x3, 
E_V2DFmode) != 0
              || !(
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2292; /* *mulv2df3 */

        case E_V32HImode:
          if (pattern26 (x3, 
E_V32HImode) != 0
              || !(
#line 16398 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6979; /* *mulv32hi3 */

        case E_V16HImode:
          if (pattern26 (x3, 
E_V16HImode) != 0
              || !(
#line 16398 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6981; /* *mulv16hi3 */

        case E_V8HImode:
          if (pattern26 (x3, 
E_V8HImode) != 0
              || !
#line 16398 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
            return -1;
          return 6983; /* *mulv8hi3 */

        case E_V8DImode:
          if (pattern171 (x3, 
E_V8DImode) != 0
              || !(
#line 16852 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V8DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7017; /* *avx512dq_mulv8di3 */

        case E_V4DImode:
          if (pattern171 (x3, 
E_V4DImode) != 0
              || !(
#line 16852 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V4DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7019; /* *avx512dq_mulv4di3 */

        case E_V2DImode:
          if (pattern171 (x3, 
E_V2DImode) != 0
              || !(
#line 16852 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V2DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7021; /* *avx512dq_mulv2di3 */

        case E_V16SImode:
          if (pattern171 (x3, 
E_V16SImode) != 0
              || !(
#line 16911 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V16SImode, operands)
  && 1) && 
#line 671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7023; /* *avx512f_mulv16si3 */

        case E_V8SImode:
          if (pattern171 (x3, 
E_V8SImode) != 0
              || !(
#line 16911 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V8SImode, operands)
  && 1) && 
#line 671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7025; /* *avx2_mulv8si3 */

        case E_V4SImode:
          if (pattern171 (x3, 
E_V4SImode) != 0
              || !
#line 16911 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V4SImode, operands)
  && 1))
            return -1;
          return 7027; /* *sse4_1_mulv4si3 */

        case E_V32BFmode:
          if (pattern27 (x3, 
E_V32BFmode) != 0
              || !(
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9968; /* avx10_2_mulbf16_v32bf */

        case E_V16BFmode:
          if (pattern27 (x3, 
E_V16BFmode) != 0
              || !
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9976; /* avx10_2_mulbf16_v16bf */

        case E_V8BFmode:
          if (pattern27 (x3, 
E_V8BFmode) != 0
              || !
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9984; /* avx10_2_mulbf16_v8bf */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern183 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 16481 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6997; /* *vec_widen_umult_even_v16si */

        case 1:
          if (!
#line 16517 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6999; /* *vec_widen_umult_even_v8si */

        case 2:
          if (!
#line 16549 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7001; /* *vec_widen_umult_even_v4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern183 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 16597 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7003; /* *vec_widen_smult_even_v16si */

        case 1:
          if (!
#line 16633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7005; /* *vec_widen_smult_even_v8si */

        case 2:
          if (!
#line 16665 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7007; /* *sse4_1_mulv2siv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern30 (x1))
    {
    case 0:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4077; /* avx512fp16_fixuns_truncv8hi2 */

    case 1:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4083; /* avx512fp16_fixuns_truncv16hi2 */

    case 2:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4091; /* avx512fp16_fixuns_truncv32hi2 */

    case 3:
      x2 = XEXP (x1, 1);
      switch (pattern459 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4099; /* avx512fp16_fixuns_truncv8si2 */

        case 1:
          if (!
#line 9581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4458; /* fixuns_truncv8dfv8si2 */

        case 2:
          if (!(
#line 9926 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4577; /* *fixuns_truncv8sfv8si2 */

        default:
          return -1;
        }

    case 4:
      x2 = XEXP (x1, 1);
      switch (pattern458 (x2))
        {
        case 0:
          if (!(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4107; /* avx512fp16_fixuns_truncv16si2 */

        case 1:
          if (!
#line 8786 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4329; /* fixuns_truncv16sfv16si2 */

        default:
          return -1;
        }

    case 5:
      x2 = XEXP (x1, 1);
      switch (pattern459 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4115; /* avx512fp16_fixuns_truncv8di2 */

        case 1:
          if (!(
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4503; /* fixuns_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9755 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4557; /* fixuns_truncv8sfv8di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !
#line 7928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4141; /* *avx512fp16_fixuns_truncv4si2_load */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F))
            return -1;
          return 4477; /* fixuns_truncv4dfv4si2 */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 9926 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4579; /* *fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case 7:
      x2 = XEXP (x1, 1);
      switch (pattern460 (x2))
        {
        case 0:
          if (!
#line 7928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4145; /* *avx512fp16_fixuns_truncv4di2_load */

        case 1:
          if (!(
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4511; /* fixuns_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9755 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4561; /* fixuns_truncv4sfv4di2 */

        default:
          return -1;
        }

    case 8:
      x2 = XEXP (x1, 1);
      switch (pattern461 (x2))
        {
        case 0:
          if (!
#line 7978 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4157; /* *avx512fp16_fixuns_truncv2di2_load */

        case 1:
          if (!(
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4517; /* fixuns_truncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 7918 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4133; /* avx512fp16_fixuns_truncv4si2 */

    case 10:
      if (!
#line 7918 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4137; /* avx512fp16_fixuns_truncv4di2 */

    case 11:
      if (!
#line 7968 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4153; /* avx512fp16_fixuns_truncv2di2 */

    case 12:
      if (!
#line 9778 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4569; /* avx512dq_fixuns_truncv2sfv2di2 */

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern34 (x1))
    {
    case 0:
      if (
#line 17680 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7177; /* *avx2_uminv32qi3 */
      if (!(
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7256; /* *avx512bw_uminv32qi3 */

    case 1:
      if (
#line 17680 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7181; /* *avx2_uminv16hi3 */
      if (!(
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7272; /* *avx512bw_uminv16hi3 */

    case 2:
      if (
#line 17680 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7185; /* *avx2_uminv8si3 */
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7200; /* *avx512f_uminv8si3 */

    case 3:
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7192; /* *avx512f_uminv16si3 */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7208; /* *avx512f_uminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17908 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7298; /* *sse4_1_uminv4si3 */

    case 5:
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7216; /* *avx512f_uminv8di3 */

    case 6:
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7224; /* *avx512f_uminv4di3 */

    case 7:
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7232; /* *avx512f_uminv2di3 */

    case 8:
      if (!(
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7240; /* *avx512bw_uminv64qi3 */

    case 9:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7248; /* *avx512bw_uminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17927 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7301; /* *uminv16qi3 */

    case 10:
      if (!(
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7264; /* *avx512bw_uminv32hi3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7280; /* *avx512bw_uminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17908 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7294; /* *sse4_1_uminv8hi3 */

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (!(
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7128; /* avx512f_rorvv16si */

    case 1:
      if (!(
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7132; /* avx512vl_rorvv8si */

    case 2:
      if (!(
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7136; /* avx512vl_rorvv4si */

    case 3:
      if (!(
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7140; /* avx512f_rorvv8di */

    case 4:
      if (!(
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7144; /* avx512vl_rorvv4di */

    case 5:
      if (!(
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7148; /* avx512vl_rorvv2di */

    case 6:
      if (!(
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7152; /* avx512f_rorv16si */

    case 7:
      if (!(
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7156; /* avx512vl_rorv8si */

    case 8:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7160; /* avx512vl_rorv4si */
      if (!const_0_to_31_operand (operands[2], E_SImode)
          || !
#line 26624 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8405; /* xop_rotrv4si3 */

    case 9:
      if (!(
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7164; /* avx512f_rorv8di */

    case 10:
      if (!(
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7168; /* avx512vl_rorv4di */

    case 11:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7172; /* avx512vl_rorv2di */
      if (!const_0_to_63_operand (operands[2], E_SImode)
          || !
#line 26624 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8406; /* xop_rotrv2di3 */

    case 12:
      if (!
#line 26624 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8403; /* xop_rotrv16qi3 */

    case 13:
      if (!
#line 26624 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8404; /* xop_rotrv8hi3 */

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CCCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != NEG)
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode)
            return -1;
          return 793; /* *negqi_ccc_1 */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode)
            return -1;
          return 794; /* *neghi_ccc_1 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          return 795; /* *negsi_ccc_1 */

        default:
          return -1;
        }

    case CLOBBER:
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !scratch_operand (operands[0], E_QImode))
            return -1;
          return 796; /* *negqi_ccc_2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !scratch_operand (operands[0], E_HImode))
            return -1;
          return 797; /* *neghi_ccc_2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 798; /* *negsi_ccc_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 106:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern620 (x4, 
E_DImode, 
107, 
UNSPEC) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          if (!pop_operand (operands[1], E_TImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 3901 "../../../gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2))
            return -1;
          return 134; /* pop2_di */

        case 14:
          if (GET_MODE (x3) != E_SImode
              || pattern355 (x1, 
E_SImode) != 0)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
              if (XWINT (x6, 0) != 0LL)
                return -1;
              return 1243; /* *set_got */

            case LABEL_REF:
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              return 1244; /* *set_got_labelled */

            default:
              return -1;
            }

        case 97:
          switch (pattern480 (x1))
            {
            case 0:
              if (!
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
                return -1;
              return 1265; /* tzcnt_si */

            case 1:
              if (!(
#line 21714 "../../../gcc/config/i386/i386.md"
(true) && 
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI)))
                return -1;
              return 1272; /* tzcnt_hi */

            case 2:
              if ((
#line 21688 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI)))
                return 1267; /* *tzcnt_si_falsedep_nf */
              if (pnum_clobbers == NULL
                  || !
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
                return -1;
              *pnum_clobbers = 1;
              return 1269; /* *tzcnt_si_falsedep */

            default:
              return -1;
            }

        case 96:
          switch (pattern480 (x1))
            {
            case 0:
              if (!
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
                return -1;
              return 1266; /* lzcnt_si */

            case 1:
              if (!(
#line 21714 "../../../gcc/config/i386/i386.md"
(true) && 
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT)))
                return -1;
              return 1274; /* lzcnt_hi */

            case 2:
              if ((
#line 21688 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT)))
                return 1268; /* *lzcnt_si_falsedep_nf */
              if (pnum_clobbers == NULL
                  || !
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
                return -1;
              *pnum_clobbers = 1;
              return 1270; /* *lzcnt_si_falsedep */

            default:
              return -1;
            }

        case 27:
          if (GET_MODE (x3) != E_CCmode
              || pattern621 (x1, 
CLOBBER, 
E_CCmode) != 0)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_HImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x4, 0);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          return 1315; /* parityhi2_cmp */

        case 80:
          if (pattern481 (x1, 
81) != 0
              || !
#line 23904 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1375; /* sincosxf3 */

        case 82:
          if (pattern481 (x1, 
83) != 0
              || !
#line 24419 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1380; /* fxtractxf3_i387 */

        case 70:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_XFmode)
              || !
#line 24965 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1389; /* lrintxfdi2 */

        case 74:
          if (pattern482 (x1) != 0
              || !
#line 25064 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
            return -1;
          return 1392; /* frndintxf2_roundeven */

        case 75:
          if (pattern482 (x1) != 0
              || !
#line 25064 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
            return -1;
          return 1393; /* frndintxf2_floor */

        case 76:
          if (pattern482 (x1) != 0
              || !
#line 25064 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
            return -1;
          return 1394; /* frndintxf2_ceil */

        case 77:
          if (pattern482 (x1) != 0
              || !
#line 25064 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
            return -1;
          return 1395; /* frndintxf2_trunc */

        case 78:
          switch (pattern484 (x1))
            {
            case 0:
              if (!
#line 25181 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
                return -1;
              return 1400; /* *fisthi2_floor_1 */

            case 1:
              if (!
#line 25181 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
                return -1;
              return 1402; /* *fistsi2_floor_1 */

            case 2:
              if (!
#line 25181 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
                return -1;
              return 1404; /* *fistdi2_floor_1 */

            default:
              return -1;
            }

        case 79:
          switch (pattern484 (x1))
            {
            case 0:
              if (!
#line 25181 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
                return -1;
              return 1401; /* *fisthi2_ceil_1 */

            case 1:
              if (!
#line 25181 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
                return -1;
              return 1403; /* *fistsi2_ceil_1 */

            case 2:
              if (!
#line 25181 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
                return -1;
              return 1405; /* *fistdi2_ceil_1 */

            default:
              return -1;
            }

        case 18:
          if (pattern299 (x1) != 0)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !const0_operand (operands[1], E_SImode)
                  || !
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode))
                return -1;
              return 1503; /* probe_stack_1_si */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !const0_operand (operands[1], E_DImode)
                  || !
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode))
                return -1;
              return 1504; /* probe_stack_1_di */

            default:
              return -1;
            }

        case 92:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_345 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XVECEXP (x3, 0, 0);
          operands[3] = x6;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern1131 (x3, 
E_SImode))
                {
                case 0:
                  if (general_operand (operands[2], E_SImode)
                      && (
#line 27307 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    return 1513; /* *stack_protect_set_2_si_si */
                  if (!address_no_seg_operand (operands[2], E_SImode)
                      || !
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
                    return -1;
                  return 1515; /* *stack_protect_set_3_si_si */

                case 1:
                  if (!((
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1516; /* *stack_protect_set_3_si_di */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1131 (x3, 
E_DImode))
                {
                case 0:
                  if (general_operand (operands[2], E_SImode)
                      && (
#line 27307 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    return 1514; /* *stack_protect_set_2_di_si */
                  if (!address_no_seg_operand (operands[2], E_SImode)
                      || !
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
                    return -1;
                  return 1517; /* *stack_protect_set_3_di_si */

                case 1:
                  if (!((
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1518; /* *stack_protect_set_3_di_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 118:
          if (GET_MODE (x3) != E_V4SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_V4SImode))
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_V4SImode)
              || !
#line 1877 "../../../gcc/config/i386/sse.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          return 2043; /* movdi_to_sse */

        case 282:
          if (GET_MODE (x3) != E_BLKmode
              || pattern299 (x1) != 0)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x6, operands[0]))
            return -1;
          return 10363; /* mfence_nosse */

        case 287:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          if (!memory_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!memory_operand (operands[2], E_DImode)
              || !
#line 196 "../../../gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)))
            return -1;
          *pnum_clobbers = 1;
          return 10364; /* atomic_loaddi_fpu */

        case 288:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!memory_operand (operands[0], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!memory_operand (operands[2], E_DImode)
              || !
#line 295 "../../../gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)))
            return -1;
          *pnum_clobbers = 1;
          return 10368; /* atomic_storedi_fpu */

        default:
          return -1;
        }

    case 2:
      return recog_348 (x1, insn, pnum_clobbers);

    case 3:
      return recog_347 (x1, insn, pnum_clobbers);

    case 4:
      return recog_349 (x1, insn, pnum_clobbers);

    case 5:
      if (XINT (x3, 1) != 131
          || pattern487 (x1, 
131, 
5) != 0)
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x3, 0, 2);
      operands[3] = x11;
      if (!nonimmediate_operand (operands[3], E_V16QImode))
        return -1;
      x12 = XVECEXP (x3, 0, 3);
      operands[4] = x12;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x13 = XVECEXP (x3, 0, 4);
      operands[5] = x13;
      if (!const_0_to_255_operand (operands[5], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x4, 1);
      x14 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      x15 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      x17 = XVECEXP (x9, 0, 3);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      x18 = XVECEXP (x9, 0, 4);
      if (!rtx_equal_p (x18, operands[5]))
        return -1;
      switch (pattern1627 (x3))
        {
        case 0:
          if (!
#line 25908 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8345; /* sse4_2_pcmpestri */

        case 1:
          if (!
#line 25936 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8346; /* sse4_2_pcmpestrm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern504 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || GET_MODE (x3) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if (x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 6465 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 212; /* *adddi3_doubleword */
          if (!x86_64_general_operand (operands[2], E_DImode)
              || !(
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 225; /* *adddi_1 */

        case E_TImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern512 (x5, 
E_TImode) != 0
              || !(
#line 6465 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 213; /* *addti3_doubleword */

        case E_SImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern514 (x5) != 0
              || !
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 223; /* *addsi_1 */

        case E_HImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern513 (x5, 
E_HImode) != 0
              || !
#line 6813 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 237; /* *addhi_1 */

        case E_QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern513 (x5, 
E_QImode) != 0
              || !
#line 6870 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 239; /* *addqi_1 */

        case E_V2QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern516 (x5, 
E_V2QImode) != 0
              || !
#line 3241 "../../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
            return -1;
          return 1676; /* addv2qi3 */

        default:
          return -1;
        }

    case 1:
      x2 = XVECEXP (x1, 0, 1);
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x2, 1))
        {
        case 110:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern201 (x5, 
E_V2SFmode) != 0
              || !
#line 746 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (PLUS, V2SFmode, operands)))
            return -1;
          return 1622; /* *mmx_addv2sf3 */

        case 174:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern516 (x5, 
E_QImode) != 0
                  || !(
#line 2252 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2081; /* kaddqi */

            case E_HImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern516 (x5, 
E_HImode) != 0
                  || !(
#line 2252 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2082; /* kaddhi */

            case E_SImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern516 (x5, 
E_SImode) != 0
                  || !(
#line 2252 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2079 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return -1;
              return 2083; /* kaddsi */

            case E_DImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern516 (x5, 
E_DImode) != 0
                  || !(
#line 2252 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2079 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return -1;
              return 2084; /* kadddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (!
#line 6946 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      return 240; /* *addqi_1_slp */

    case 3:
      if (!
#line 6946 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      return 241; /* *addhi_1_slp */

    default:
      return -1;
    }
}

 int
recog_367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      return recog_366 (x1, insn, pnum_clobbers);

    case NEG:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!general_operand (operands[2], E_QImode)
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !scratch_operand (operands[0], E_QImode)
                  || !
#line 7225 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCZmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 252; /* *addqi_3 */

            case E_HImode:
              if (!general_operand (operands[2], E_HImode)
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !scratch_operand (operands[0], E_HImode)
                  || !
#line 7225 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCZmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 253; /* *addhi_3 */

            case E_SImode:
              if (!x86_64_general_operand (operands[2], E_SImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !scratch_operand (operands[0], E_SImode)
                  || !
#line 7225 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCZmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 254; /* *addsi_3 */

            case E_DImode:
              if (!x86_64_general_operand (operands[2], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !scratch_operand (operands[0], E_DImode)
                  || !(
#line 7225 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCZmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 255; /* *adddi_3 */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x6, 0) != 0LL)
            return -1;
          switch (pattern755 (x1, 
NEG))
            {
            case 0:
              if (!
#line 14417 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 789; /* *negqi_2 */

            case 1:
              if (!
#line 14417 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 790; /* *neghi_2 */

            case 2:
              if (!
#line 14417 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 791; /* *negsi_2 */

            case 3:
              if (!(
#line 14417 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 792; /* *negdi_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (pattern868 (x7, 
MINUS))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && const_int_operand (operands[2], E_QImode)
                  && scratch_operand (operands[0], E_QImode)
                  && 
#line 7371 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGCmode)))
                return 256; /* *addqi_4 */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[1], E_HImode)
                  && const_int_operand (operands[2], E_HImode)
                  && scratch_operand (operands[0], E_HImode)
                  && 
#line 7371 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGCmode)))
                return 257; /* *addhi_4 */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && const_int_operand (operands[2], E_SImode)
                  && scratch_operand (operands[0], E_SImode)
                  && 
#line 7371 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGCmode)))
                return 258; /* *addsi_4 */
              break;

            default:
              break;
            }
          break;

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              x10 = XEXP (x7, 1);
              if (pattern1366 (x10, 
E_QImode) == 0
                  && 
#line 8670 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return 369; /* *subqi_3 */
              break;

            case E_HImode:
              x10 = XEXP (x7, 1);
              if (pattern1366 (x10, 
E_HImode) == 0
                  && 
#line 8670 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return 370; /* *subhi_3 */
              break;

            case E_SImode:
              x10 = XEXP (x7, 1);
              if (pattern1367 (x10, 
E_SImode) == 0
                  && 
#line 8670 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return 371; /* *subsi_3 */
              break;

            case E_DImode:
              x10 = XEXP (x7, 1);
              if (pattern1367 (x10, 
E_DImode) == 0
                  && (
#line 8670 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 372; /* *subdi_3 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x7) != SET
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_MODE (x10) != E_SImode)
        return -1;
      switch (GET_CODE (x10))
        {
        case CTZ:
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_CCCmode:
              if (GET_MODE (x3) != E_CCCmode
                  || !
#line 20994 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
                return -1;
              return 1250; /* *tzcntsi_1 */

            case E_CCZmode:
              if (GET_MODE (x3) != E_CCZmode)
                return -1;
              return 1252; /* *bsfsi_1 */

            default:
              return -1;
            }

        case MINUS:
          x11 = XEXP (x10, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
            return -1;
          x12 = XEXP (x10, 1);
          if (GET_CODE (x12) != CLZ
              || GET_MODE (x12) != E_SImode
              || GET_MODE (x5) != E_CCZmode
              || GET_MODE (x3) != E_CCZmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          return 1255; /* bsr */

        default:
          return -1;
        }

    case MINUS:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern506 (x1, 
MINUS) != 0)
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x8;
          x14 = XEXP (x4, 1);
          operands[2] = x14;
          switch (pattern872 (x1))
            {
            case 0:
              if (!
#line 8276 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 339; /* *subqi_2 */

            case 1:
              if (!
#line 8276 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 340; /* *subhi_2 */

            case 2:
              if (!
#line 8276 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 341; /* *subsi_2 */

            case 3:
              if (!(
#line 8276 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 342; /* *subdi_2 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 110)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_MODE (x5) != E_CCGOCmode)
            return -1;
          switch (pattern309 (x1, 
E_CCGOCmode))
            {
            case 0:
              return 10414; /* atomic_sub_fetch_cmp_0qi_1 */

            case 1:
              return 10415; /* atomic_sub_fetch_cmp_0hi_1 */

            case 2:
              return 10416; /* atomic_sub_fetch_cmp_0si_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_365 (x1, insn, pnum_clobbers);

    case AND:
      return recog_364 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern311 (x1, 
IOR))
        {
        case 0:
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern869 (x1, 
IOR))
                {
                case 0:
                  if (
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                    return 634; /* *iorqi_exthi_1_cc */
                  break;

                case 1:
                  if (
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                    return 637; /* *iorqi_extsi_1_cc */
                  break;

                case 2:
                  if ((
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 640; /* *iorqi_extdi_1_cc */
                  break;

                default:
                  break;
                }
            }
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (pattern874 (x1, 
IOR))
            {
            case 0:
              if (!
#line 13881 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 709; /* *iorqi_2 */

            case 1:
              if (!
#line 13881 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 711; /* *iorhi_2 */

            case 2:
              if (!
#line 13881 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 713; /* *iorsi_2 */

            case 3:
              if (!(
#line 13881 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 715; /* *iordi_2 */

            case 4:
              if (!
#line 13935 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 717; /* *iorqi_3 */

            case 5:
              if (!
#line 13935 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 719; /* *iorhi_3 */

            case 6:
              if (!
#line 13935 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 721; /* *iorsi_3 */

            case 7:
              if (!(
#line 13935 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 723; /* *iordi_3 */

            default:
              return -1;
            }

        case 1:
          return 10418; /* atomic_or_fetch_cmp_0qi_1 */

        case 2:
          return 10421; /* atomic_or_fetch_cmp_0hi_1 */

        case 3:
          return 10424; /* atomic_or_fetch_cmp_0si_1 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern311 (x1, 
XOR))
        {
        case 0:
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern869 (x1, 
XOR))
                {
                case 0:
                  if (
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                    return 635; /* *xorqi_exthi_1_cc */
                  break;

                case 1:
                  if (
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                    return 638; /* *xorqi_extsi_1_cc */
                  break;

                case 2:
                  if ((
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 641; /* *xorqi_extdi_1_cc */
                  break;

                default:
                  break;
                }
            }
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (pattern874 (x1, 
XOR))
            {
            case 0:
              if (!
#line 13881 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 710; /* *xorqi_2 */

            case 1:
              if (!
#line 13881 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 712; /* *xorhi_2 */

            case 2:
              if (!
#line 13881 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 714; /* *xorsi_2 */

            case 3:
              if (!(
#line 13881 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 716; /* *xordi_2 */

            case 4:
              if (!
#line 13935 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 718; /* *xorqi_3 */

            case 5:
              if (!
#line 13935 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 720; /* *xorhi_3 */

            case 6:
              if (!
#line 13935 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 722; /* *xorsi_3 */

            case 7:
              if (!(
#line 13935 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 724; /* *xordi_3 */

            default:
              return -1;
            }

        case 1:
          return 10419; /* atomic_xor_fetch_cmp_0qi_1 */

        case 2:
          return 10422; /* atomic_xor_fetch_cmp_0hi_1 */

        case 3:
          return 10425; /* atomic_xor_fetch_cmp_0si_1 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17)
        return -1;
      switch (pattern755 (x1, 
NOT))
        {
        case 0:
          if (!
#line 15078 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, QImode, operands, TARGET_APX_NDD)))
            return -1;
          return 853; /* *one_cmplqi2_2 */

        case 1:
          if (!
#line 15078 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, HImode, operands, TARGET_APX_NDD)))
            return -1;
          return 854; /* *one_cmplhi2_2 */

        case 2:
          if (!
#line 15078 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 855; /* *one_cmplsi2_2 */

        case 3:
          if (!(
#line 15078 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 856; /* *one_cmpldi2_2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern313 (x1, 
ASHIFT))
        {
        case 0:
          if (!
#line 16341 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || (TARGET_DOUBLE_WITH_ADD && REG_P (operands[0])))))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, QImode, operands, TARGET_APX_NDD)))
            return -1;
          return 903; /* *ashlqi3_cmp */

        case 1:
          if (!
#line 16341 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || (TARGET_DOUBLE_WITH_ADD && REG_P (operands[0])))))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, HImode, operands, TARGET_APX_NDD)))
            return -1;
          return 904; /* *ashlhi3_cmp */

        case 2:
          if (!
#line 16341 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || (TARGET_DOUBLE_WITH_ADD && REG_P (operands[0])))))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 905; /* *ashlsi3_cmp */

        case 3:
          if (!(
#line 16341 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || (TARGET_DOUBLE_WITH_ADD && REG_P (operands[0])))))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 906; /* *ashldi3_cmp */

        case 4:
          if (!
#line 16448 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 907; /* *ashlqi3_cconly */

        case 5:
          if (!
#line 16448 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 908; /* *ashlhi3_cconly */

        case 6:
          if (!
#line 16448 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 909; /* *ashlsi3_cconly */

        case 7:
          if (!(
#line 16448 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 910; /* *ashldi3_cconly */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern313 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!
#line 17679 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)))
            return -1;
          return 989; /* *lshrqi3_cmp */

        case 1:
          if (!
#line 17679 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)))
            return -1;
          return 991; /* *lshrhi3_cmp */

        case 2:
          if (!
#line 17679 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 993; /* *lshrsi3_cmp */

        case 3:
          if (!(
#line 17679 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 995; /* *lshrdi3_cmp */

        case 4:
          if (!
#line 17750 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 997; /* *lshrqi3_cconly */

        case 5:
          if (!
#line 17750 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 999; /* *lshrhi3_cconly */

        case 6:
          if (!
#line 17750 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1001; /* *lshrsi3_cconly */

        case 7:
          if (!(
#line 17750 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1003; /* *lshrdi3_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern313 (x1, 
ASHIFTRT))
        {
        case 0:
          if (!
#line 17679 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, QImode, operands, TARGET_APX_NDD)))
            return -1;
          return 990; /* *ashrqi3_cmp */

        case 1:
          if (!
#line 17679 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, HImode, operands, TARGET_APX_NDD)))
            return -1;
          return 992; /* *ashrhi3_cmp */

        case 2:
          if (!
#line 17679 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 994; /* *ashrsi3_cmp */

        case 3:
          if (!(
#line 17679 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 996; /* *ashrdi3_cmp */

        case 4:
          if (!
#line 17750 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 998; /* *ashrqi3_cconly */

        case 5:
          if (!
#line 17750 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1000; /* *ashrhi3_cconly */

        case 6:
          if (!
#line 17750 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1002; /* *ashrsi3_cconly */

        case 7:
          if (!(
#line 17750 "../../../gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1004; /* *ashrdi3_cconly */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 98
          || GET_MODE (x4) != E_SImode
          || pattern756 (x1) != 0)
        return -1;
      x15 = XVECEXP (x4, 0, 0);
      operands[1] = x15;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x16 = XVECEXP (x4, 0, 1);
      operands[2] = x16;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 21744 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
        return -1;
      return 1276; /* *bmi_bextr_si_ccz */

    case IF_THEN_ELSE:
      if (pattern314 (x4, 
0, 
E_QImode, 
NE) != 0)
        return -1;
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != ZERO_EXTRACT
          || GET_MODE (x14) != E_SImode)
        return -1;
      x17 = XEXP (x14, 1);
      if (GET_CODE (x17) != UMIN
          || GET_MODE (x17) != E_QImode)
        return -1;
      x18 = XEXP (x14, 2);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XEXP (x4, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern756 (x1) != 0)
        return -1;
      x8 = XEXP (x4, 0);
      x20 = XEXP (x8, 0);
      operands[2] = x20;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x21 = XEXP (x14, 0);
      operands[1] = x21;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x17, 1);
      operands[3] = x22;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      x23 = XEXP (x17, 0);
      if (!rtx_equal_p (x23, operands[2])
          || !
#line 21907 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 4 * BITS_PER_UNIT))
        return -1;
      return 1287; /* *bmi2_bzhi_si3_1_ccz */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 110)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[2] = x6;
      res = recog_363 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (XWINT (x6, 0) != 0LL)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17
          || GET_MODE (x5) != E_CCCmode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != ZERO_EXTRACT)
        return -1;
      x24 = XEXP (x9, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_MODE (x3) != E_CCCmode)
        return -1;
      x15 = XVECEXP (x4, 0, 0);
      operands[0] = x15;
      x16 = XVECEXP (x4, 0, 1);
      operands[2] = x16;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x25 = XEXP (x9, 2);
      operands[1] = x25;
      x26 = XEXP (x9, 0);
      if (!rtx_equal_p (x26, operands[0]))
        return -1;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
          switch (XWINT (x10, 0))
            {
            case 1LL:
              switch (pattern1614 (x1))
                {
                case 0:
                  return 10405; /* atomic_bit_test_and_sethi_1 */

                case 1:
                  return 10406; /* atomic_bit_test_and_setsi_1 */

                default:
                  return -1;
                }

            case 0LL:
              switch (pattern1614 (x1))
                {
                case 0:
                  return 10409; /* atomic_bit_test_and_resethi_1 */

                case 1:
                  return 10410; /* atomic_bit_test_and_resetsi_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != ZERO_EXTRACT)
            return -1;
          x27 = XEXP (x11, 1);
          if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x28 = XEXP (x11, 0);
          if (!rtx_equal_p (x28, operands[0]))
            return -1;
          x29 = XEXP (x11, 2);
          if (!rtx_equal_p (x29, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_HImode:
              if (pattern1678 (x7, 
E_HImode) != 0)
                return -1;
              return 10407; /* atomic_bit_test_and_complementhi_1 */

            case E_SImode:
              if (pattern1678 (x7, 
E_SImode) != 0)
                return -1;
              return 10408; /* atomic_bit_test_and_complementsi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_400 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      if (XWINT (x3, 0) != 0LL)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x7) != USE)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case ASHIFT:
          x10 = XEXP (x9, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x11 = XEXP (x5, 1);
          operands[3] = x11;
          switch (pattern1140 (x1))
            {
            case 0:
              x12 = XEXP (x6, 1);
              x13 = XEXP (x12, 0);
              if (GET_CODE (x13) != ASHIFT)
                return -1;
              x14 = XEXP (x13, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
                  || pattern1232 (x1) != 0)
                return -1;
              x15 = XEXP (x9, 0);
              operands[5] = x15;
              x16 = XEXP (x6, 0);
              operands[1] = x16;
              x17 = XEXP (x12, 1);
              operands[4] = x17;
              x18 = XEXP (x13, 0);
              if (!rtx_equal_p (x18, operands[5]))
                return -1;
              switch (pattern1615 (x1))
                {
                case 0:
                  if (pattern1698 (x1, 
E_SImode) != 0
                      || !(
#line 25577 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1423; /* *rep_movsi */

                case 1:
                  if (pattern1698 (x1, 
E_DImode) != 0
                      || !(
#line 25577 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1424; /* *rep_movsi */

                default:
                  return -1;
                }

            case 1:
              x15 = XEXP (x9, 0);
              operands[4] = x15;
              switch (pattern1527 (x1, 
E_SImode))
                {
                case 0:
                  if (pattern1653 (x5, 
E_SImode) != 0
                      || !(
#line 25774 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1433; /* *rep_stossi */

                case 1:
                  if (pattern1653 (x5, 
E_DImode) != 0
                      || !(
#line 25774 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1434; /* *rep_stossi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (pattern1140 (x1))
            {
            case 0:
              if (pattern1232 (x1) != 0)
                return -1;
              x11 = XEXP (x5, 1);
              operands[5] = x11;
              x16 = XEXP (x6, 0);
              operands[1] = x16;
              x12 = XEXP (x6, 1);
              x13 = XEXP (x12, 0);
              operands[4] = x13;
              x17 = XEXP (x12, 1);
              if (!rtx_equal_p (x17, operands[5]))
                return -1;
              switch (pattern1615 (x1))
                {
                case 0:
                  if (pattern1680 (x1, 
E_SImode) != 0
                      || !(
#line 25595 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1425; /* *rep_movqi */

                case 1:
                  if (pattern1680 (x1, 
E_DImode) != 0
                      || !(
#line 25595 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1426; /* *rep_movqi */

                default:
                  return -1;
                }

            case 1:
              x11 = XEXP (x5, 1);
              operands[4] = x11;
              switch (pattern1527 (x1, 
E_QImode))
                {
                case 0:
                  if (pattern1634 (x5, 
E_SImode) != 0
                      || !(
#line 25791 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1435; /* *rep_stosqi */

                case 1:
                  if (pattern1634 (x5, 
E_DImode) != 0
                      || !(
#line 25791 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1436; /* *rep_stosqi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      if (pattern215 (x1) != 0)
        return -1;
      x19 = XEXP (x3, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 0);
      operands[4] = x21;
      x22 = XEXP (x19, 1);
      x23 = XEXP (x22, 0);
      operands[5] = x23;
      x4 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x16 = XEXP (x6, 0);
      operands[0] = x16;
      x24 = XVECEXP (x1, 0, 3);
      x25 = XEXP (x24, 0);
      operands[1] = x25;
      x7 = XVECEXP (x1, 0, 4);
      x26 = XEXP (x7, 0);
      operands[2] = x26;
      switch (GET_MODE (operands[6]))
        {
        case E_SImode:
          if (pattern1704 (
E_SImode) != 0
              || !(
#line 25922 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 1439; /* *cmpstrnqi_1 */

        case E_DImode:
          if (pattern1704 (
E_DImode) != 0
              || !(
#line 25922 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 1440; /* *cmpstrnqi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LTU:
      if (GET_MODE (x2) != E_CCCmode)
        return NULL;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17)
        return NULL;
      switch (pattern561 (x1))
        {
        case 0:
          if (!(
#line 9893 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9895 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_162 (insn, operands);

        case 1:
          if (!(
#line 9893 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9895 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_163 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern341 (x1))
        {
        case 0:
          return gen_split_716 (insn, operands);

        case 1:
          return gen_split_717 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      switch (pattern341 (x1))
        {
        case 0:
          return gen_split_718 (insn, operands);

        case 1:
          return gen_split_719 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return NULL;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 2);
  operands[2] = x9;
  if (!register_operand (operands[2], E_QImode))
    return NULL;
  x10 = XEXP (x2, 1);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  operands[4] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      switch (pattern1394 (x2, 
E_HImode))
        {
        case 0:
          if (!
#line 19300 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_692 (insn, operands);

        case 1:
          if (!(
#line 19300 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_693 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      switch (pattern1394 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 19300 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_694 (insn, operands);

        case 1:
          if (!(
#line 19300 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_695 (insn, operands);

        default:
          return NULL;
        }

    case E_DImode:
      switch (pattern1394 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 19300 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_696 (insn, operands);

        case 1:
          if (!(
#line 19300 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_697 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      if (pattern333 (x3) != 0
          || !(
#line 3748 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_12 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern763 (x3, 
E_QImode) != 0
              || !
#line 7095 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_101 (insn, operands);

        case E_HImode:
          if (pattern763 (x3, 
E_HImode) != 0
              || !
#line 7095 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_102 (insn, operands);

        case E_SImode:
          if (pattern764 (x3, 
E_SImode) != 0
              || !
#line 7095 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_103 (insn, operands);

        case E_DImode:
          if (pattern764 (x3, 
E_DImode) != 0
              || !(
#line 7095 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_104 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern368 (x3))
            {
            case 0:
              if (!(
#line 7898 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7900 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_120 (insn, operands);

            case 1:
              if (!(
#line 7898 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7900 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_121 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          switch (pattern371 (x3))
            {
            case 0:
              if (!(
#line 7964 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7966 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_126 (insn, operands);

            case 1:
              if (!(
#line 7964 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7966 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_127 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern372 (x3))
            {
            case 0:
              if (!(
#line 7990 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7992 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_128 (insn, operands);

            case 1:
              if (!(
#line 7990 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7992 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_129 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern335 (x3))
        {
        case 0:
          if (!(
#line 7920 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7922 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_122 (insn, operands);

        case 1:
          if (!(
#line 7920 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7922 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_123 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern338 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern892 (x3, 
E_QImode) != 0
                      || !(
#line 7941 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7943 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_124 (insn, operands);

                case E_HImode:
                  if (pattern892 (x3, 
E_HImode) != 0
                      || !(
#line 7941 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7943 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_125 (insn, operands);

                case E_DImode:
                  if (pattern782 (x3, 
E_DImode) != 0
                      || !((
#line 14137 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14151 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_371 (insn, operands);

                case E_TImode:
                  if (pattern782 (x3, 
E_TImode) != 0
                      || !((
#line 14137 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14151 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_374 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              if (pattern697 (x3) != 0
                  || !((
#line 14060 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14062 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!((
#line 14096 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14098 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_359 (insn, operands);

        case 2:
          if (!((
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14183 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_377 (insn, operands);

        case 3:
          if (!((
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14183 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_383 (insn, operands);

        case 4:
          if (!((
#line 14096 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14098 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_362 (insn, operands);

        case 5:
          if (!((
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14183 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_380 (insn, operands);

        case 6:
          if (!((
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14183 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_386 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern340 (x3))
        {
        case 0:
          if (!((
#line 14077 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14079 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_356 (insn, operands);

        case 1:
          if (!((
#line 14121 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14123 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_365 (insn, operands);

        case 2:
          if (!((
#line 14121 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14123 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_368 (insn, operands);

        case 3:
          if (!((
#line 14198 "../../../gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14209 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_389 (insn, operands);

        case 4:
          if (!((
#line 14198 "../../../gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14209 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_392 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern297 (x2, 
E_CCmode, 
17) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      switch (pattern1069 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x4) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode))
                {
                  if (nonimmediate_operand (operands[0], E_DImode)
                      && x86_64_hilo_general_operand (operands[2], E_DImode)
                      && ((
#line 12501 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 12503 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_230 (insn, operands);
                  if (register_operand (operands[0], E_DImode)
                      && const_int_operand (operands[2], E_DImode)
                      && (
#line 12825 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return gen_split_258 (insn, operands);
                }
              break;

            case E_TImode:
              if (pattern512 (x4, 
E_TImode) == 0
                  && ((
#line 12501 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12503 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return gen_split_231 (insn, operands);
              break;

            case E_HImode:
              if (pattern1241 (x4, 
E_HImode) == 0
                  && 
#line 12825 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))))
                return gen_split_256 (insn, operands);
              break;

            case E_SImode:
              if (pattern1241 (x4, 
E_SImode) == 0
                  && 
#line 12825 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))))
                return gen_split_257 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case 1:
          if ((
#line 12741 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12745 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return gen_split_232 (insn, operands);
          break;

        case 2:
          if ((
#line 12741 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12745 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return gen_split_235 (insn, operands);
          break;

        default:
          break;
        }
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) == CONST_INT)
        {
          res = split_17 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0))
        return NULL;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x7;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return NULL;
          x9 = XEXP (x7, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x4) != E_QImode
              || GET_MODE (x5) != E_QImode)
            return NULL;
          x10 = XEXP (x7, 0);
          if (!int248_register_operand (x10, E_VOIDmode))
            return NULL;
          operands[2] = x10;
          switch (pattern1542 (x3))
            {
            case 0:
              if ((
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12772 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
                return gen_split_238 (insn, operands);
              break;

            case 1:
              if ((
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12772 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
                return gen_split_241 (insn, operands);
              break;

            case 2:
              if (((
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12772 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
                return gen_split_244 (insn, operands);
              break;

            default:
              break;
            }
          operands[1] = x10;
          switch (pattern1543 (x3))
            {
            case 0:
              if (!(
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12803 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_247 (insn, operands);

            case 1:
              if (!(
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12803 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_250 (insn, operands);

            case 2:
              if (!((
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12803 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_253 (insn, operands);

            case 3:
              if (!
#line 13044 "../../../gcc/config/i386/i386.md"
( reload_completed))
                return NULL;
              return gen_split_267 (insn, operands);

            case 4:
              if (!
#line 13044 "../../../gcc/config/i386/i386.md"
( reload_completed))
                return NULL;
              return gen_split_270 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          if (GET_MODE (x7) != E_SImode)
            return NULL;
          x10 = XEXP (x7, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return NULL;
          switch (pattern1312 (x3))
            {
            case 0:
              if (!(
#line 18942 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 18944 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_670 (insn, operands);

            case 1:
              if (!(
#line 18942 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 18944 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_671 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      x11 = XEXP (x3, 0);
      operands[0] = x11;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern1313 (x4, 
E_DImode) == 0)
                {
                  if (((
#line 13312 "../../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 13314 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_312 (insn, operands);
                  if (((
#line 13330 "../../../gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 13333 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_313 (insn, operands);
                }
              break;

            case E_TImode:
              if (pattern1313 (x4, 
E_TImode) == 0
                  && ((
#line 13330 "../../../gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13333 "../../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_314 (insn, operands);
              break;

            case E_SImode:
              if (pattern1313 (x4, 
E_SImode) == 0
                  && 
#line 13398 "../../../gcc/config/i386/i386.md"
(reload_completed
   && optimize_insn_for_size_p () && optimize_size > 1
   && REGNO (operands[0]) == REGNO (operands[1])
   && LEGACY_INT_REG_P (operands[0])
   && !REX_INT_REG_P (operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                return gen_split_315 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_QImode)
            return NULL;
          x10 = XEXP (x7, 0);
          if (GET_CODE (x10) != LSHIFTRT
              || x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1393 (x4))
            {
            case 0:
              if (!(
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19346 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_700 (insn, operands);

            case 1:
              if (!((
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19346 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_701 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1136 (x4))
            {
            case 0:
              if (!(
#line 19362 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19364 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_702 (insn, operands);

            case 1:
              if (!((
#line 19362 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19364 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_703 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ROTATE:
      switch (pattern962 (x3, 
-2))
        {
        case 0:
          if (!(
#line 18892 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18897 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_666 (insn, operands);

        case 1:
          if (!((
#line 18892 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18897 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_667 (insn, operands);

        case 2:
          if (!(
#line 18920 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18925 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_668 (insn, operands);

        case 3:
          if (!((
#line 18920 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18925 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_669 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return NULL;
      if (XWINT (x4, 0) == 1LL)
        {
          res = split_14 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (XWINT (x4, 0) != 8LL
          || pattern654 (x2) != 0)
        return NULL;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern297 (x5, 
E_CCmode, 
17) != 0)
        return NULL;
      switch (pattern1306 (x2))
        {
        case 0:
          if (!(
#line 13228 "../../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 13232 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_300 (insn, operands);

        case 1:
          if (!(
#line 13228 "../../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 13232 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_303 (insn, operands);

        case 2:
          if (!(
#line 13228 "../../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 13232 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_301 (insn, operands);

        case 3:
          if (!(
#line 13228 "../../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 13232 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_304 (insn, operands);

        case 4:
          if (!(
#line 13228 "../../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 13232 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_302 (insn, operands);

        case 5:
          if (!(
#line 13228 "../../../gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 13232 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_305 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (pattern299 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          switch (pattern1051 (x3))
            {
            case 0:
              if (!(
#line 4839 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)) && 
#line 4841 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_40 (insn, operands);

            case 1:
              if (!(
#line 4839 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)) && 
#line 4841 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 2:
              if (!(
#line 4893 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)) && 
#line 4895 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_42 (insn, operands);

            default:
              return NULL;
            }

        case CTZ:
          if (pattern1068 (x3, 
E_SImode, 
E_DImode) != 0
              || !
#line 21168 "../../../gcc/config/i386/i386.md"
((TARGET_BMI || TARGET_CPU_P (GENERIC))
   && TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])))
            return NULL;
          return gen_split_732 (insn, operands);

        case POPCOUNT:
          if (pattern1068 (x3, 
E_HImode, 
E_SImode) != 0
              || !(
#line 22351 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT
   && ix86_pre_reload_split ()) && 
#line 22354 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_743 (insn, operands);

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != UNSPEC
              || pattern1053 (x7) != 0
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          x8 = XEXP (x6, 1);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode)
              || !(
#line 23083 "../../../gcc/config/i386/i386.md"
(TARGET_X32) && 
#line 23085 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_750 (insn, operands);

        default:
          return NULL;
        }

    case FIX:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern298 (x5) != 0)
        return NULL;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_VOIDmode))
        return NULL;
      switch (pattern483 (x3))
        {
        case 0:
          if (!(
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
   && ix86_pre_reload_split ()) && 
#line 5999 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_57 (insn, operands);

        case 1:
          if (!(
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
   && ix86_pre_reload_split ()) && 
#line 5999 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_58 (insn, operands);

        case 2:
          if (!(
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
   && ix86_pre_reload_split ()) && 
#line 5999 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_59 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      if (pattern299 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
          if (!rtx_equal_p (x6, operands[0])
              || !general_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XEXP (x3, 1);
          operands[1] = x4;
          if (!const1248_operand (operands[1], E_SImode)
              || !
#line 6420 "../../../gcc/config/i386/i386.md"
(reload_completed))
            return NULL;
          return gen_split_75 (insn, operands);

        case ZERO_EXTEND:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != ZERO_EXTEND)
            return NULL;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x10 = XEXP (x4, 0);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern510 (x3, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 11021 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed
  && REGNO (operands[1]) == DX_REG) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return NULL;
              return gen_split_204 (insn, operands);

            case E_TImode:
              if (pattern510 (x3, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 11021 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed
  && REGNO (operands[1]) == DX_REG) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_205 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      return split_23 (x1, insn);

    case SUBREG:
      return split_18 (x1, insn);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (GET_CODE (x3) == EQ)
        {
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case PLUS:
              switch (pattern658 (x1, 
PLUS))
                {
                case 0:
                  if (((
#line 7713 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 7715 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_116 (insn, operands);
                  break;

                case 1:
                  if (((
#line 7713 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 7715 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_117 (insn, operands);
                  break;

                case 2:
                  if (((
#line 7759 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && CONST_SCALAR_INT_P (operands[2])
   && rtx_equal_p (operands[2], operands[3])) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 7763 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_118 (insn, operands);
                  break;

                case 3:
                  if (((
#line 7759 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)
   && CONST_SCALAR_INT_P (operands[2])
   && rtx_equal_p (operands[2], operands[3])) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 7763 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_119 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case MINUS:
              switch (pattern658 (x1, 
MINUS))
                {
                case 0:
                  if (((
#line 8485 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 8487 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_153 (insn, operands);
                  break;

                case 1:
                  if (((
#line 8485 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 8487 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_154 (insn, operands);
                  break;

                case 2:
                  if (((
#line 8529 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && CONST_SCALAR_INT_P (operands[2])
   && rtx_equal_p (operands[2], operands[3])) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 8533 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_155 (insn, operands);
                  break;

                case 3:
                  if (((
#line 8529 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && CONST_SCALAR_INT_P (operands[2])
   && rtx_equal_p (operands[2], operands[3])) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 8533 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_156 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case ZERO_EXTRACT:
              switch (pattern625 (x1))
                {
                case 0:
                  if ((
#line 19384 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19386 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_704 (insn, operands);
                  break;

                case 1:
                  if (((
#line 19384 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19386 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_705 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x3;
      switch (pattern316 (x1))
        {
        case 0:
          if (!(
#line 19497 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)) && 
#line 19500 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_711 (insn, operands);

        case 1:
          if (!(
#line 19497 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)) && 
#line 19500 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_712 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern297 (x5, 
E_CCmode, 
17) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          res = split_16 (x1, insn);
          if (res != NULL_RTX)
            return res;
          if (GET_CODE (x6) != SUBREG)
            return NULL;
          switch (pattern953 (x2))
            {
            case 0:
              if (!(
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 8250 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_145 (insn, operands);

            case 1:
              if (!(
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 8250 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_146 (insn, operands);

            case 2:
              if (!((
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 8250 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_147 (insn, operands);

            case 3:
              if (!
#line 8339 "../../../gcc/config/i386/i386.md"
( reload_completed))
                return NULL;
              return gen_split_148 (insn, operands);

            case 4:
              if (!
#line 8339 "../../../gcc/config/i386/i386.md"
( reload_completed))
                return NULL;
              return gen_split_149 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != EQ)
            return NULL;
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x12 = XEXP (x8, 0);
          operands[3] = x12;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return NULL;
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1433 (x3, 
E_QImode) != 0
                  || !(
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10233 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_184 (insn, operands);

            case E_HImode:
              if (pattern1433 (x3, 
E_HImode) != 0
                  || !(
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10233 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_185 (insn, operands);

            case E_SImode:
              if (pattern1434 (x3, 
E_SImode) != 0
                  || !(
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10233 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_186 (insn, operands);

            case E_DImode:
              if (pattern1434 (x3, 
E_DImode) != 0
                  || !((
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10233 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_187 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      if (!bt_comparison_operator (x6, E_VOIDmode))
        return NULL;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern631 (x1))
        {
        case 0:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != PLUS)
            return NULL;
          x13 = XEXP (x4, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return NULL;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          operands[1] = x6;
          switch (pattern1440 (x3))
            {
            case 0:
              if (!(
#line 8750 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 8752 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_157 (insn, operands);

            case 1:
              if (!(
#line 8750 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 8752 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_158 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          x7 = XEXP (x6, 0);
          x14 = XEXP (x7, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1233 (x2))
            {
            case 0:
              x15 = XEXP (x7, 2);
              operands[2] = x15;
              switch (pattern1544 (x3))
                {
                case 0:
                  if ((
#line 19189 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (CONST_INT_P (operands[2])
       ? (INTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)
	  && INTVAL (operands[2])
	       >= (optimize_function_for_size_p (cfun) ? 8 : 32))
       : !memory_operand (operands[1], SImode))
   && ix86_pre_reload_split ()) && 
#line 19197 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_682 (insn, operands);
                  break;

                case 1:
                  if (((
#line 19189 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (CONST_INT_P (operands[2])
       ? (INTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)
	  && INTVAL (operands[2])
	       >= (optimize_function_for_size_p (cfun) ? 8 : 32))
       : !memory_operand (operands[1], DImode))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19197 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_683 (insn, operands);
                  break;

                default:
                  break;
                }
              if (GET_CODE (x15) != SUBREG)
                return NULL;
              switch (pattern1546 (x3))
                {
                case 0:
                  if (!(
#line 19265 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19270 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_686 (insn, operands);

                case 1:
                  if (!(
#line 19265 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19270 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_688 (insn, operands);

                case 2:
                  if (!((
#line 19265 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19270 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_690 (insn, operands);

                case 3:
                  if (!((
#line 19265 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19270 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_687 (insn, operands);

                case 4:
                  if (!((
#line 19265 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19270 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_689 (insn, operands);

                case 5:
                  if (!((
#line 19265 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19270 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_691 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              if (!(
#line 19228 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19233 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_684 (insn, operands);

            case 2:
              if (!((
#line 19228 "../../../gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19233 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_685 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COMPARE:
      return split_19 (x1, insn);

    case AND:
      return split_22 (x1, insn);

    case IOR:
      return split_24 (x1, insn);

    case XOR:
      return split_20 (x1, insn);

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != XOR
          || pattern345 (x1) != 0)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1224 (x3, 
E_HImode) != 0
              || !(
#line 13607 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)) && 
#line 13609 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_325 (insn, operands);

        case E_SImode:
          if (pattern1225 (x3, 
E_SImode) != 0
              || !(
#line 13607 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)) && 
#line 13609 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_326 (insn, operands);

        case E_DImode:
          if (pattern1225 (x3, 
E_DImode) != 0
              || !((
#line 13607 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13609 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_327 (insn, operands);

        case E_QImode:
          if (pattern1224 (x3, 
E_QImode) != 0
              || !(
#line 13807 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)) && 
#line 13809 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_331 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      return split_25 (x1, insn);

    case ABS:
      return split_26 (x1, insn);

    case ASHIFT:
      return split_21 (x1, insn);

    case LSHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern297 (x5, 
E_CCmode, 
17) != 0)
        return NULL;
      switch (pattern191 (x2))
        {
        case 0:
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) == SUBREG)
            {
              switch (pattern1227 (x3))
                {
                case 0:
                  if (((
#line 16582 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16587 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_483 (insn, operands);
                  break;

                case 1:
                  if (((
#line 16582 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16587 "../../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_485 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (GET_MODE (x3) == E_SImode
              && nonimmediate_operand (operands[1], E_SImode))
            {
              if (register_operand (operands[0], E_SImode))
                {
                  operands[2] = x4;
                  if (register_operand (operands[2], E_QImode)
                      && 
#line 17435 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                    return gen_split_503 (insn, operands);
                }
              if (GET_CODE (x4) == SUBREG)
                {
                  switch (pattern1374 (x4))
                    {
                    case 0:
                      if ((
#line 17840 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17845 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_516 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 17888 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17892 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_528 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 17934 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17938 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_540 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[2] = x4;
          switch (pattern1143 (x2))
            {
            case 0:
              if ((
#line 16694 "../../../gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return gen_split_491 (insn, operands);
              break;

            case 1:
              if ((
#line 17638 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 17649 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return gen_split_505 (insn, operands);
              break;

            case 2:
              if ((
#line 17638 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 17649 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return gen_split_507 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x4) != SUBREG)
            return NULL;
          switch (pattern1146 (x2))
            {
            case 0:
              if (!((
#line 17840 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17845 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_519 (insn, operands);

            case 1:
              if (!((
#line 17888 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17892 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_531 (insn, operands);

            case 2:
              if (!((
#line 17934 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17938 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_543 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && ((
#line 16643 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16648 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_487 (insn, operands);
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !((
#line 17865 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17870 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_525 (insn, operands);

        case 2:
          if (!((
#line 16643 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16648 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_489 (insn, operands);

        case 3:
          if (!(
#line 17865 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17870 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_522 (insn, operands);

        case 4:
          if (!(
#line 17912 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17916 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_534 (insn, operands);

        case 5:
          if (!((
#line 17912 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17916 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_537 (insn, operands);

        case 6:
          if (!(
#line 17964 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17968 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_546 (insn, operands);

        case 7:
          if (!((
#line 17964 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17968 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_549 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      return split_29 (x1, insn);

    case ROTATE:
      return split_28 (x1, insn);

    case ROTATERT:
      return split_27 (x1, insn);

    case CONST_INT:
      if (pattern344 (x2) != 0)
        return NULL;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern297 (x5, 
E_CCmode, 
17) != 0)
        return NULL;
      x9 = XEXP (x2, 0);
      x16 = XEXP (x9, 0);
      operands[0] = x16;
      x17 = XEXP (x9, 2);
      operands[1] = x17;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (nonimmediate_operand (operands[0], E_QImode)
              && (
#line 18963 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 18965 "../../../gcc/config/i386/i386.md"
( MEM_P (operands[0]))))
            return gen_split_672 (insn, operands);
          if (!register_operand (operands[0], E_QImode)
              || !
#line 18987 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_674 (insn, operands);

        case E_HImode:
          if (nonimmediate_operand (operands[0], E_HImode)
              && (
#line 18963 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 18965 "../../../gcc/config/i386/i386.md"
( MEM_P (operands[0]))))
            return gen_split_673 (insn, operands);
          if (!register_operand (operands[0], E_HImode)
              || !
#line 18987 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_675 (insn, operands);

        default:
          return NULL;
        }

    case CTZ:
      if (pattern345 (x1) != 0)
        return NULL;
      switch (pattern963 (x3))
        {
        case 0:
          if (!
#line 21062 "../../../gcc/config/i386/i386.md"
((TARGET_BMI || TARGET_CPU_P (GENERIC))
   && TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])))
            return NULL;
          return gen_split_729 (insn, operands);

        case 1:
          if (!(
#line 21062 "../../../gcc/config/i386/i386.md"
((TARGET_BMI || TARGET_CPU_P (GENERIC))
   && TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_730 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != CTZ
          || GET_MODE (x6) != E_SImode
          || pattern355 (x1, 
E_DImode) != 0)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21168 "../../../gcc/config/i386/i386.md"
((TARGET_BMI || TARGET_CPU_P (GENERIC))
   && TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])))
        return NULL;
      return gen_split_731 (insn, operands);

    case CLZ:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern346 (x5) != 0)
        return NULL;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 21500 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 21502 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_735 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || pattern540 (x1) != 0)
        return NULL;
      x18 = XVECEXP (x3, 0, 0);
      operands[1] = x18;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return NULL;
      switch (XINT (x3, 1))
        {
        case 97:
          if (!(
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21664 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_738 (insn, operands);

        case 96:
          if (!(
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 21664 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_739 (insn, operands);

        default:
          return NULL;
        }

    case POPCOUNT:
      if (GET_MODE (x3) != E_SImode
          || pattern355 (x1, 
E_SImode) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !(
#line 22163 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT) && 
#line 22171 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_741 (insn, operands);

        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_SImode)
            return NULL;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !(
#line 22333 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT
   && ix86_pre_reload_split ()) && 
#line 22336 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_742 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_63 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern475 (x2))
        {
        case 0:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1774 (insn, operands);

        case 1:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1801 (insn, operands);

        case 2:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1828 (insn, operands);

        case 3:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1855 (insn, operands);

        case 4:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1882 (insn, operands);

        case 5:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1909 (insn, operands);

        case 6:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1936 (insn, operands);

        case 7:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1963 (insn, operands);

        case 8:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1990 (insn, operands);

        case 9:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2017 (insn, operands);

        case 10:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2044 (insn, operands);

        case 11:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2071 (insn, operands);

        case 12:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1777 (insn, operands);

        case 13:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1804 (insn, operands);

        case 14:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 15:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1858 (insn, operands);

        case 16:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1885 (insn, operands);

        case 17:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1912 (insn, operands);

        case 18:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1939 (insn, operands);

        case 19:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1966 (insn, operands);

        case 20:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1993 (insn, operands);

        case 21:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2020 (insn, operands);

        case 22:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2047 (insn, operands);

        case 23:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2074 (insn, operands);

        case 24:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1780 (insn, operands);

        case 25:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1807 (insn, operands);

        case 26:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1834 (insn, operands);

        case 27:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1861 (insn, operands);

        case 28:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1888 (insn, operands);

        case 29:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1915 (insn, operands);

        case 30:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1942 (insn, operands);

        case 31:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1969 (insn, operands);

        case 32:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1996 (insn, operands);

        case 33:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2023 (insn, operands);

        case 34:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2050 (insn, operands);

        case 35:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2077 (insn, operands);

        case 36:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2842 (insn, operands);

        case 37:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2851 (insn, operands);

        case 38:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2860 (insn, operands);

        case 39:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2869 (insn, operands);

        case 40:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2878 (insn, operands);

        case 41:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2887 (insn, operands);

        case 42:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2896 (insn, operands);

        case 43:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2905 (insn, operands);

        case 44:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2914 (insn, operands);

        case 45:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2923 (insn, operands);

        case 46:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2932 (insn, operands);

        case 47:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2941 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern476 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2422 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2449 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2476 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2503 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2530 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2557 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2584 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2611 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2638 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2665 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2692 (insn, operands);

        case 11:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2719 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern476 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2425 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2452 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2479 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2506 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2533 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2560 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2587 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2614 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2641 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2668 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2695 (insn, operands);

        case 11:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2722 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern476 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2428 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2455 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2482 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2509 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2536 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2563 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2590 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2617 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2644 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2671 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2698 (insn, operands);

        case 11:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2725 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = split_58 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case IOR:
      res = split_65 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          res = split_60 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IOR:
          res = split_61 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case XOR:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
            case NOT:
              switch (pattern471 (x2))
                {
                case 0:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1451 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1478 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1505 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1532 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1559 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1586 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1613 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1640 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1667 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1694 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1721 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1748 (insn, operands);
                  break;

                case 12:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1454 (insn, operands);
                  break;

                case 13:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1481 (insn, operands);
                  break;

                case 14:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1508 (insn, operands);
                  break;

                case 15:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1535 (insn, operands);
                  break;

                case 16:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1562 (insn, operands);
                  break;

                case 17:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1589 (insn, operands);
                  break;

                case 18:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1616 (insn, operands);
                  break;

                case 19:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1643 (insn, operands);
                  break;

                case 20:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1670 (insn, operands);
                  break;

                case 21:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1697 (insn, operands);
                  break;

                case 22:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1724 (insn, operands);
                  break;

                case 23:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1751 (insn, operands);
                  break;

                case 24:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1457 (insn, operands);
                  break;

                case 25:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1484 (insn, operands);
                  break;

                case 26:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1511 (insn, operands);
                  break;

                case 27:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1538 (insn, operands);
                  break;

                case 28:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1565 (insn, operands);
                  break;

                case 29:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1592 (insn, operands);
                  break;

                case 30:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1619 (insn, operands);
                  break;

                case 31:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1646 (insn, operands);
                  break;

                case 32:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1673 (insn, operands);
                  break;

                case 33:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1700 (insn, operands);
                  break;

                case 34:
                  if (((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1727 (insn, operands);
                  break;

                case 35:
                  if ((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1754 (insn, operands);
                  break;

                case 36:
                  if (((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2735 (insn, operands);
                  break;

                case 37:
                  if (((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2744 (insn, operands);
                  break;

                case 38:
                  if ((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2753 (insn, operands);
                  break;

                case 39:
                  if (((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2762 (insn, operands);
                  break;

                case 40:
                  if (((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2771 (insn, operands);
                  break;

                case 41:
                  if ((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2780 (insn, operands);
                  break;

                case 42:
                  if (((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2789 (insn, operands);
                  break;

                case 43:
                  if (((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2798 (insn, operands);
                  break;

                case 44:
                  if ((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2807 (insn, operands);
                  break;

                case 45:
                  if (((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2816 (insn, operands);
                  break;

                case 46:
                  if (((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2825 (insn, operands);
                  break;

                case 47:
                  if ((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2834 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              switch (pattern473 (x2))
                {
                case 0:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2099 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2126 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2153 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2180 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2207 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2234 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2261 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2288 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2315 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2342 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2369 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2396 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case IOR:
              switch (pattern473 (x2))
                {
                case 0:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2102 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2129 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2156 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2183 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2210 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2237 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2264 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2291 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2318 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2345 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2372 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2399 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              switch (pattern473 (x2))
                {
                case 0:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2105 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2132 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2159 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2186 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2213 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2240 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2267 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2294 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2321 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2348 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2375 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2402 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[1] = x3;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern856 (x2, 
E_V16SImode) == 0
                  && ((
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3095 (insn, operands);
              break;

            case E_V8DImode:
              if (pattern856 (x2, 
E_V8DImode) == 0
                  && ((
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3096 (insn, operands);
              break;

            case E_V64QImode:
              if (pattern856 (x2, 
E_V64QImode) == 0
                  && ((
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3097 (insn, operands);
              break;

            case E_V32QImode:
              if (pattern856 (x2, 
E_V32QImode) == 0
                  && ((
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3098 (insn, operands);
              break;

            case E_V16QImode:
              if (pattern856 (x2, 
E_V16QImode) == 0
                  && (
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3099 (insn, operands);
              break;

            case E_V32HImode:
              if (pattern856 (x2, 
E_V32HImode) == 0
                  && ((
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3100 (insn, operands);
              break;

            case E_V16HImode:
              if (pattern856 (x2, 
E_V16HImode) == 0
                  && ((
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3101 (insn, operands);
              break;

            case E_V8HImode:
              if (pattern856 (x2, 
E_V8HImode) == 0
                  && (
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3102 (insn, operands);
              break;

            case E_V8SImode:
              if (pattern856 (x2, 
E_V8SImode) == 0
                  && ((
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3103 (insn, operands);
              break;

            case E_V4SImode:
              if (pattern856 (x2, 
E_V4SImode) == 0
                  && (
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3104 (insn, operands);
              break;

            case E_V4DImode:
              if (pattern856 (x2, 
E_V4DImode) == 0
                  && ((
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3105 (insn, operands);
              break;

            case E_V2DImode:
              if (pattern856 (x2, 
E_V2DImode) == 0
                  && (
#line 18371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 18382 "../../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3106 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x3) == VEC_DUPLICATE)
            {
              switch (pattern546 (x2))
                {
                case 0:
                  if ((
#line 18676 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3139 (insn, operands);
                  break;

                case 1:
                  if ((
#line 18676 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3140 (insn, operands);
                  break;

                case 2:
                  if ((
#line 18676 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3141 (insn, operands);
                  break;

                case 3:
                  if ((
#line 18676 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3142 (insn, operands);
                  break;

                case 4:
                  if (
#line 18676 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3143 (insn, operands);
                  break;

                case 5:
                  if ((
#line 18676 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3144 (insn, operands);
                  break;

                case 6:
                  if ((
#line 18676 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3145 (insn, operands);
                  break;

                case 7:
                  if (
#line 18676 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3146 (insn, operands);
                  break;

                case 8:
                  if ((
#line 18676 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3147 (insn, operands);
                  break;

                case 9:
                  if (
#line 18676 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3148 (insn, operands);
                  break;

                case 10:
                  if ((
#line 18676 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3149 (insn, operands);
                  break;

                case 11:
                  if (
#line 18676 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3150 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  switch (pattern184 ())
    {
    case 0:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1419 (insn, operands);
      break;

    case 1:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1420 (insn, operands);
      break;

    case 2:
      if ((
#line 13760 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1421 (insn, operands);
      break;

    case 3:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1422 (insn, operands);
      break;

    case 4:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1423 (insn, operands);
      break;

    case 5:
      if ((
#line 13760 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1424 (insn, operands);
      break;

    case 6:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1425 (insn, operands);
      break;

    case 7:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1426 (insn, operands);
      break;

    case 8:
      if ((
#line 13760 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1427 (insn, operands);
      break;

    case 9:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1428 (insn, operands);
      break;

    case 10:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1429 (insn, operands);
      break;

    case 11:
      if (((
#line 13760 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13764 "../../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1430 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case AND:
      return split_68 (x1, insn);

    case IOR:
      return split_67 (x1, insn);

    case XOR:
      return split_66 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MINUS
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x5) != E_CCmode)
        return NULL;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x7, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return NULL;
      x11 = XEXP (x4, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!general_reg_operand (operands[0], E_QImode)
              || !general_gr_operand (operands[1], E_QImode)
              || GET_MODE (x7) != E_QImode
              || !
#line 8688 "../../../gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_62 (insn, operands);

        case E_HImode:
          if (!general_reg_operand (operands[0], E_HImode)
              || !general_gr_operand (operands[1], E_HImode)
              || GET_MODE (x7) != E_HImode
              || !
#line 8688 "../../../gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_63 (insn, operands);

        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || !general_gr_operand (operands[1], E_SImode)
              || GET_MODE (x7) != E_SImode
              || !
#line 8688 "../../../gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_64 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || !general_gr_operand (operands[1], E_DImode)
              || GET_MODE (x7) != E_DImode
              || !(
#line 8688 "../../../gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_65 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (peep2_current_count < 2)
        return NULL;
      x12 = XEXP (x6, 0);
      if (GET_CODE (x12) != PLUS)
        return NULL;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != PLUS)
        return NULL;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case LTU:
        case UNLT:
          operands[4] = x14;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != PLUS)
            return NULL;
          x16 = XEXP (x8, 0);
          switch (GET_CODE (x16))
            {
            case LTU:
            case UNLT:
              operands[3] = x16;
              x17 = XEXP (x16, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x18 = XEXP (x8, 1);
              if (GET_CODE (x18) != ZERO_EXTEND)
                return NULL;
              x7 = XEXP (x4, 1);
              if (GET_CODE (x7) != PLUS)
                return NULL;
              x9 = XEXP (x7, 0);
              if (GET_CODE (x9) != PLUS)
                return NULL;
              x19 = XEXP (x9, 0);
              switch (GET_CODE (x19))
                {
                case LTU:
                case UNLT:
                  if (!rtx_equal_p (x19, operands[4])
                      || GET_MODE (x3) != E_CCCmode
                      || GET_MODE (x5) != E_CCCmode)
                    return NULL;
                  x20 = XEXP (x14, 0);
                  operands[2] = x20;
                  if (!flags_reg_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x21 = XEXP (x13, 1);
                  operands[0] = x21;
                  x22 = XEXP (x12, 1);
                  operands[1] = x22;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[2]))
                    return NULL;
                  x24 = XEXP (x18, 0);
                  if (!rtx_equal_p (x24, operands[1]))
                    return NULL;
                  x25 = XEXP (x9, 1);
                  if (!rtx_equal_p (x25, operands[0]))
                    return NULL;
                  x10 = XEXP (x7, 1);
                  if (!rtx_equal_p (x10, operands[1]))
                    return NULL;
                  x11 = XEXP (x4, 0);
                  if (!rtx_equal_p (x11, operands[0]))
                    return NULL;
                  x26 = PATTERN (peep2_next_insn (1));
                  if (GET_CODE (x26) != SET)
                    return NULL;
                  switch (GET_MODE (x6))
                    {
                    case E_DImode:
                      switch (pattern1717 (x1, 
E_SImode, 
E_DImode))
                        {
                        case 0:
                          if (!
#line 9089 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
                            return NULL;
                          *pmatch_len_ = 1;
                          return gen_peephole2_82 (insn, operands);

                        case 1:
                          if (!
#line 9183 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[5])
   && !reg_overlap_mentioned_p (operands[5], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[6])
   && !reg_overlap_mentioned_p (operands[6], operands[1])))
                            return NULL;
                          *pmatch_len_ = 3;
                          return gen_peephole2_86 (insn, operands);

                        default:
                          return NULL;
                        }

                    case E_TImode:
                      switch (pattern1717 (x1, 
E_DImode, 
E_TImode))
                        {
                        case 0:
                          if (!(
#line 9089 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            return NULL;
                          *pmatch_len_ = 1;
                          return gen_peephole2_83 (insn, operands);

                        case 1:
                          if (!(
#line 9183 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[5])
   && !reg_overlap_mentioned_p (operands[5], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[6])
   && !reg_overlap_mentioned_p (operands[6], operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            return NULL;
                          *pmatch_len_ = 3;
                          return gen_peephole2_87 (insn, operands);

                        default:
                          return NULL;
                        }

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      if (peep2_current_count < 2)
        return NULL;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      x27 = XEXP (x6, 1);
      operands[1] = x27;
      x11 = XEXP (x4, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      x26 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x26) != SET)
        return NULL;
      x28 = XEXP (x26, 1);
      if (!rtx_equal_p (x28, operands[0]))
        return NULL;
      x29 = XEXP (x26, 0);
      if (!rtx_equal_p (x29, operands[1]))
        return NULL;
      if (GET_CODE (x6) == PLUS)
        {
          res = peephole2_41 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[2] = x6;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return NULL;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!plusminuslogic_operator (operands[2], E_QImode)
              || !register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_QImode)
              || !
#line 28053 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_288 (insn, operands);

        case E_HImode:
          if (!plusminuslogic_operator (operands[2], E_HImode)
              || !register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_HImode)
              || !
#line 28053 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_289 (insn, operands);

        case E_SImode:
          if (!plusminuslogic_operator (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode)
              || !
#line 28053 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_290 (insn, operands);

        case E_DImode:
          if (!plusminuslogic_operator (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode)
              || !(
#line 28053 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_291 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
