/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4QImode:
      return pattern11 (x1, 
E_V4QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V4HImode)
          || !register_mmxmem_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern19 (x1); /* [-1, 1] */
}

int
pattern23 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != COMPARE
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != USE)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x4, 0);
  operands[4] = x12;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern38 (x2); /* [-1, 0] */
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      return 0;

    case STRICT_LOW_PART:
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      res = pattern41 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !x86_64_general_operand (operands[2], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !x86_64_general_operand (operands[2], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != VEC_CONCAT)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != PARALLEL)
    return -1;
  x9 = XEXP (x1, 0);
  operands[0] = x9;
  return pattern53 (x2); /* [-1, 1] */
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern76 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_or_x86_64_const_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern88 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern87 (x2, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern87 (x2, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern97 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !x86_64_general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !x86_64_general_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT
      || XWINT (x3, 0) != -65536LL)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != BSWAP
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  return 0;
}

int
pattern120 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern119 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern119 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern119 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern119 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern119 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern119 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern139 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i3))
    return -1;
  return 0;
}

int
pattern143 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern142 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern142 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern142 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern142 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern142 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern142 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern142 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern142 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern142 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern154 (x3, 
E_V32HFmode, 
E_V64QImode, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern154 (x3, 
E_V16HFmode, 
E_V32QImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern161 (x3, 
E_V32HImode); /* [-1, 0] */

    case E_V16SImode:
      if (pattern161 (x3, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern161 (x3, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16HImode:
      if (pattern161 (x3, 
E_V16HImode) != 0)
        return -1;
      return 3;

    case E_V8SImode:
      if (pattern161 (x3, 
E_V8SImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern161 (x3, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern161 (x3, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern161 (x3, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern161 (x3, 
E_V2DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i3))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_CONCAT)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x6, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      return pattern177 (x1); /* [-1, 0] */

    case 8:
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x4, 0, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x14 = XVECEXP (x4, 0, 2);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x15 = XVECEXP (x4, 0, 3);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x16 = XVECEXP (x4, 0, 4);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x17 = XVECEXP (x4, 0, 5);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x18 = XVECEXP (x4, 0, 6);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x4, 0, 7);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x20 = XVECEXP (x7, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x21 = XVECEXP (x7, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x22 = XVECEXP (x7, 0, 2);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x23 = XVECEXP (x7, 0, 3);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x24 = XVECEXP (x7, 0, 4);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x25 = XVECEXP (x7, 0, 5);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x26 = XVECEXP (x7, 0, 6);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x27 = XVECEXP (x7, 0, 7);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || pattern178 (x1, 
E_V16HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], E_QImode))
    return -1;
  return pattern194 (x1); /* [-1, 3] */
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern205 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_DUPLICATE
      || GET_MODE (x4) != E_V4SFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != FLOAT
      || GET_MODE (x5) != E_V2SFmode)
    return -1;
  x6 = XEXP (x3, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[2] = x9;
  if (!register_mmxmem_operand (operands[2], E_V2SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V4SFmode))
    return -1;
  x11 = XEXP (x7, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern218 (x1, 
E_V32HImode); /* [-1, 0] */

    case E_V16SImode:
      if (pattern218 (x1, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern218 (x1, 
E_V8DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x5, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != ZERO_EXTRACT)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x10 = XEXP (x8, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x11 = XEXP (x8, 0);
  operands[0] = x11;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern240 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  return pattern246 (x6); /* [-1, 1] */
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!ix86_comparison_operator (x2, E_QImode))
    return -1;
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  x8 = XEXP (x3, 2);
  operands[4] = x8;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x9 = XEXP (x1, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern262 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern262 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern262 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !float_vector_all_ones_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !vector_operand (operands[1], i1))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !vector_operand (operands[1], i2))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !vector_operand (operands[1], i3))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x1, 1);
  return pattern290 (x7, 
i1, 
i2); /* [-1, 0] */
}

int
pattern295 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern298 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  return pattern300 (x3); /* [-1, 1] */
}

int
pattern304 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern305 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern310 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 110)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCNOmode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  return pattern309 (x1, 
E_CCNOmode); /* [-1, 2] */
}

int
pattern314 (rtx x1, int i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern320 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern329 (x6, 
37); /* [-1, 0] */
}

int
pattern340 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return pattern109 (x4); /* [-1, 2] */

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern339 (x1, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 3;

        case E_TImode:
          if (pattern339 (x1, 
E_TImode, 
E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern354 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern360 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[4] = x6;
  if (!const_0_to_7_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern358 (x1); /* [-1, 1] */

    case E_QImode:
      if (pattern359 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern369 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern369 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern381 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      return 0;

    case CONST_INT:
      operands[3] = x3;
      if (!const_0_to_31_operand (operands[3], E_QImode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const_0_to_31_operand (operands[2], E_QImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i3)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern416 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern425 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern430 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern435 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!vector_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!vector_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern441 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case VEC_SELECT:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!nonimm_or_0_operand (operands[2], E_V4SImode))
        return -1;
      x7 = XEXP (x1, 2);
      operands[3] = x7;
      return 0;

    case CONST_VECTOR:
      if (XVECLEN (x2, 0) != 2)
        return -1;
      x8 = XVECEXP (x2, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 2);
      operands[2] = x7;
      return 1;

    default:
      return -1;
    }
}

int
pattern452 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CONST_VECTOR
      || XVECLEN (x2, 0) != 8
      || GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x2, 0, 4);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x2, 0, 5);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x2, 0, 6);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XVECEXP (x2, 0, 7);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x11 = XEXP (x1, 0);
  if (GET_MODE (x11) != E_V8QImode)
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !permvar_truncate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern471 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern469 (x1); /* [-1, 11] */

    case IOR:
      res = pattern469 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    case XOR:
      res = pattern469 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern470 (x1, 
E_V64QImode) != 0)
            return -1;
          return 36;

        case E_V32QImode:
          if (pattern470 (x1, 
E_V32QImode) != 0)
            return -1;
          return 37;

        case E_V16QImode:
          if (pattern470 (x1, 
E_V16QImode) != 0)
            return -1;
          return 38;

        case E_V32HImode:
          if (pattern470 (x1, 
E_V32HImode) != 0)
            return -1;
          return 39;

        case E_V16HImode:
          if (pattern470 (x1, 
E_V16HImode) != 0)
            return -1;
          return 40;

        case E_V8HImode:
          if (pattern470 (x1, 
E_V8HImode) != 0)
            return -1;
          return 41;

        case E_V16SImode:
          if (pattern470 (x1, 
E_V16SImode) != 0)
            return -1;
          return 42;

        case E_V8SImode:
          if (pattern470 (x1, 
E_V8SImode) != 0)
            return -1;
          return 43;

        case E_V4SImode:
          if (pattern470 (x1, 
E_V4SImode) != 0)
            return -1;
          return 44;

        case E_V8DImode:
          if (pattern470 (x1, 
E_V8DImode) != 0)
            return -1;
          return 45;

        case E_V4DImode:
          if (pattern470 (x1, 
E_V4DImode) != 0)
            return -1;
          return 46;

        case E_V2DImode:
          if (pattern470 (x1, 
E_V2DImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern484 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return pattern483 (x6); /* [-1, 2] */
}

int
pattern488 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !x86_64_general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !x86_64_general_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern495 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!nonimmediate_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern504 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          return 0;

        case UNSPEC:
          return 1;

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      res = pattern503 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern510 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern509 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern514 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !nonimmediate_operand (operands[1], E_SImode)
      || !x86_64_general_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 174)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern516 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern516 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern516 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern516 (x5, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern531 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern535 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x2), 0))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          return pattern533 (x1); /* [-1, 3] */

        case PLUS:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          res = pattern534 (x1);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        case MINUS:
          x4 = XEXP (x3, 0);
          operands[3] = x4;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern534 (x1);
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    case AND:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      res = pattern533 (x1);
      if (res >= 0)
        return res + 10; /* [10, 13] */
      return -1;

    case PLUS:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      res = pattern534 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case MINUS:
      x3 = XEXP (x2, 0);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      res = pattern534 (x1);
      if (res >= 0)
        return res + 17; /* [17, 19] */
      return -1;

    default:
      return -1;
    }
}

int
pattern563 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern571 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern570 (x1, 
E_V32HImode, 
E_SImode, 
i1); /* [-1, 0] */

    case E_V16HImode:
      if (pattern570 (x1, 
E_V16HImode, 
E_HImode, 
i2) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern570 (x1, 
E_V8HImode, 
E_QImode, 
i3) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern580 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    case E_V8SFmode:
      if (!vector_operand (operands[1], E_V8SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern586 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[4] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern583 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern583 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern583 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern583 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern583 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern583 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern583 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern583 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern583 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern585 (x1);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern607 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern611 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  return 0;
}

int
pattern645 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCZmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCZmode
      || !register_operand (operands[0], E_V2DImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_V2DImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!memory_operand (operands[2], E_BLKmode))
    return -1;
  x9 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XVECEXP (x5, 0, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

int
pattern662 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  return 0;
}

int
pattern669 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      return 0;

    case PARALLEL:
      return 1;

    default:
      return -1;
    }
}

int
pattern676 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern682 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern688 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !sse_comparison_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern695 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern704 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 59)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x1, 1);
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x2, 0, 1);
      operands[2] = x7;
      switch (GET_MODE (x1))
        {
        case E_V32QImode:
          return pattern703 (x2, 
E_V32QImode, 
E_SImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern703 (x2, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (x1))
        {
        case E_V16QImode:
          if (!vector_all_ones_operand (operands[2], E_V16QImode)
              || !const0_operand (operands[3], E_V16QImode)
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        case E_V32QImode:
          if (!vector_all_ones_operand (operands[2], E_V32QImode)
              || !const0_operand (operands[3], E_V32QImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern730 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern749 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern758 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 17
          || GET_MODE (x2) != E_CCmode)
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 174)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        case E_SImode:
          return 3;

        case E_DImode:
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern763 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern767 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V2BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern636 (x5, 
E_V2BFmode); /* [-1, 0] */

    case E_V2HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern636 (x5, 
E_V2HFmode) != 0)
        return -1;
      return 1;

    case E_V32BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V32BFmode) != 0)
        return -1;
      return 2;

    case E_V16BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16BFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V32HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V32HFmode) != 0)
        return -1;
      return 5;

    case E_V16HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16HFmode) != 0)
        return -1;
      return 6;

    case E_V8HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8HFmode) != 0)
        return -1;
      return 7;

    case E_V16SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16SFmode) != 0)
        return -1;
      return 8;

    case E_V8SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8SFmode) != 0)
        return -1;
      return 9;

    case E_V4SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V4SFmode) != 0)
        return -1;
      return 10;

    case E_V8DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8DFmode) != 0)
        return -1;
      return 11;

    case E_V4DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V4DFmode) != 0)
        return -1;
      return 12;

    case E_V2DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V2DFmode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern795 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern805 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern812 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8HFmode
      || !nonimm_or_0_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!vector_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!vector_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!vector_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern821 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  operands[3] = x2;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[5] = x4;
  if (!const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern831 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern836 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern841 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != CONST_VECTOR
      || XVECLEN (x4, 0) != 2
      || GET_MODE (x4) != E_V2SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || GET_MODE (x2) != E_V2SImode
      || !nonimmediate_operand (operands[1], E_V2DFmode))
    return -1;
  return pattern441 (x2); /* [-1, 1] */
}

int
pattern847 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern852 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  return 0;
}

int
pattern873 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      return pattern872 (x1); /* [-1, 3] */

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 1);
      x7 = XEXP (x6, 0);
      switch (GET_MODE (x7))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !general_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_QImode))
            return -1;
          return 4;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !general_operand (operands[2], E_HImode)
              || !scratch_operand (operands[0], E_HImode))
            return -1;
          return 5;

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !x86_64_general_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 6;

        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !x86_64_general_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern889 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[3], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!nonimm_or_0_operand (operands[1], E_V16QImode)
              || !nonimm_or_0_operand (operands[2], E_V16QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!nonimm_or_0_operand (operands[1], E_V16HImode)
              || !nonimm_or_0_operand (operands[2], E_V16HImode))
            return -1;
          return 1;

        case E_V16SImode:
          if (!nonimm_or_0_operand (operands[1], E_V16SImode)
              || !nonimm_or_0_operand (operands[2], E_V16SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!nonimm_or_0_operand (operands[1], E_V8HImode)
              || !nonimm_or_0_operand (operands[2], E_V8HImode))
            return -1;
          return 3;

        case E_V8SImode:
          if (!nonimm_or_0_operand (operands[1], E_V8SImode)
              || !nonimm_or_0_operand (operands[2], E_V8SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!nonimm_or_0_operand (operands[1], E_V4SImode)
              || !nonimm_or_0_operand (operands[2], E_V4SImode))
            return -1;
          return 5;

        case E_V8DImode:
          if (!nonimm_or_0_operand (operands[1], E_V8DImode)
              || !nonimm_or_0_operand (operands[2], E_V8DImode))
            return -1;
          return 6;

        case E_V4DImode:
          if (!nonimm_or_0_operand (operands[1], E_V4DImode)
              || !nonimm_or_0_operand (operands[2], E_V4DImode))
            return -1;
          return 7;

        case E_V2DImode:
          if (!nonimm_or_0_operand (operands[1], E_V2DImode)
              || !nonimm_or_0_operand (operands[2], E_V2DImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern910 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern915 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!nonimmediate_operand (x5, i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (!nonimmediate_operand (x6, i1))
    return -1;
  return 0;
}

int
pattern927 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern937 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern944 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern953 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != SUBREG
          || maybe_ne (SUBREG_BYTE (x7), 0)
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          return pattern952 (x1); /* [-1, 4] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern967 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern974 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode)
          || !const_0_to_3_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern980 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern989 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern988 (x2); /* [-1, 11] */
}

int
pattern996 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1005 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1012 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1020 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i4
      || !vector_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1026 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V8HFmode)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 223
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 2);
  if (XWINT (x6, 0) != 3LL
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || GET_MODE (x3) != E_V8HFmode)
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  operands[1] = x7;
  if (!nonimmediate_operand (operands[1], E_V8HFmode))
    return -1;
  x8 = XVECEXP (x4, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
    return -1;
  x10 = XVECEXP (x5, 0, 0);
  operands[4] = x10;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  operands[5] = x11;
  if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
    return -1;
  x12 = XEXP (x2, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern1043 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0LL:
      x3 = XVECEXP (x1, 0, 1);
      switch (XWINT (x3, 0))
        {
        case 1LL:
          return 0;

        case 2LL:
          return 1;

        default:
          return -1;
        }

    case 1LL:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3LL)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (XWINT (x4, 0) != 5LL)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (XWINT (x5, 0) != 7LL)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1054 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  return pattern300 (x1); /* [-1, 1] */
}

int
pattern1066 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x1, 1);
          if (GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x3 = XEXP (x1, 1);
          if (GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          return 1;

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          x3 = XEXP (x1, 1);
          if (GET_MODE (x3) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          x3 = XEXP (x1, 1);
          if (GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x3 = XEXP (x1, 1);
      res = pattern320 (x3);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1090 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || !ix86_comparison_operator (operands[1], E_VOIDmode)
      || !register_operand (operands[2], E_QImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern1096 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!ix86_carry_flag_operator (operands[2], E_QImode)
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!ix86_carry_flag_operator (operands[2], E_HImode)
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1107 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern1120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      switch (XWINT (x4, 0))
        {
        case 64LL:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (!rtx_equal_p (x9, operands[2]))
            return -1;
          return 0;

        case 32LL:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
      if (pattern1133 (x1) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1150 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1157 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!general_reg_operand (operands[1], E_QImode)
          || !nonimmediate_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!general_reg_operand (operands[1], E_HImode)
          || !nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1172 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !ix86_carry_flag_unset_operator (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !ix86_carry_flag_unset_operator (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1180 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  operands[5] = x3;
  if (!const_0_to_31_operand (operands[5], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      return pattern1187 (x1, 
E_V8SFmode, 
E_V8SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern1187 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4DImode:
      if (pattern1187 (x1, 
E_V4DFmode, 
E_V4DImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern1187 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern1202 (x1, 
E_HImode, 
E_V16SImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V8SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8SImode
          || !nonimm_or_0_operand (operands[2], E_V8SImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 1;

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (pattern1202 (x1, 
E_QImode, 
E_V4SImode, 
E_V4DFmode) != 0)
        return -1;
      return 3;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8DImode
          || !nonimm_or_0_operand (operands[2], E_V8DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 4;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4DImode
          || !nonimm_or_0_operand (operands[2], E_V4DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[1], E_V4DFmode))
            return -1;
          return 6;

        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1254 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !vector_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1262 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1268 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1270 (x4, 
i1); /* [-1, 0] */
}

int
pattern1290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1297 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_MODE (x6))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1316 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1316 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1316 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1329 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern1341 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SImode)
      || GET_MODE (x1) != E_V8SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V8SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8SImode
      || !nonimm_or_0_operand (operands[2], E_V8SImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1364 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1375 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !mask_reg_operand (operands[1], i1)
      || !mask_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1384 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 0;

        case E_V4SFmode:
          return 1;

        case E_V2DFmode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x4;
      x5 = XEXP (x3, 2);
      operands[5] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[6] = x6;
      x7 = XEXP (x2, 1);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1403 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1420 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x9, 1);
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x13, 1);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern1432 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_unset_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1445 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8SFmode
      || !vector_operand (operands[1], E_V4SFmode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!nonimm_or_0_operand (operands[2], E_V4SFmode))
    return -1;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

int
pattern1454 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || pattern1453 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1461 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern1472 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], i2)
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1482 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1490 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1498 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 1);
  if (!nonimm_or_0_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern1505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1515 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x2, 0);
      return pattern1523 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x3 = XEXP (x2, 0);
      if (pattern1523 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1535 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1544 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1554 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern1562 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1561 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1561 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1573 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1572 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1572 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1584 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1592 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1598 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1598 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1609 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !const_int_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[4]))
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[5]))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1625 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      if (!register_operand (operands[2], E_V16SImode)
          || !register_operand (operands[6], E_HImode)
          || !register_operand (operands[3], E_V16SImode)
          || !scratch_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (pattern1624 (
E_QImode, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1634 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1641 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1649 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[2], i1)
      || pattern1648 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1658 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1667 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[5], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1674 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], i1)
      || !register_operand (operands[5], i1)
      || !register_operand (operands[6], i1)
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1678 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1684 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  operands[4] = x4;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != COMPARE
      || GET_MODE (x10) != E_CCZmode)
    return -1;
  x11 = XEXP (x9, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCZmode)
    return -1;
  x12 = XEXP (x10, 0);
  operands[5] = x12;
  return 0;
}

int
pattern1693 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1703 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsib_mem_operator (operands[6], i3)
      || !register_operand (operands[4], i2)
      || !scratch_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1714 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i2
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  return 0;
}

int
pattern1722 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x2, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  return 0;
}

int
pattern1729 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[6], i2))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1
      || !ix86_carry_flag_operator (operands[5], i1))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  return pattern1728 (x11, 
i1); /* [-1, 0] */
}

int
pattern1738 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!nonimmediate_operand (operands[1], E_V8HImode))
    return -1;
  x7 = XEXP (x3, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!nonimmediate_operand (operands[2], E_V8HImode))
    return -1;
  x10 = XEXP (x1, 1);
  operands[3] = x10;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x11 = XEXP (x2, 1);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  x14 = XEXP (x13, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x11, 1);
  x16 = XEXP (x15, 0);
  x17 = XEXP (x16, 0);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x4) != E_CCFPmode)
    return -1;
  switch (GET_CODE (x4))
    {
    case COMPARE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x6;
          switch (GET_MODE (operands[1]))
            {
            case E_XFmode:
              if (!register_operand (operands[1], E_XFmode)
                  || !reg_or_0_operand (operands[2], E_XFmode)
                  || !
#line 1936 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 34; /* *cmpxf_i387 */

            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !nonimm_or_0_operand (operands[2], E_SFmode)
                  || !
#line 1949 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 35; /* *cmpsf_i387 */

            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !nonimm_or_0_operand (operands[2], E_DFmode)
                  || !
#line 1949 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 36; /* *cmpdf_i387 */

            default:
              return -1;
            }

        case FLOAT:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              switch (pattern1162 (x6, 
E_SFmode))
                {
                case 0:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 37; /* *cmpsf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 40; /* *cmpsf_si_i387 */

                default:
                  return -1;
                }

            case E_DFmode:
              switch (pattern1162 (x6, 
E_DFmode))
                {
                case 0:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 38; /* *cmpdf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 41; /* *cmpdf_si_i387 */

                default:
                  return -1;
                }

            case E_XFmode:
              switch (pattern1162 (x6, 
E_XFmode))
                {
                case 0:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 39; /* *cmpxf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 42; /* *cmpxf_si_i387 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 26)
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x8) != COMPARE
          || GET_MODE (x8) != E_CCFPmode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !register_operand (operands[2], E_SFmode)
              || !
#line 1981 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 43; /* *cmpusf_i387 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !register_operand (operands[2], E_DFmode)
              || !
#line 1981 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 44; /* *cmpudf_i387 */

        case E_XFmode:
          if (!register_operand (operands[1], E_XFmode)
              || !register_operand (operands[2], E_XFmode)
              || !
#line 1981 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 45; /* *cmpuxf_i387 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 18
          || !
#line 23710 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
        return -1;
      return 1370; /* x86_fnstsw_1 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (push_operand (operands[0], E_DImode)
          && general_no_elim_operand (operands[1], E_DImode))
        return 64; /* *pushdi2 */
      if (nonimmediate_operand (operands[0], E_DImode))
        {
          if (pop_operand (operands[1], E_DImode)
              && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode))
            return 71; /* *popdi1 */
          if (general_operand (operands[1], E_DImode)
              && 
#line 2584 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
            return 86; /* *movdi_internal */
        }
      break;

    case E_SImode:
      if (push_operand (operands[0], E_SImode)
          && general_no_elim_operand (operands[1], E_SImode))
        return 65; /* *pushsi2 */
      if (nonimmediate_operand (operands[0], E_SImode)
          && pop_operand (operands[1], E_SImode)
          && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode))
        return 70; /* *popsi1 */
      if (pnum_clobbers != NULL
          && const0_operand (operands[1], E_SImode))
        {
          if (register_operand (operands[0], E_SImode)
              && 
#line 2424 "../../../gcc/config/i386/i386.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 78; /* *movsi_xor */
            }
          if (memory_operand (operands[0], E_SImode)
              && 
#line 2434 "../../../gcc/config/i386/i386.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 80; /* *movsi_and */
            }
        }
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          if (pnum_clobbers != NULL
              && constm1_operand (operands[1], E_SImode)
              && 
#line 2444 "../../../gcc/config/i386/i386.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 82; /* *movsi_or */
            }
          if (general_operand (operands[1], E_SImode)
              && 
#line 2824 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
            return 87; /* *movsi_internal */
        }
      break;

    case E_QImode:
      if (push_operand (operands[0], E_QImode)
          && nonmemory_no_elim_operand (operands[1], E_QImode))
        return 66; /* *pushqi2 */
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 3144 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 89; /* *movqi_internal */
      break;

    case E_HImode:
      if (push_operand (operands[0], E_HImode)
          && nonmemory_no_elim_operand (operands[1], E_HImode))
        return 67; /* *pushhi2 */
      if (pnum_clobbers != NULL
          && memory_operand (operands[0], E_HImode)
          && const0_operand (operands[1], E_HImode)
          && 
#line 2434 "../../../gcc/config/i386/i386.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 79; /* *movhi_and */
        }
      if (nonimmediate_operand (operands[0], E_HImode))
        {
          if (pnum_clobbers != NULL
              && constm1_operand (operands[1], E_HImode)
              && 
#line 2444 "../../../gcc/config/i386/i386.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 81; /* *movhi_or */
            }
          if (general_operand (operands[1], E_HImode)
              && 
#line 2981 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
            return 88; /* *movhi_internal */
        }
      break;

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && general_operand (operands[1], E_TImode)
          && 
#line 2500 "../../../gcc/config/i386/i386.md"
((TARGET_64BIT
    && !(MEM_P (operands[0]) && MEM_P (operands[1])))
   || (TARGET_SSE
       && nonimmediate_or_sse_const_operand (operands[1], TImode)
       && (register_operand (operands[0], TImode)
	   || register_operand (operands[1], TImode)))))
        return 85; /* *movti_internal */
      break;

    case E_TFmode:
      if (push_operand (operands[0], E_TFmode)
          && general_no_elim_operand (operands[1], E_TFmode)
          && 
#line 3765 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT || TARGET_SSE))
        return 128; /* *pushtf */
      if (nonimmediate_operand (operands[0], E_TFmode)
          && general_operand (operands[1], E_TFmode)
          && 
#line 4034 "../../../gcc/config/i386/i386.md"
((TARGET_64BIT || TARGET_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && (lra_in_progress || reload_completed
       || !CONST_DOUBLE_P (operands[1])
       || (standard_sse_constant_p (operands[1], TFmode) == 1
	   && !memory_operand (operands[0], TFmode))
       || (!TARGET_MEMORY_MISMATCH_STALL
	   && memory_operand (operands[0], TFmode)))))
        return 139; /* *movtf_internal */
      break;

    case E_XFmode:
      if (push_operand (operands[0], E_XFmode)
          && general_no_elim_operand (operands[1], E_XFmode))
        return 129; /* *pushxf */
      if (nonimmediate_operand (operands[0], E_XFmode)
          && general_operand (operands[1], E_XFmode)
          && 
#line 4094 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && (lra_in_progress || reload_completed
       || !CONST_DOUBLE_P (operands[1])
       || ((optimize_function_for_size_p (cfun)
	    || (ix86_cmodel == CM_LARGE || ix86_cmodel == CM_LARGE_PIC))
	   && standard_80387_constant_p (operands[1]) > 0
	   && !memory_operand (operands[0], XFmode))
       || (!TARGET_MEMORY_MISMATCH_STALL
	   && memory_operand (operands[0], XFmode))
       || !TARGET_HARD_XF_REGS)))
        return 140; /* *movxf_internal */
      break;

    case E_DFmode:
      if (push_operand (operands[0], E_DFmode)
          && general_no_elim_operand (operands[1], E_DFmode))
        return 130; /* *pushdf */
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode)
          && 
#line 4166 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && (lra_in_progress || reload_completed
       || !CONST_DOUBLE_P (operands[1])
       || ((optimize_function_for_size_p (cfun)
	    || (ix86_cmodel == CM_LARGE || ix86_cmodel == CM_LARGE_PIC))
	   && IS_STACK_MODE (DFmode)
	   && standard_80387_constant_p (operands[1]) > 0
	   && !memory_operand (operands[0], DFmode))
       || (TARGET_SSE2 && TARGET_SSE_MATH
	   && standard_sse_constant_p (operands[1], DFmode) == 1
	   && !memory_operand (operands[0], DFmode))
       || ((TARGET_64BIT || !TARGET_MEMORY_MISMATCH_STALL)
	   && memory_operand (operands[0], DFmode))
       || !TARGET_HARD_DF_REGS)))
        return 141; /* *movdf_internal */
      break;

    case E_HFmode:
      if (push_operand (operands[0], E_HFmode)
          && general_no_elim_operand (operands[1], E_HFmode))
        return 131; /* *pushhf */
      if (nonimmediate_operand (operands[0], E_HFmode)
          && general_operand (operands[1], E_HFmode)
          && 
#line 4478 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
  && (lra_in_progress
      || reload_completed
      || !CONST_DOUBLE_P (operands[1])
      || (TARGET_SSE2
	  && standard_sse_constant_p (operands[1], HFmode) == 1)
      || memory_operand (operands[0], HFmode))))
        return 143; /* *movhf_internal */
      break;

    case E_BFmode:
      if (push_operand (operands[0], E_BFmode)
          && general_no_elim_operand (operands[1], E_BFmode))
        return 132; /* *pushbf */
      if (nonimmediate_operand (operands[0], E_BFmode)
          && general_operand (operands[1], E_BFmode)
          && 
#line 4478 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
  && (lra_in_progress
      || reload_completed
      || !CONST_DOUBLE_P (operands[1])
      || (TARGET_SSE2
	  && standard_sse_constant_p (operands[1], BFmode) == 1)
      || memory_operand (operands[0], BFmode))))
        return 144; /* *movbf_internal */
      break;

    case E_SFmode:
      if (push_operand (operands[0], E_SFmode)
          && general_no_elim_operand (operands[1], E_SFmode))
        return 138; /* *pushsf */
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode)
          && 
#line 4343 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && (lra_in_progress || reload_completed
       || !CONST_DOUBLE_P (operands[1])
       || ((optimize_function_for_size_p (cfun)
	    || (ix86_cmodel == CM_LARGE || ix86_cmodel == CM_LARGE_PIC))
	   && IS_STACK_MODE (SFmode)
	   && standard_80387_constant_p (operands[1]) > 0)
       || (TARGET_SSE && TARGET_SSE_MATH
	   && standard_sse_constant_p (operands[1], SFmode) == 1)
       || memory_operand (operands[0], SFmode)
       || !TARGET_HARD_SF_REGS)))
        return 142; /* *movsf_internal */
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && nonimm_or_0_operand (operands[1], E_V8QImode)
          && 
#line 189 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1603; /* *movv8qi_internal */
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && nonimm_or_0_operand (operands[1], E_V4HImode)
          && 
#line 189 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1604; /* *movv4hi_internal */
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && nonimm_or_0_operand (operands[1], E_V2SImode)
          && 
#line 189 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1605; /* *movv2si_internal */
      break;

    case E_V1DImode:
      if (nonimmediate_operand (operands[0], E_V1DImode)
          && nonimm_or_0_operand (operands[1], E_V1DImode)
          && 
#line 189 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1606; /* *movv1di_internal */
      break;

    case E_V2SFmode:
      if (nonimmediate_operand (operands[0], E_V2SFmode)
          && nonimm_or_0_operand (operands[1], E_V2SFmode)
          && 
#line 189 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1607; /* *movv2sf_internal */
      break;

    case E_V4HFmode:
      if (nonimmediate_operand (operands[0], E_V4HFmode)
          && nonimm_or_0_operand (operands[1], E_V4HFmode)
          && 
#line 189 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1608; /* *movv4hf_internal */
      break;

    case E_V4BFmode:
      if (nonimmediate_operand (operands[0], E_V4BFmode)
          && nonimm_or_0_operand (operands[1], E_V4BFmode)
          && 
#line 189 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1609; /* *movv4bf_internal */
      break;

    case E_V4QImode:
      if (nonimmediate_operand (operands[0], E_V4QImode)
          && general_operand (operands[1], E_V4QImode)
          && 
#line 344 "../../../gcc/config/i386/mmx.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1610; /* *movv4qi_internal */
      if (memory_operand (operands[0], E_V4QImode)
          && x86_64_const_vector_operand (operands[1], E_V4QImode))
        return 1616; /* *movv4qi_imm */
      break;

    case E_V2HImode:
      if (nonimmediate_operand (operands[0], E_V2HImode)
          && general_operand (operands[1], E_V2HImode)
          && 
#line 344 "../../../gcc/config/i386/mmx.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1611; /* *movv2hi_internal */
      if (memory_operand (operands[0], E_V2HImode)
          && x86_64_const_vector_operand (operands[1], E_V2HImode))
        return 1617; /* *movv2hi_imm */
      break;

    case E_V1SImode:
      if (nonimmediate_operand (operands[0], E_V1SImode)
          && general_operand (operands[1], E_V1SImode)
          && 
#line 344 "../../../gcc/config/i386/mmx.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1612; /* *movv1si_internal */
      break;

    case E_V2HFmode:
      if (nonimmediate_operand (operands[0], E_V2HFmode)
          && general_operand (operands[1], E_V2HFmode)
          && 
#line 344 "../../../gcc/config/i386/mmx.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1613; /* *movv2hf_internal */
      if (memory_operand (operands[0], E_V2HFmode)
          && x86_64_const_vector_operand (operands[1], E_V2HFmode))
        return 1618; /* *movv2hf_imm */
      break;

    case E_V2BFmode:
      if (nonimmediate_operand (operands[0], E_V2BFmode)
          && general_operand (operands[1], E_V2BFmode)
          && 
#line 344 "../../../gcc/config/i386/mmx.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1614; /* *movv2bf_internal */
      break;

    case E_V2QImode:
      if (memory_operand (operands[0], E_V2QImode)
          && x86_64_const_vector_operand (operands[1], E_V2QImode))
        return 1615; /* *movv2qi_imm */
      if (nonimmediate_operand (operands[0], E_V2QImode)
          && general_operand (operands[1], E_V2QImode)
          && 
#line 472 "../../../gcc/config/i386/mmx.md"
(!(MEM_P (operands[0]) && MEM_P (operands[1]))))
        return 1619; /* *movv2qi_internal */
      if (push_operand (operands[0], E_V2QImode)
          && nonmemory_no_elim_operand (operands[1], E_V2QImode))
        return 1620; /* *pushv2qi2 */
      break;

    case E_P2QImode:
      if (nonimmediate_operand (operands[0], E_P2QImode)
          && nonimmediate_operand (operands[1], E_P2QImode)
          && 
#line 30958 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
        return 9688; /* *movp2qi_internal */
      break;

    case E_P2HImode:
      if (nonimmediate_operand (operands[0], E_P2HImode)
          && nonimmediate_operand (operands[1], E_P2HImode)
          && 
#line 30958 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
        return 9689; /* *movp2hi_internal */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!x86_64_movabs_operand (operands[0], E_DImode))
    return -1;
  operands[1] = x3;
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonmemory_operand (operands[1], E_QImode)
          || !
#line 3295 "../../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 0)))
        return -1;
      return 90; /* *movabsqi_1 */

    case E_HImode:
      if (!nonmemory_operand (operands[1], E_HImode)
          || !
#line 3295 "../../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 0)))
        return -1;
      return 91; /* *movabshi_1 */

    case E_SImode:
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 3295 "../../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 0)))
        return -1;
      return 92; /* *movabssi_1 */

    case E_DImode:
      if (!nonmemory_operand (operands[1], E_DImode)
          || !
#line 3295 "../../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 0)))
        return -1;
      return 93; /* *movabsdi_1 */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern237 (x3, pnum_clobbers, 
E_SImode, 
E_DImode) == 0)
            {
              *pnum_clobbers = 2;
              return 153; /* extendsidi2_1 */
            }
          break;

        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (nonimmediate_operand (operands[1], E_HImode))
                    return 154; /* extendhisi2 */
                  break;

                case E_QImode:
                  if (nonimmediate_operand (operands[1], E_QImode))
                    return 155; /* extendqisi2 */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && GET_MODE (x3) == E_HImode
              && nonimmediate_operand (operands[1], E_QImode))
            return 156; /* extendqihi2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || pattern236 (x4) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          switch (pattern1243 (x3, 
E_HImode))
            {
            case 0:
              return 157; /* *extendqihi_ext_1 */

            case 1:
              return 158; /* *extendqihi_ext_1 */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern1243 (x3, 
E_SImode))
            {
            case 0:
              return 159; /* *extendqisi_ext_1 */

            case 1:
              return 160; /* *extendqisi_ext_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_TRUNCATE:
      if (GET_MODE (x4) != E_V2HImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != FIX
          || GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_V2SFmode)
          || !
#line 1612 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
        return -1;
      return 1642; /* mmx_pf2iw */

    case VEC_SELECT:
      if (pattern83 (x4, 
E_V2QImode) != 0
          || !register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 5101 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
        return -1;
      return 1821; /* sse4_1_sign_extendv2qiv2hi2 */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern366 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 6062 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (!(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
       || TARGET_MIX_SSE_I387)))
                return -1;
              return 191; /* floathisf2 */

            case 1:
              if (!
#line 6092 "../../../gcc/config/i386/i386.md"
((TARGET_80387 && X87_ENABLE_FLOAT (SFmode, SImode))
   || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
                return -1;
              return 196; /* *floatsisf2 */

            case 2:
              if (!
#line 6145 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)))
                return -1;
              return 200; /* *floatdisf2_i387 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern366 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 6062 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (!(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
       || TARGET_MIX_SSE_I387)))
                return -1;
              return 192; /* floathidf2 */

            case 1:
              if (!
#line 6092 "../../../gcc/config/i386/i386.md"
((TARGET_80387 && X87_ENABLE_FLOAT (DFmode, SImode))
   || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 197; /* *floatsidf2 */

            case 2:
              if (!
#line 6145 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)))
                return -1;
              return 201; /* *floatdidf2_i387 */

            default:
              return -1;
            }

        case E_XFmode:
          switch (pattern366 (x3, 
E_XFmode))
            {
            case 0:
              if (!
#line 6062 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (!(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
       || TARGET_MIX_SSE_I387)))
                return -1;
              return 193; /* floathixf2 */

            case 1:
              if (!
#line 6074 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 194; /* floatsixf2 */

            case 2:
              if (!
#line 6074 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 195; /* floatdixf2 */

            default:
              return -1;
            }

        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || GET_MODE (x3) != E_HFmode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 6136 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 198; /* floatsihf2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != TRUNCATE
          || GET_MODE (x5) != E_V2HImode
          || !register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_V2SImode)
          || !
#line 1624 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
        return -1;
      return 1643; /* mmx_pi2fw */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      res = recog_32 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0))
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (pattern1163 (x1))
            {
            case 0:
              if (
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 593; /* *andqi_exthi_1_slp */
                }
              break;

            case 1:
              if (
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 596; /* *andqi_extsi_1_slp */
                }
              break;

            case 2:
              if ((
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 599; /* *andqi_extdi_1_slp */
                }
              break;

            case 3:
              *pnum_clobbers = 1;
              return 615; /* *andqi_exthi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 618; /* *andqi_extsi_0 */

            default:
              break;
            }
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != SUBREG)
            return -1;
          switch (pattern1165 (x1))
            {
            case 0:
              if (!
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 602; /* *andqi_exthi_2_slp */

            case 1:
              if (!
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 605; /* *andqi_extsi_2_slp */

            case 2:
              if (!(
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 608; /* *andqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 621; /* *andqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 624; /* *andqi_ext2si_0 */

            default:
              return -1;
            }

        case ROTATE:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return -1;
          x9 = XEXP (x1, 0);
          operands[0] = x9;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1244 (x2, 
E_QImode) != 0
                  || !
#line 18942 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1160; /* *btrqi_1 */

            case E_HImode:
              if (pattern1244 (x2, 
E_HImode) != 0
                  || !
#line 18942 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1161; /* *btrhi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pnum_clobbers != NULL
              && pattern683 (x2, 
E_TImode) == 0
              && (
#line 13330 "../../../gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 656; /* *andnti3_doubleword */
            }
          break;

        case E_QImode:
          if (pnum_clobbers != NULL
              && pattern556 (x2, 
E_QImode) == 0
              && 
#line 13362 "../../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            {
              *pnum_clobbers = 1;
              return 658; /* *andnqi_1 */
            }
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && pattern556 (x2, 
E_HImode) == 0
              && 
#line 13362 "../../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            {
              *pnum_clobbers = 1;
              return 659; /* *andnhi_1 */
            }
          break;

        case E_V2BFmode:
          if (pattern556 (x2, 
E_V2BFmode) == 0
              && 
#line 2568 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1655; /* *mmx_andnotv2bf3 */
          break;

        case E_V2HFmode:
          if (pattern556 (x2, 
E_V2HFmode) == 0
              && 
#line 2568 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1656; /* *mmx_andnotv2hf3 */
          break;

        case E_V8QImode:
          if (pattern557 (x2, 
E_V8QImode) == 0
              && 
#line 4592 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1786; /* mmx_andnotv8qi3 */
          break;

        case E_V4HImode:
          if (pattern557 (x2, 
E_V4HImode) == 0
              && 
#line 4592 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1787; /* mmx_andnotv4hi3 */
          break;

        case E_V2SImode:
          if (pattern557 (x2, 
E_V2SImode) == 0
              && 
#line 4592 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1788; /* mmx_andnotv2si3 */
          break;

        case E_V4QImode:
          if (pnum_clobbers != NULL
              && pattern556 (x2, 
E_V4QImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1789; /* *andnotv4qi3 */
            }
          break;

        case E_V2QImode:
          if (pnum_clobbers != NULL
              && pattern556 (x2, 
E_V2QImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1790; /* *andnotv2qi3 */
            }
          break;

        case E_V2HImode:
          if (pnum_clobbers != NULL
              && pattern556 (x2, 
E_V2HImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1791; /* *andnotv2hi3 */
            }
          break;

        case E_BFmode:
          if (pattern556 (x2, 
E_BFmode) == 0
              && 
#line 5531 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3254; /* *andnotbf3 */
          break;

        case E_HFmode:
          if (pattern556 (x2, 
E_HFmode) == 0
              && 
#line 5531 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3255; /* *andnothf3 */
          break;

        case E_SFmode:
          if (pattern556 (x2, 
E_SFmode) == 0
              && 
#line 5531 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3256; /* *andnotsf3 */
          break;

        case E_DFmode:
          if (pattern556 (x2, 
E_DFmode) == 0
              && (
#line 5531 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../../gcc/config/i386/i386.md"
(TARGET_SSE2)))
            return 3257; /* *andnotdf3 */
          break;

        case E_TFmode:
          if (pattern558 (x2, 
E_TFmode) == 0
              && 
#line 5601 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3258; /* *andnottf3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_QImode)
          || GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != LSHIFTRT
          || x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      x11 = XEXP (x7, 1);
      operands[2] = x11;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1183; /* *btsi_setncqi */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1184; /* *btdi_setncqi */

        default:
          return -1;
        }

    case UNSPEC:
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      switch (XVECLEN (x3, 0))
        {
        case 3:
          x12 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x3, 0, 0);
          operands[1] = x13;
          x14 = XVECEXP (x3, 0, 1);
          operands[2] = x14;
          switch (XINT (x3, 1))
            {
            case 59:
              operands[3] = x12;
              res = recog_33 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              if (XWINT (x12, 0) != 0LL)
                return -1;
              switch (pattern889 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2976; /* *avx512vl_eqv16qi3_mask_1 */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2988; /* *avx512vl_eqv16hi3_mask_1 */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3044; /* *avx512f_eqv16si3_mask_1 */

                case 3:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2992; /* *avx512vl_eqv8hi3_mask_1 */

                case 4:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3048; /* *avx512vl_eqv8si3_mask_1 */

                case 5:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3052; /* *avx512vl_eqv4si3_mask_1 */

                case 6:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3056; /* *avx512f_eqv8di3_mask_1 */

                case 7:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3060; /* *avx512vl_eqv4di3_mask_1 */

                case 8:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3064; /* *avx512vl_eqv2di3_mask_1 */

                default:
                  return -1;
                }

            case 157:
              if (XWINT (x12, 0) == 0LL)
                {
                  switch (pattern889 (x2))
                    {
                    case 0:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2978; /* *avx512vl_eqv16qi3_mask_1 */
                      break;

                    case 1:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2990; /* *avx512vl_eqv16hi3_mask_1 */
                      break;

                    case 2:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 3046; /* *avx512f_eqv16si3_mask_1 */
                      break;

                    case 3:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2994; /* *avx512vl_eqv8hi3_mask_1 */
                      break;

                    case 4:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3050; /* *avx512vl_eqv8si3_mask_1 */
                      break;

                    case 5:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3054; /* *avx512vl_eqv4si3_mask_1 */
                      break;

                    case 6:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 3058; /* *avx512f_eqv8di3_mask_1 */
                      break;

                    case 7:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3062; /* *avx512vl_eqv4di3_mask_1 */
                      break;

                    case 8:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4670 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3066; /* *avx512vl_eqv2di3_mask_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x12;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              switch (pattern976 (x2))
                {
                case 0:
                  switch (pattern684 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4596 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2998; /* avx512vl_ucmpv16qi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4596 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3004; /* avx512vl_ucmpv16hi3_mask */

                    case 2:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3068; /* avx512f_ucmpv16si3_mask */

                    default:
                      return -1;
                    }

                case 1:
                  switch (pattern685 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4596 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3006; /* avx512vl_ucmpv8hi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3070; /* avx512vl_ucmpv8si3_mask */

                    case 2:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3072; /* avx512vl_ucmpv4si3_mask */

                    case 3:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3074; /* avx512f_ucmpv8di3_mask */

                    case 4:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3076; /* avx512vl_ucmpv4di3_mask */

                    case 5:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3078; /* avx512vl_ucmpv2di3_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x13 = XVECEXP (x3, 0, 0);
          operands[1] = x13;
          x14 = XVECEXP (x3, 0, 1);
          operands[2] = x14;
          switch (XINT (x3, 1))
            {
            case 158:
              switch (pattern686 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7530; /* avx512vl_testmv16qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7534; /* avx512vl_testmv16hi3_mask */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7538; /* avx512f_testmv16si3_mask */

                case 3:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7536; /* avx512vl_testmv8hi3_mask */

                case 4:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7540; /* avx512vl_testmv8si3_mask */

                case 5:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7542; /* avx512vl_testmv4si3_mask */

                case 6:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7544; /* avx512f_testmv8di3_mask */

                case 7:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7546; /* avx512vl_testmv4di3_mask */

                case 8:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7548; /* avx512vl_testmv2di3_mask */

                default:
                  return -1;
                }

            case 159:
              switch (pattern686 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7554; /* avx512vl_testnmv16qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7558; /* avx512vl_testnmv16hi3_mask */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7562; /* avx512f_testnmv16si3_mask */

                case 3:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7560; /* avx512vl_testnmv8hi3_mask */

                case 4:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7564; /* avx512vl_testnmv8si3_mask */

                case 5:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7566; /* avx512vl_testnmv4si3_mask */

                case 6:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7568; /* avx512f_testnmv8di3_mask */

                case 7:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7570; /* avx512vl_testnmv4di3_mask */

                case 8:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7572; /* avx512vl_testnmv2di3_mask */

                default:
                  return -1;
                }

            case 193:
              if (!const_0_to_255_operand (operands[2], E_VOIDmode))
                return -1;
              x8 = XEXP (x2, 1);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                  operands[3] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern248 (x2, 
E_HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V16HFmode:
                          if (!vector_operand (operands[1], E_V16HFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16HFmode)) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                            return -1;
                          return 9357; /* avx512dq_fpclassv16hf_mask */

                        case E_V16SFmode:
                          if (!vector_operand (operands[1], E_V16SFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return -1;
                          return 9361; /* avx512dq_fpclassv16sf_mask */

                        default:
                          return -1;
                        }

                    case E_QImode:
                      if (pattern248 (x2, 
E_QImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V8HFmode:
                          if (!vector_operand (operands[1], E_V8HFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                            return -1;
                          return 9359; /* avx512dq_fpclassv8hf_mask */

                        case E_V8SFmode:
                          if (!vector_operand (operands[1], E_V8SFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9363; /* avx512dq_fpclassv8sf_mask */

                        case E_V4SFmode:
                          if (!vector_operand (operands[1], E_V4SFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9365; /* avx512dq_fpclassv4sf_mask */

                        case E_V8DFmode:
                          if (!vector_operand (operands[1], E_V8DFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return -1;
                          return 9367; /* avx512dq_fpclassv8df_mask */

                        case E_V4DFmode:
                          if (!vector_operand (operands[1], E_V4DFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9369; /* avx512dq_fpclassv4df_mask */

                        case E_V2DFmode:
                          if (!vector_operand (operands[1], E_V2DFmode)
                              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9371; /* avx512dq_fpclassv2df_mask */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x8, 0) != 1LL
                      || !register_operand (operands[0], E_QImode)
                      || GET_MODE (x2) != E_QImode
                      || GET_MODE (x3) != E_QImode)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V8HFmode:
                      if (!nonimmediate_operand (operands[1], E_V8HFmode)
                          || !(
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 9372; /* avx512dq_vmfpclassv8hf */

                    case E_V4SFmode:
                      if (!nonimmediate_operand (operands[1], E_V4SFmode)
                          || !
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode)))
                        return -1;
                      return 9374; /* avx512dq_vmfpclassv4sf */

                    case E_V2DFmode:
                      if (!nonimmediate_operand (operands[1], E_V2DFmode)
                          || !(
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 9376; /* avx512dq_vmfpclassv2df */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 214:
              if (GET_MODE (x3) != E_HImode
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !nonimmediate_operand (operands[2], E_V16QImode))
                return -1;
              x8 = XEXP (x2, 1);
              operands[3] = x8;
              if (!register_operand (operands[3], E_HImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9685; /* avx512vl_vpshufbitqmbv16qi_mask */

            case 262:
              if (!const_0_to_255_operand (operands[2], E_VOIDmode))
                return -1;
              x8 = XEXP (x2, 1);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern977 (x2, 
E_HImode, 
E_V16BFmode) != 0
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32448 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                    return -1;
                  return 10081; /* avx10_2_fpclassbf16_v16bf_mask */

                case E_QImode:
                  if (pattern977 (x2, 
E_QImode, 
E_V8BFmode) != 0
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32448 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                    return -1;
                  return 10083; /* avx10_2_fpclassbf16_v8bf_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (pattern85 (x4, 
E_QImode, 
193) != 0)
        return -1;
      x15 = XEXP (x3, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x16 = XVECEXP (x4, 0, 0);
      operands[1] = x16;
      x17 = XVECEXP (x4, 0, 1);
      operands[2] = x17;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 9373; /* avx512dq_vmfpclassv8hf_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode))))
            return -1;
          return 9375; /* avx512dq_vmfpclassv4sf_mask */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 9377; /* avx512dq_vmfpclassv2df_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = recog_73 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CLZ
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21272 "../../../gcc/config/i386/i386.md"
(!TARGET_LZCNT))
        return -1;
      *pnum_clobbers = 1;
      return 1256; /* bsr_1 */

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern253 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1173 (x3, 
E_SImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* subsi3_carry */

            case E_DImode:
              if (pattern1173 (x3, 
E_DImode) != 0
                  || !(
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* subdi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1101 (x3, 
E_SImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 481; /* *subsi3_eq */

            case E_DImode:
              if (pattern1101 (x3, 
E_DImode) != 0
                  || !(
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 482; /* *subdi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pnum_clobbers != NULL)
        {
          res = recog_76 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      if (!nonimmediate_operand (operands[3], E_SImode)
          || !
#line 26171 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 1449; /* *movsicc_noc */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LSHIFTRT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_MODE (x8) != E_DImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x8) != SIGN_EXTEND)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!nonimmediate_operand (operands[2], E_SImode)
          || !
#line 11223 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      *pnum_clobbers = 2;
      return 527; /* *smulsi3_highpart_1 */

    case ZERO_EXTEND:
      if (GET_CODE (x8) != ZERO_EXTEND)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!nonimmediate_operand (operands[2], E_SImode)
          || !
#line 11223 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      *pnum_clobbers = 2;
      return 528; /* *umulsi3_highpart_1 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern114 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && (
#line 14237 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 767; /* *negdi2_doubleword */
            }
          if ((
#line 14346 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 775; /* *negdi_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 14346 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 776; /* *negdi_1 */

        case 1:
          if (
#line 14346 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 773; /* *negsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 14346 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 774; /* *negsi_1 */

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern560 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 14644 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 807; /* *nabsdi2_doubleword */
            }
          if (!(
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 816; /* *nabsdi2_1 */

        case E_SImode:
          if (pattern560 (x3, 
E_SImode) != 0
              || !
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 815; /* *nabssi2_1 */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      *pnum_clobbers = 1;
      return 1447; /* *x86_movsicc_0_m1_neg */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers != NULL)
        {
          x2 = XEXP (x1, 1);
          if (pattern667 (x2, 
E_DImode, 
E_QImode) == 0)
            {
              *pnum_clobbers = 1;
              return 922; /* ashrdi3_doubleword */
            }
        }
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      if (const_int_operand (operands[2], E_QImode))
        {
          if ((
#line 17244 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 945; /* ashrdi3_cvt_nf */
          if (pnum_clobbers != NULL
              && (
#line 17244 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 946; /* ashrdi3_cvt */
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      if ((
#line 17323 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 951; /* *ashrdi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 17323 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 952; /* *ashrdi3_1 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern682 (x2, 
E_SImode) != 0)
        return -1;
      if (
#line 17323 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 949; /* *ashrsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 17323 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 950; /* *ashrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern22 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 18182 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1060; /* *rotlsi3_mask_1 */

    case 1:
      if (!(
#line 18182 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1062; /* *rotldi3_mask_1 */

    case 2:
      if (!
#line 18253 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1076; /* *rotlsi3_add_1 */

    case 3:
      if (!(
#line 18253 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1078; /* *rotldi3_add_1 */

    case 4:
      if (!
#line 18322 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1092; /* *rotlsi3_sub_1 */

    case 5:
      if (!(
#line 18322 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1094; /* *rotldi3_sub_1 */

    case 6:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern391 (x2, pnum_clobbers))
            {
            case 0:
              if (
#line 18142 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1052; /* *rotlsi3_mask */
                }
              break;

            case 1:
              if ((
#line 18142 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1054; /* *rotldi3_mask */
                }
              break;

            case 2:
              if (
#line 18217 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1068; /* *rotlsi3_add */
                }
              break;

            case 3:
              if ((
#line 18217 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1070; /* *rotldi3_add */
                }
              break;

            case 4:
              if (
#line 18286 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1084; /* *rotlsi3_sub */
                }
              break;

            case 5:
              if ((
#line 18286 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1086; /* *rotldi3_sub */
                }
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          if (pnum_clobbers != NULL)
            {
              operands[2] = x3;
              if (const_1_to_31_operand (operands[2], E_QImode)
                  && register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && register_operand (operands[1], E_DImode))
                {
                  *pnum_clobbers = 2;
                  return 1096; /* ix86_rotldi3_doubleword */
                }
            }
          if (XWINT (x3, 0) == 32LL
              && register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_DImode))
            return 1098; /* rotl32di2_doubleword */
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      switch (pattern19 (x2))
        {
        case 0:
          if (
#line 18478 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1102; /* *rotlsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18478 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1103; /* *rotlsi3_1 */

        case 1:
          if ((
#line 18478 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1106; /* *rotldi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 18478 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1107; /* *rotldi3_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 0LL:
      if (nonimmediate_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode)
        {
          switch (GET_MODE (operands[1]))
            {
            case E_V2SImode:
              if (nonimmediate_operand (operands[1], E_V2SImode)
                  && 
#line 5729 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return 1842; /* *vec_extractv2si_0 */
              break;

            case E_V4SImode:
              if (nonimmediate_operand (operands[1], E_V4SImode)
                  && 
#line 21170 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return 7881; /* *vec_extractv4si_0 */
              break;

            default:
              break;
            }
        }
      break;

    case 1LL:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (nonimmediate_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && nonimmediate_operand (operands[1], E_V2SImode)
              && 
#line 5786 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return 1844; /* *vec_extractv2si_1 */
          break;

        case E_DImode:
          if (nonimmediate_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && nonimmediate_operand (operands[1], E_V2DImode)
              && 
#line 21339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return 7885; /* *vec_extractv2di_1 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      if (register_operand (operands[0], E_SImode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_V16SImode:
              if (register_operand (operands[1], E_V16SImode)
                  && const_0_to_15_operand (operands[2], E_VOIDmode)
                  && (
#line 14085 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (SImode) >= 16) && 
#line 300 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 6512; /* *vec_extractv16sisi_valign */
              break;

            case E_V8SImode:
              if (register_operand (operands[1], E_V8SImode)
                  && const_0_to_7_operand (operands[2], E_VOIDmode)
                  && (
#line 14085 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (SImode) >= 16) && 
#line 300 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 6513; /* *vec_extractv8sisi_valign */
              break;

            default:
              break;
            }
        }
      if (nonimmediate_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_V4SImode)
          && const_0_to_3_operand (operands[2], E_SImode)
          && 
#line 21260 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return 7883; /* *vec_extractv4si */
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode)
          || !
#line 21317 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 7884; /* *vec_extractv4si_mem */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !const_0_to_7_operand (operands[2], E_VOIDmode)
              || !(
#line 14085 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (DImode) >= 16) && 
#line 301 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 6514; /* *vec_extractv8didi_valign */

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode)
              || !const_0_to_3_operand (operands[2], E_VOIDmode)
              || !(
#line 14085 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (DImode) >= 16) && 
#line 301 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 6515; /* *vec_extractv4didi_valign */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern570 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4034; /* unspec_avx512fp16_fixuns_truncv8hi2_mask */

    case E_V16HImode:
      if (pattern570 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4041; /* unspec_avx512fp16_fixuns_truncv16hi2_mask */

    case E_V32HImode:
      if (pattern570 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4049; /* unspec_avx512fp16_fixuns_truncv32hi2_mask */

    case E_V8SImode:
      switch (pattern907 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4057; /* unspec_avx512fp16_fixuns_truncv8si2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4452; /* unspec_fixuns_truncv8dfv8si2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9916 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && 1) && 
#line 440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 4573; /* unspec_fixuns_truncv8sfv8si2_mask */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern906 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4065; /* unspec_avx512fp16_fixuns_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4323; /* unspec_fixuns_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern907 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4073; /* unspec_avx512fp16_fixuns_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4485; /* unspec_fixuns_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4545; /* unspec_fixuns_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern908 (x2, 
E_V4SImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7906 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1)))
            return -1;
          return 4122; /* unspec_avx512fp16_fixuns_truncv4si2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F
  && (!false || TARGET_AVX10_2_256))))
            return -1;
          return 4475; /* unspec_fixuns_truncv4dfv4si2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9916 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && 1)))
            return -1;
          return 4576; /* unspec_fixuns_truncv4sfv4si2_mask */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern908 (x2, 
E_V4DImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7906 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1)))
            return -1;
          return 4129; /* unspec_avx512fp16_fixuns_truncv4di2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4493; /* unspec_fixuns_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4553; /* unspec_fixuns_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern909 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7956 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4150; /* unspec_avx512fp16_fixuns_truncv2di2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4498; /* unspec_fixuns_truncv2dfv2di2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9766 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
            return -1;
          return 4566; /* unspec_avx512dq_fixuns_truncv2sfv2di2_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1254 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3570; /* fma_fmaddsub_v32hf_maskz_1 */

            case E_V16HFmode:
              if (pattern1254 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3574; /* fma_fmaddsub_v16hf_maskz_1 */

            case E_V8HFmode:
              if (pattern1254 (x2, 
E_V8HFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3578; /* fma_fmaddsub_v8hf_maskz_1 */

            case E_V16SFmode:
              if (pattern1254 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3580; /* fma_fmaddsub_v16sf_maskz_1 */

            case E_V8SFmode:
              if (pattern1254 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3584; /* fma_fmaddsub_v8sf_maskz_1 */

            case E_V4SFmode:
              if (pattern1254 (x2, 
E_V4SFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3588; /* fma_fmaddsub_v4sf_maskz_1 */

            case E_V8DFmode:
              if (pattern1254 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3590; /* fma_fmaddsub_v8df_maskz_1 */

            case E_V4DFmode:
              if (pattern1254 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3594; /* fma_fmaddsub_v4df_maskz_1 */

            case E_V2DFmode:
              if (pattern1254 (x2, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3598; /* fma_fmaddsub_v2df_maskz_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x8 = XEXP (x2, 2);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1174 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V32HFmode)
                  && vector_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return 3599; /* avx512bw_fmaddsub_v32hf_mask */
              if (!nonimmediate_operand (operands[1], E_V32HFmode)
                  || !nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3614; /* avx512bw_fmaddsub_v32hf_mask3 */

            case E_V16HFmode:
              if (pattern1174 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V16HFmode)
                  && vector_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 3601; /* avx512vl_fmaddsub_v16hf_mask */
              if (!nonimmediate_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3616; /* avx512vl_fmaddsub_v16hf_mask3 */

            case E_V8HFmode:
              if (pattern1174 (x2, 
E_V8HFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8HFmode)
                  && vector_operand (operands[3], E_V8HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 3603; /* avx512fp16_fmaddsub_v8hf_mask */
              if (!nonimmediate_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[3], E_V8HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3618; /* avx512fp16_fmaddsub_v8hf_mask3 */

            case E_V16SFmode:
              if (pattern1174 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V16SFmode)
                  && vector_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 3604; /* avx512f_fmaddsub_v16sf_mask */
              if (!nonimmediate_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3619; /* avx512f_fmaddsub_v16sf_mask3 */

            case E_V8SFmode:
              if (pattern1174 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8SFmode)
                  && vector_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3606; /* avx512vl_fmaddsub_v8sf_mask */
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3621; /* avx512vl_fmaddsub_v8sf_mask3 */

            case E_V4SFmode:
              if (pattern1174 (x2, 
E_V4SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V4SFmode)
                  && vector_operand (operands[3], E_V4SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3608; /* avx512vl_fmaddsub_v4sf_mask */
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[3], E_V4SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3623; /* avx512vl_fmaddsub_v4sf_mask3 */

            case E_V8DFmode:
              if (pattern1174 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8DFmode)
                  && vector_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 3609; /* avx512f_fmaddsub_v8df_mask */
              if (!nonimmediate_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3624; /* avx512f_fmaddsub_v8df_mask3 */

            case E_V4DFmode:
              if (pattern1174 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V4DFmode)
                  && vector_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3611; /* avx512vl_fmaddsub_v4df_mask */
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3626; /* avx512vl_fmaddsub_v4df_mask3 */

            case E_V2DFmode:
              if (pattern1174 (x2, 
E_V2DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V2DFmode)
                  && vector_operand (operands[3], E_V2DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3613; /* avx512vl_fmaddsub_v2df_mask */
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[3], E_V2DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3628; /* avx512vl_fmaddsub_v2df_mask3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1255 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3634; /* fma_fmsubadd_v32hf_maskz_1 */

            case E_V16HFmode:
              if (pattern1255 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3638; /* fma_fmsubadd_v16hf_maskz_1 */

            case E_V8HFmode:
              if (pattern1255 (x2, 
E_V8HFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3642; /* fma_fmsubadd_v8hf_maskz_1 */

            case E_V16SFmode:
              if (pattern1255 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3644; /* fma_fmsubadd_v16sf_maskz_1 */

            case E_V8SFmode:
              if (pattern1255 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3648; /* fma_fmsubadd_v8sf_maskz_1 */

            case E_V4SFmode:
              if (pattern1255 (x2, 
E_V4SFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3652; /* fma_fmsubadd_v4sf_maskz_1 */

            case E_V8DFmode:
              if (pattern1255 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3654; /* fma_fmsubadd_v8df_maskz_1 */

            case E_V4DFmode:
              if (pattern1255 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3658; /* fma_fmsubadd_v4df_maskz_1 */

            case E_V2DFmode:
              if (pattern1255 (x2, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3662; /* fma_fmsubadd_v2df_maskz_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x8 = XEXP (x2, 2);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1175 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return 3663; /* avx512bw_fmsubadd_v32hf_mask */
              if (!nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3681; /* avx512bw_fmsubadd_v32hf_mask3 */

            case E_V16HFmode:
              if (pattern1175 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 3665; /* avx512vl_fmsubadd_v16hf_mask */
              if (!nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3683; /* avx512vl_fmsubadd_v16hf_mask3 */

            case E_V8HFmode:
              if (pattern1175 (x2, 
E_V8HFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 3667; /* avx512fp16_fmsubadd_v8hf_mask */
              if (!nonimmediate_operand (operands[3], E_V8HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3685; /* avx512fp16_fmsubadd_v8hf_mask3 */

            case E_V16SFmode:
              if (pattern1175 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 3669; /* avx512f_fmsubadd_v16sf_mask */
              if (!nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3687; /* avx512f_fmsubadd_v16sf_mask3 */

            case E_V8SFmode:
              if (pattern1175 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3671; /* avx512vl_fmsubadd_v8sf_mask */
              if (!nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3689; /* avx512vl_fmsubadd_v8sf_mask3 */

            case E_V4SFmode:
              if (pattern1175 (x2, 
E_V4SFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V4SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3673; /* avx512vl_fmsubadd_v4sf_mask */
              if (!nonimmediate_operand (operands[3], E_V4SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3691; /* avx512vl_fmsubadd_v4sf_mask3 */

            case E_V8DFmode:
              if (pattern1175 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 3675; /* avx512f_fmsubadd_v8df_mask */
              if (!nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3693; /* avx512f_fmsubadd_v8df_mask3 */

            case E_V4DFmode:
              if (pattern1175 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3677; /* avx512vl_fmsubadd_v4df_mask */
              if (!nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3695; /* avx512vl_fmsubadd_v4df_mask3 */

            case E_V2DFmode:
              if (pattern1175 (x2, 
E_V2DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V2DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3679; /* avx512vl_fmsubadd_v2df_mask */
              if (!nonimmediate_operand (operands[3], E_V2DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3697; /* avx512vl_fmsubadd_v2df_mask3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16HFmode)
    return -1;
  x3 = XEXP (x2, 2);
  if (!register_operand (x3, E_HImode))
    return -1;
  operands[3] = x3;
  if (register_operand (operands[0], E_V16HFmode))
    {
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (nonimmediate_operand (operands[2], E_V16HFmode))
        {
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (nonimm_or_0_operand (operands[1], E_V16HFmode)
              && (
#line 1780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 2010; /* avx512vl_blendmv16hf */
        }
    }
  operands[2] = x3;
  if (!memory_operand (operands[0], E_V16HFmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16HFmode))
    return -1;
  x5 = XEXP (x2, 1);
  if (!rtx_equal_p (x5, operands[0])
      || !(
#line 1822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
    return -1;
  return 2034; /* *avx512vl_storev16hf_mask */
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
    case MEM:
      x2 = XEXP (x1, 1);
      switch (pattern1188 (x2))
        {
        case 0:
          if ((
#line 4117 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 2716; /* *avx_cmpv8sf3_1 */
          break;

        case 1:
          if (
#line 4117 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return 2717; /* *avx_cmpv4sf3_1 */
          break;

        case 2:
          if ((
#line 4117 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 2718; /* *avx_cmpv4df3_1 */
          break;

        case 3:
          if ((
#line 4117 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 2719; /* *avx_cmpv2df3_1 */
          break;

        default:
          break;
        }
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 2);
      x4 = XVECEXP (x3, 0, 2);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
        {
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1345 (x2, 
E_V32HImode, 
E_SImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 763 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 7055; /* *avx512_ashrv32hi3_1 */
              break;

            case E_V16HImode:
              if (pattern1345 (x2, 
E_V16HImode, 
E_HImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 764 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                return 7056; /* *avx512_ashrv16hi3_1 */
              break;

            case E_V8HImode:
              if (pattern1345 (x2, 
E_V8HImode, 
E_QImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                return 7057; /* *avx512_ashrv8hi3_1 */
              break;

            case E_V16SImode:
              if (pattern1345 (x2, 
E_V16SImode, 
E_HImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 7058; /* *avx512_ashrv16si3_1 */
              break;

            case E_V8SImode:
              if (pattern1345 (x2, 
E_V8SImode, 
E_QImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7059; /* *avx512_ashrv8si3_1 */
              break;

            case E_V4SImode:
              if (pattern1345 (x2, 
E_V4SImode, 
E_QImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7060; /* *avx512_ashrv4si3_1 */
              break;

            case E_V8DImode:
              if (pattern1345 (x2, 
E_V8DImode, 
E_QImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 7061; /* *avx512_ashrv8di3_1 */
              break;

            case E_V4DImode:
              if (pattern1345 (x2, 
E_V4DImode, 
E_QImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7062; /* *avx512_ashrv4di3_1 */
              break;

            case E_V2DImode:
              if (pattern1345 (x2, 
E_V2DImode, 
E_QImode) == 0
                  && (
#line 17170 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7063; /* *avx512_ashrv2di3_1 */
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  x4 = XVECEXP (x3, 0, 2);
  operands[5] = x4;
  switch (pattern1189 (x2))
    {
    case 0:
      if (vector_all_ones_operand (operands[1], E_V16QImode)
          && const0_operand (operands[2], E_V16QImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V16QImode)
              && nonimm_or_0_operand (operands[4], E_V16QImode)
              && 
#line 17969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7306; /* *avx2_pcmpv16qi3_1 */
          if (nonimmediate_operand (operands[3], E_V16QImode)
              && nonimmediate_operand (operands[4], E_V16QImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7328; /* *avx2_pcmpv16qi3_6 */
        }
      if (!const0_operand (operands[1], E_V16QImode)
          || !vector_all_ones_operand (operands[2], E_V16QImode)
          || !nonimmediate_operand (operands[3], E_V16QImode)
          || !nonimmediate_operand (operands[4], E_V16QImode)
          || !
#line 18159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7344; /* *avx2_pcmpv16qi3_7 */

    case 1:
      if (vector_all_ones_operand (operands[1], E_V8HImode)
          && const0_operand (operands[2], E_V8HImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V8HImode)
              && nonimm_or_0_operand (operands[4], E_V8HImode)
              && 
#line 17969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7307; /* *avx2_pcmpv8hi3_1 */
          if (nonimmediate_operand (operands[3], E_V8HImode)
              && nonimmediate_operand (operands[4], E_V8HImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7330; /* *avx2_pcmpv8hi3_6 */
        }
      if (!const0_operand (operands[1], E_V8HImode)
          || !vector_all_ones_operand (operands[2], E_V8HImode)
          || !nonimmediate_operand (operands[3], E_V8HImode)
          || !nonimmediate_operand (operands[4], E_V8HImode)
          || !
#line 18159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7345; /* *avx2_pcmpv8hi3_7 */

    case 2:
      if (vector_all_ones_operand (operands[1], E_V4SImode)
          && const0_operand (operands[2], E_V4SImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V4SImode)
              && nonimm_or_0_operand (operands[4], E_V4SImode)
              && 
#line 17969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7308; /* *avx2_pcmpv4si3_1 */
          if (nonimmediate_operand (operands[3], E_V4SImode)
              && nonimmediate_operand (operands[4], E_V4SImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7332; /* *avx2_pcmpv4si3_6 */
        }
      if (!const0_operand (operands[1], E_V4SImode)
          || !vector_all_ones_operand (operands[2], E_V4SImode)
          || !nonimmediate_operand (operands[3], E_V4SImode)
          || !nonimmediate_operand (operands[4], E_V4SImode)
          || !
#line 18159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7346; /* *avx2_pcmpv4si3_7 */

    case 3:
      if (vector_all_ones_operand (operands[1], E_V2DImode)
          && const0_operand (operands[2], E_V2DImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V2DImode)
              && nonimm_or_0_operand (operands[4], E_V2DImode)
              && 
#line 17969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7309; /* *avx2_pcmpv2di3_1 */
          if (nonimmediate_operand (operands[3], E_V2DImode)
              && nonimmediate_operand (operands[4], E_V2DImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7334; /* *avx2_pcmpv2di3_6 */
        }
      if (!const0_operand (operands[1], E_V2DImode)
          || !vector_all_ones_operand (operands[2], E_V2DImode)
          || !nonimmediate_operand (operands[3], E_V2DImode)
          || !nonimmediate_operand (operands[4], E_V2DImode)
          || !
#line 18159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7347; /* *avx2_pcmpv2di3_7 */

    case 4:
      if (vector_all_ones_operand (operands[1], E_V32QImode)
          && const0_operand (operands[2], E_V32QImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V32QImode)
              && nonimm_or_0_operand (operands[4], E_V32QImode)
              && 
#line 17969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7310; /* *avx2_pcmpv32qi3_1 */
          if (nonimmediate_operand (operands[3], E_V32QImode)
              && nonimmediate_operand (operands[4], E_V32QImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7336; /* *avx2_pcmpv32qi3_6 */
        }
      if (!const0_operand (operands[1], E_V32QImode)
          || !vector_all_ones_operand (operands[2], E_V32QImode)
          || !nonimmediate_operand (operands[3], E_V32QImode)
          || !nonimmediate_operand (operands[4], E_V32QImode)
          || !
#line 18159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7348; /* *avx2_pcmpv32qi3_7 */

    case 5:
      if (vector_all_ones_operand (operands[1], E_V16HImode)
          && const0_operand (operands[2], E_V16HImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V16HImode)
              && nonimm_or_0_operand (operands[4], E_V16HImode)
              && 
#line 17969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7311; /* *avx2_pcmpv16hi3_1 */
          if (nonimmediate_operand (operands[3], E_V16HImode)
              && nonimmediate_operand (operands[4], E_V16HImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7338; /* *avx2_pcmpv16hi3_6 */
        }
      if (!const0_operand (operands[1], E_V16HImode)
          || !vector_all_ones_operand (operands[2], E_V16HImode)
          || !nonimmediate_operand (operands[3], E_V16HImode)
          || !nonimmediate_operand (operands[4], E_V16HImode)
          || !
#line 18159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7349; /* *avx2_pcmpv16hi3_7 */

    case 6:
      if (vector_all_ones_operand (operands[1], E_V8SImode)
          && const0_operand (operands[2], E_V8SImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V8SImode)
              && nonimm_or_0_operand (operands[4], E_V8SImode)
              && 
#line 17969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7312; /* *avx2_pcmpv8si3_1 */
          if (nonimmediate_operand (operands[3], E_V8SImode)
              && nonimmediate_operand (operands[4], E_V8SImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7340; /* *avx2_pcmpv8si3_6 */
        }
      if (!const0_operand (operands[1], E_V8SImode)
          || !vector_all_ones_operand (operands[2], E_V8SImode)
          || !nonimmediate_operand (operands[3], E_V8SImode)
          || !nonimmediate_operand (operands[4], E_V8SImode)
          || !
#line 18159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7350; /* *avx2_pcmpv8si3_7 */

    case 7:
      if (vector_all_ones_operand (operands[1], E_V4DImode)
          && const0_operand (operands[2], E_V4DImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V4DImode)
              && nonimm_or_0_operand (operands[4], E_V4DImode)
              && 
#line 17969 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7313; /* *avx2_pcmpv4di3_1 */
          if (nonimmediate_operand (operands[3], E_V4DImode)
              && nonimmediate_operand (operands[4], E_V4DImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7342; /* *avx2_pcmpv4di3_6 */
        }
      if (!const0_operand (operands[1], E_V4DImode)
          || !vector_all_ones_operand (operands[2], E_V4DImode)
          || !nonimmediate_operand (operands[3], E_V4DImode)
          || !nonimmediate_operand (operands[4], E_V4DImode)
          || !
#line 18159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7351; /* *avx2_pcmpv4di3_7 */

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XVECEXP (x8, 0, 0);
  switch (XWINT (x9, 0))
    {
    case 1LL:
      x10 = XVECEXP (x8, 0, 1);
      if (XWINT (x10, 0) != 3LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1446 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 13397 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4826; /* avx512vl_unpckhpd128_mask */

        case E_V2DImode:
          if (pattern1447 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14508 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 6622; /* vec_interleave_highv2di_mask */

        default:
          return -1;
        }

    case 0LL:
      x10 = XVECEXP (x8, 0, 1);
      if (XWINT (x10, 0) != 2LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1446 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 13540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4836; /* avx512vl_unpcklpd128_mask */

        case E_V2DImode:
          if (pattern1447 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14558 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 6628; /* vec_interleave_lowv2di_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[4] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[5] = x7;
  x8 = XEXP (x2, 1);
  operands[6] = x8;
  x9 = XEXP (x2, 2);
  operands[7] = x9;
  if (!register_operand (operands[7], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || GET_MODE (x3) != E_V4SFmode
          || pattern1532 (
E_V16SFmode) != 0
          || !nonimm_or_0_operand (operands[6], E_V4SFmode)
          || !(
#line 12511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL (operands[2]) % 4 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[6]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4762; /* avx512f_vextractf32x4_1_mask */

    case E_V4SImode:
      if (GET_MODE (x2) != E_V4SImode
          || GET_MODE (x3) != E_V4SImode
          || !nonimm_or_0_operand (operands[6], E_V4SImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && pattern1532 (
E_V16SImode) == 0
          && (
#line 12511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL (operands[2]) % 4 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[6]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 4763; /* avx512f_vextracti32x4_1_mask */
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || pattern1556 () != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20703 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
        return -1;
      return 7858; /* sse2_pshufd_1_mask */

    case E_V4DImode:
      if (pattern1413 (x2, 
E_V4DImode) != 0
          || pattern1556 () != 0
          || !nonimm_or_0_operand (operands[6], E_V4DImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 27564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8537; /* avx2_permv4di_1_mask */

    default:
      return -1;
    }
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) == CONST_INT)
    {
      res = recog_155 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x5;
  res = recog_157 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 0LL
      || x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern1200 (x2, 
E_V8HImode) != 0
      || pattern1414 (x4) != 0)
    return -1;
  x9 = XEXP (x2, 1);
  operands[6] = x9;
  if (!nonimm_or_0_operand (operands[6], E_V8HImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[7] = x10;
  if (!register_operand (operands[7], E_QImode)
      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 21016 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512BW && TARGET_AVX512VL)))
    return -1;
  return 7870; /* sse2_pshufhw_1_mask */
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_141 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (pattern274 (x2))
        {
        case 0:
          res = recog_142 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 1:
          if (vector_all_ones_operand (operands[1], E_V16QImode)
              && const0_operand (operands[2], E_V16QImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7329; /* *avx2_pcmpv16qi3_6 */
          if (const0_operand (operands[1], E_V16QImode)
              && vector_all_ones_operand (operands[2], E_V16QImode)
              && 
#line 18191 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7352; /* *avx2_pcmpv16qi3_8 */
          break;

        case 2:
          if (vector_all_ones_operand (operands[1], E_V8HImode)
              && const0_operand (operands[2], E_V8HImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7331; /* *avx2_pcmpv8hi3_6 */
          if (const0_operand (operands[1], E_V8HImode)
              && vector_all_ones_operand (operands[2], E_V8HImode)
              && 
#line 18191 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7353; /* *avx2_pcmpv8hi3_8 */
          break;

        case 3:
          if (vector_all_ones_operand (operands[1], E_V4SImode)
              && const0_operand (operands[2], E_V4SImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7333; /* *avx2_pcmpv4si3_6 */
          if (const0_operand (operands[1], E_V4SImode)
              && vector_all_ones_operand (operands[2], E_V4SImode)
              && 
#line 18191 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7354; /* *avx2_pcmpv4si3_8 */
          break;

        case 4:
          if (vector_all_ones_operand (operands[1], E_V2DImode)
              && const0_operand (operands[2], E_V2DImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7335; /* *avx2_pcmpv2di3_6 */
          if (const0_operand (operands[1], E_V2DImode)
              && vector_all_ones_operand (operands[2], E_V2DImode)
              && 
#line 18191 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7355; /* *avx2_pcmpv2di3_8 */
          break;

        case 5:
          if (vector_all_ones_operand (operands[1], E_V32QImode)
              && const0_operand (operands[2], E_V32QImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7337; /* *avx2_pcmpv32qi3_6 */
          if (const0_operand (operands[1], E_V32QImode)
              && vector_all_ones_operand (operands[2], E_V32QImode)
              && 
#line 18191 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7356; /* *avx2_pcmpv32qi3_8 */
          break;

        case 6:
          if (vector_all_ones_operand (operands[1], E_V16HImode)
              && const0_operand (operands[2], E_V16HImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7339; /* *avx2_pcmpv16hi3_6 */
          if (const0_operand (operands[1], E_V16HImode)
              && vector_all_ones_operand (operands[2], E_V16HImode)
              && 
#line 18191 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7357; /* *avx2_pcmpv16hi3_8 */
          break;

        case 7:
          if (vector_all_ones_operand (operands[1], E_V8SImode)
              && const0_operand (operands[2], E_V8SImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7341; /* *avx2_pcmpv8si3_6 */
          if (const0_operand (operands[1], E_V8SImode)
              && vector_all_ones_operand (operands[2], E_V8SImode)
              && 
#line 18191 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7358; /* *avx2_pcmpv8si3_8 */
          break;

        case 8:
          if (vector_all_ones_operand (operands[1], E_V4DImode)
              && const0_operand (operands[2], E_V4DImode)
              && 
#line 18133 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7343; /* *avx2_pcmpv4di3_6 */
          if (const0_operand (operands[1], E_V4DImode)
              && vector_all_ones_operand (operands[2], E_V4DImode)
              && 
#line 18191 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7359; /* *avx2_pcmpv4di3_8 */
          break;

        case 9:
          if ((
#line 4144 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 2720; /* *avx_cmpv8sf3_2 */
          break;

        case 10:
          if (
#line 18008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7320; /* *avx2_pcmpv8si3_2 */
          break;

        case 11:
          if (
#line 4144 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return 2721; /* *avx_cmpv4sf3_2 */
          break;

        case 12:
          if (
#line 18008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7316; /* *avx2_pcmpv4si3_2 */
          break;

        case 13:
          if ((
#line 4144 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 2722; /* *avx_cmpv4df3_2 */
          break;

        case 14:
          if (
#line 18008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7321; /* *avx2_pcmpv4di3_2 */
          break;

        case 15:
          if ((
#line 4144 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 2723; /* *avx_cmpv2df3_2 */
          break;

        case 16:
          if (
#line 18008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7317; /* *avx2_pcmpv2di3_2 */
          break;

        case 17:
          if (
#line 18008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7314; /* *avx2_pcmpv16qi3_2 */
          break;

        case 18:
          if (
#line 18008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7315; /* *avx2_pcmpv8hi3_2 */
          break;

        case 19:
          if (
#line 18008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7318; /* *avx2_pcmpv32qi3_2 */
          break;

        case 20:
          if (
#line 18008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7319; /* *avx2_pcmpv16hi3_2 */
          break;

        case 21:
          switch (GET_MODE (operands[0]))
            {
            case E_V64QImode:
              if (register_operand (operands[0], E_V64QImode)
                  && GET_MODE (x2) == E_V64QImode
                  && register_operand (operands[1], E_DImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V64QImode)
                      && const0_operand (operands[3], E_V64QImode)
                      && (
#line 10306 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4629; /* *avx512bw_cvtmask2bv64qi */
                  if (const0_operand (operands[2], E_V64QImode)
                      && vector_all_ones_operand (operands[3], E_V64QImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return 4641; /* *avx512bw_cvtmask2bv64qi_not */
                }
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x2) == E_V16QImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16QImode)
                      && const0_operand (operands[3], E_V16QImode)
                      && (
#line 10306 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4630; /* *avx512vl_cvtmask2bv16qi */
                  if (const0_operand (operands[2], E_V16QImode)
                      && vector_all_ones_operand (operands[3], E_V16QImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 4643; /* *avx512vl_cvtmask2bv16qi_not */
                }
              break;

            case E_V32QImode:
              if (register_operand (operands[0], E_V32QImode)
                  && GET_MODE (x2) == E_V32QImode
                  && register_operand (operands[1], E_SImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V32QImode)
                      && const0_operand (operands[3], E_V32QImode)
                      && (
#line 10306 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4631; /* *avx512vl_cvtmask2bv32qi */
                  if (const0_operand (operands[2], E_V32QImode)
                      && vector_all_ones_operand (operands[3], E_V32QImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 4642; /* *avx512vl_cvtmask2bv32qi_not */
                }
              break;

            case E_V32HImode:
              if (register_operand (operands[0], E_V32HImode)
                  && GET_MODE (x2) == E_V32HImode
                  && register_operand (operands[1], E_SImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V32HImode)
                      && const0_operand (operands[3], E_V32HImode)
                      && (
#line 10306 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4632; /* *avx512bw_cvtmask2wv32hi */
                  if (const0_operand (operands[2], E_V32HImode)
                      && vector_all_ones_operand (operands[3], E_V32HImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return 4644; /* *avx512bw_cvtmask2wv32hi_not */
                }
              break;

            case E_V16HImode:
              if (register_operand (operands[0], E_V16HImode)
                  && GET_MODE (x2) == E_V16HImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16HImode)
                      && const0_operand (operands[3], E_V16HImode)
                      && (
#line 10306 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4633; /* *avx512vl_cvtmask2wv16hi */
                  if (const0_operand (operands[2], E_V16HImode)
                      && vector_all_ones_operand (operands[3], E_V16HImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 4645; /* *avx512vl_cvtmask2wv16hi_not */
                }
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x2) == E_V8HImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8HImode)
                      && const0_operand (operands[3], E_V8HImode)
                      && (
#line 10306 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4634; /* *avx512vl_cvtmask2wv8hi */
                  if (const0_operand (operands[2], E_V8HImode)
                      && vector_all_ones_operand (operands[3], E_V8HImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 4646; /* *avx512vl_cvtmask2wv8hi_not */
                }
              break;

            case E_V16SImode:
              if (register_operand (operands[0], E_V16SImode)
                  && GET_MODE (x2) == E_V16SImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16SImode)
                      && const0_operand (operands[3], E_V16SImode)
                      && (
#line 10329 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4635; /* *avx512f_cvtmask2dv16si */
                  if (const0_operand (operands[2], E_V16SImode)
                      && vector_all_ones_operand (operands[3], E_V16SImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4647; /* *avx512f_cvtmask2dv16si_not */
                }
              break;

            case E_V8SImode:
              if (register_operand (operands[0], E_V8SImode)
                  && GET_MODE (x2) == E_V8SImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8SImode)
                      && const0_operand (operands[3], E_V8SImode)
                      && (
#line 10329 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4636; /* *avx512vl_cvtmask2dv8si */
                  if (const0_operand (operands[2], E_V8SImode)
                      && vector_all_ones_operand (operands[3], E_V8SImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4648; /* *avx512vl_cvtmask2dv8si_not */
                }
              break;

            case E_V4SImode:
              if (register_operand (operands[0], E_V4SImode)
                  && GET_MODE (x2) == E_V4SImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V4SImode)
                      && const0_operand (operands[3], E_V4SImode)
                      && (
#line 10329 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4637; /* *avx512vl_cvtmask2dv4si */
                  if (const0_operand (operands[2], E_V4SImode)
                      && vector_all_ones_operand (operands[3], E_V4SImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4649; /* *avx512vl_cvtmask2dv4si_not */
                }
              break;

            case E_V8DImode:
              if (register_operand (operands[0], E_V8DImode)
                  && GET_MODE (x2) == E_V8DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8DImode)
                      && const0_operand (operands[3], E_V8DImode)
                      && (
#line 10329 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4638; /* *avx512f_cvtmask2qv8di */
                  if (const0_operand (operands[2], E_V8DImode)
                      && vector_all_ones_operand (operands[3], E_V8DImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4650; /* *avx512f_cvtmask2qv8di_not */
                }
              break;

            case E_V4DImode:
              if (register_operand (operands[0], E_V4DImode)
                  && GET_MODE (x2) == E_V4DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V4DImode)
                      && const0_operand (operands[3], E_V4DImode)
                      && (
#line 10329 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4639; /* *avx512vl_cvtmask2qv4di */
                  if (const0_operand (operands[2], E_V4DImode)
                      && vector_all_ones_operand (operands[3], E_V4DImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4651; /* *avx512vl_cvtmask2qv4di_not */
                }
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V2DImode)
                      && const0_operand (operands[3], E_V2DImode)
                      && (
#line 10329 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4640; /* *avx512vl_cvtmask2qv2di */
                  if (const0_operand (operands[2], E_V2DImode)
                      && vector_all_ones_operand (operands[3], E_V2DImode)
                      && (
#line 10355 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4652; /* *avx512vl_cvtmask2qv2di_not */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  switch (pattern277 (x2))
    {
    case 0:
      if (!(
#line 4171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2724; /* *avx_cmpv8sf3_3 */

    case 1:
      if (!
#line 4171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
        return -1;
      return 2725; /* *avx_cmpv4sf3_3 */

    case 2:
      if (!(
#line 4171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2726; /* *avx_cmpv4df3_3 */

    case 3:
      if (!(
#line 4171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2727; /* *avx_cmpv2df3_3 */

    case 4:
      if (!(
#line 4192 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2728; /* *avx_cmpv8sf3_4 */

    case 5:
      if (!
#line 4192 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
        return -1;
      return 2729; /* *avx_cmpv4sf3_4 */

    case 6:
      if (!(
#line 4192 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2730; /* *avx_cmpv4df3_4 */

    case 7:
      if (!(
#line 4192 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2731; /* *avx_cmpv2df3_4 */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern128 (x2))
    {
    case 0:
      if (pattern713 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4078; /* avx512fp16_fixuns_truncv8hi2_mask */

    case 1:
      if (pattern713 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4085; /* avx512fp16_fixuns_truncv16hi2_mask */

    case 2:
      if (pattern713 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4093; /* avx512fp16_fixuns_truncv32hi2_mask */

    case 3:
      switch (pattern817 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4101; /* avx512fp16_fixuns_truncv8si2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4460; /* fixuns_truncv8dfv8si2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9926 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 4578; /* fixuns_truncv8sfv8si2_mask */

        default:
          return -1;
        }

    case 4:
      switch (pattern816 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4109; /* avx512fp16_fixuns_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8786 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4331; /* fixuns_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case 5:
      switch (pattern817 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4117; /* avx512fp16_fixuns_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4505; /* fixuns_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9755 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4558; /* fixuns_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case 6:
      if (pattern712 (x2, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4142; /* *avx512fp16_fixuns_truncv4si2_load_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 4478; /* fixuns_truncv4dfv4si2_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9926 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4580; /* fixuns_truncv4sfv4si2_mask */

        default:
          return -1;
        }

    case 7:
      switch (pattern818 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4146; /* *avx512fp16_fixuns_truncv4di2_load_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4513; /* fixuns_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9755 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4562; /* fixuns_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case 8:
      switch (pattern819 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7978 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4158; /* *avx512fp16_fixuns_truncv2di2_load_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4518; /* fixuns_truncv2dfv2di2_mask */

        default:
          return -1;
        }

    case 9:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7918 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4134; /* avx512fp16_fixuns_truncv4si2_mask */

    case 10:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7918 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4138; /* avx512fp16_fixuns_truncv4di2_mask */

    case 11:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7968 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4154; /* avx512fp16_fixuns_truncv2di2_mask */

    case 12:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9778 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
        return -1;
      return 4570; /* avx512dq_fixuns_truncv2sfv2di2_mask */

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x2) != E_V64QImode
          || !memory_operand (operands[1], E_V64QImode)
          || !(
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 514 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10336; /* avx10_2_vmovrsbv64qi */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || !memory_operand (operands[1], E_V32QImode)
          || !
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS))
        return -1;
      return 10338; /* avx10_2_vmovrsbv32qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !memory_operand (operands[1], E_V16QImode)
          || !
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS))
        return -1;
      return 10340; /* avx10_2_vmovrsbv16qi */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !memory_operand (operands[1], E_V32HImode)
          || !(
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 515 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10342; /* avx10_2_vmovrswv32hi */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !memory_operand (operands[1], E_V16HImode)
          || !
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS))
        return -1;
      return 10344; /* avx10_2_vmovrswv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !memory_operand (operands[1], E_V8HImode)
          || !
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS))
        return -1;
      return 10346; /* avx10_2_vmovrswv8hi */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode
          || !memory_operand (operands[1], E_V16SImode)
          || !(
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 516 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10348; /* avx10_2_vmovrsdv16si */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x2) != E_V8SImode
          || !memory_operand (operands[1], E_V8SImode)
          || !
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS))
        return -1;
      return 10350; /* avx10_2_vmovrsdv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !memory_operand (operands[1], E_V4SImode)
          || !
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS))
        return -1;
      return 10352; /* avx10_2_vmovrsdv4si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x2) != E_V8DImode
          || !memory_operand (operands[1], E_V8DImode)
          || !(
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 517 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10354; /* avx10_2_vmovrsqv8di */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode
          || !memory_operand (operands[1], E_V4DImode)
          || !
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS))
        return -1;
      return 10356; /* avx10_2_vmovrsqv4di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !memory_operand (operands[1], E_V2DImode)
          || !
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS))
        return -1;
      return 10358; /* avx10_2_vmovrsqv2di */

    default:
      return -1;
    }
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 2911 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2356; /* avx_rcpv8sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !
#line 2911 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 2357; /* sse_rcpv4sf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !nonimmediate_operand (operands[1], E_V32HFmode)
          || !(
#line 2965 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2360; /* avx512fp16_rcpv32hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !nonimmediate_operand (operands[1], E_V16HFmode)
          || !(
#line 2965 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2362; /* avx512fp16_rcpv16hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !(
#line 2965 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2364; /* avx512fp16_rcpv8hf2 */

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode)
          || !(
#line 32409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10048; /* avx10_2_rcpbf16_v32bf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x2) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !
#line 32409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10050; /* avx10_2_rcpbf16_v16bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !
#line 32409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10052; /* avx10_2_rcpbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      switch (pattern718 (x2))
        {
        case 0:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2239; /* avx512fp16_vmaddv8hf3_mask_round */

        case 1:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2247; /* sse_vmaddv4sf3_mask_round */

        case 2:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2255; /* sse2_vmaddv2df3_mask_round */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern718 (x2))
        {
        case 0:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2243; /* avx512fp16_vmsubv8hf3_mask_round */

        case 1:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2251; /* sse_vmsubv4sf3_mask_round */

        case 2:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2259; /* sse2_vmsubv2df3_mask_round */

        default:
          return -1;
        }

    case MULT:
      switch (pattern718 (x2))
        {
        case 0:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2305; /* avx512fp16_vmmulv8hf3_mask_round */

        case 1:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2313; /* sse_vmmulv4sf3_mask_round */

        case 2:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2321; /* sse2_vmmulv2df3_mask_round */

        default:
          return -1;
        }

    case DIV:
      switch (pattern718 (x2))
        {
        case 0:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2309; /* avx512fp16_vmdivv8hf3_mask_round */

        case 1:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2317; /* sse_vmdivv4sf3_mask_round */

        case 2:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2325; /* sse2_vmdivv2df3_mask_round */

        default:
          return -1;
        }

    case SQRT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 2);
      operands[4] = x9;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1416 (x2, 
E_V8HFmode) != 0
              || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2418; /* avx512fp16_vmsqrtv8hf2_mask_round */

        case E_V4SFmode:
          if (pattern1416 (x2, 
E_V4SFmode) != 0
              || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2422; /* sse_vmsqrtv4sf2_mask_round */

        case E_V2DFmode:
          if (pattern1416 (x2, 
E_V2DFmode) != 0
              || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2426; /* sse2_vmsqrtv2df2_mask_round */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SQRT:
          x6 = XEXP (x3, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x12 = XEXP (x7, 0);
          operands[1] = x12;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x4, 2);
          operands[4] = x9;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1448 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3101 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                return -1;
              return 2430; /* *avx512fp16_vmsqrtv8hf2_mask_round */

            case E_V4SFmode:
              if (pattern1448 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3101 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
                return -1;
              return 2434; /* *sse_vmsqrtv4sf2_mask_round */

            case E_V2DFmode:
              if (pattern1448 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3101 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                return -1;
              return 2438; /* *sse2_vmsqrtv2df2_mask_round */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x12 = XEXP (x7, 0);
          if (GET_CODE (x12) != VEC_SELECT
              || GET_MODE (x12) != E_HFmode
              || pattern1112 (x3) != 0)
            return -1;
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x4, 2);
          operands[4] = x9;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!const48_operand (operands[5], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern1620 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 4220; /* avx512fp16_vcvtsh2sd_mask_round */

            case E_V4SFmode:
              if (pattern1620 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 4224; /* avx512fp16_vcvtsh2ss_mask_round */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          switch (GET_CODE (x12))
            {
            case VEC_SELECT:
              if (pattern1112 (x3) != 0
                  || pattern1348 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              operands[1] = x13;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
                return -1;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V8HFmode))
                return -1;
              switch (GET_MODE (x12))
                {
                case E_DFmode:
                  if (!register_operand (operands[1], E_V2DFmode)
                      || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8341 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 4232; /* avx512fp16_vcvtsd2sh_mask_round */

                case E_SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8341 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 4236; /* avx512fp16_vcvtss2sh_mask_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[2] = x12;
              if (!nonimmediate_operand (operands[2], E_V2DFmode))
                return -1;
              x9 = XEXP (x4, 2);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || pattern1348 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              operands[1] = x8;
              if (!register_operand (operands[1], E_V4SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[3] = x10;
              if (!nonimm_or_0_operand (operands[3], E_V4SFmode))
                return -1;
              x6 = XEXP (x3, 2);
              operands[4] = x6;
              if (!register_operand (operands[4], E_QImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10016 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 4589; /* sse2_cvtsd2ss_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern719 (x2))
        {
        case 0:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2611; /* *avx512fp16_vmsmaxv8hf3_mask_round */

        case 1:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2619; /* *sse_vmsmaxv4sf3_mask_round */

        case 2:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2627; /* *sse2_vmsmaxv2df3_mask_round */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern719 (x2))
        {
        case 0:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2615; /* *avx512fp16_vmsminv8hf3_mask_round */

        case 1:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2623; /* *sse_vmsminv4sf3_mask_round */

        case 2:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2631; /* *sse2_vmsminv2df3_mask_round */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          switch (XINT (x5, 1))
            {
            case 63:
              switch (pattern1025 (x2))
                {
                case 0:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2635; /* avx512fp16_ieee_vmmaxv8hf3_mask_round */

                case 1:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3485 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
                    return -1;
                  return 2643; /* sse_ieee_vmmaxv4sf3_mask_round */

                case 2:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2651; /* sse2_ieee_vmmaxv2df3_mask_round */

                default:
                  return -1;
                }

            case 62:
              switch (pattern1025 (x2))
                {
                case 0:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2639; /* avx512fp16_ieee_vmminv8hf3_mask_round */

                case 1:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3485 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))))
                    return -1;
                  return 2647; /* sse_ieee_vmminv4sf3_mask_round */

                case 2:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2655; /* sse2_ieee_vmminv2df3_mask_round */

                default:
                  return -1;
                }

            case 221:
              if (pattern1026 (x2) != 0
                  || !(
#line 460 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 412 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7522 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3892; /* avx512fp16_fmulcsh_v8hf_mask_round */

            case 222:
              if (pattern1026 (x2) != 0
                  || !(
#line 460 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 412 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7522 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3896; /* avx512fp16_fcmulcsh_v8hf_mask_round */

            case 58:
              if (XWINT (x6, 0) != 1LL)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[2] = x15;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[5] = x11;
              if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
                return -1;
              switch (pattern1504 (x2))
                {
                case 0:
                  if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13625 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 4841; /* avx512f_vmscalefv8hf_mask_round */

                case 1:
                  if (!
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 4845; /* avx512f_vmscalefv4sf_mask_round */

                case 2:
                  if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13625 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 4849; /* avx512f_vmscalefv2df_mask_round */

                default:
                  return -1;
                }

            case 165:
              if (XWINT (x6, 0) != 1LL)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[2] = x15;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[5] = x11;
              if (!const48_operand (operands[5], E_SImode))
                return -1;
              switch (pattern1504 (x2))
                {
                case 0:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14058 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 6491; /* avx512f_sgetexpv8hf_mask_round */

                case 1:
                  if (!
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6495; /* avx512f_sgetexpv4sf_mask_round */

                case 2:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14058 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6499; /* avx512f_sgetexpv2df_mask_round */

                default:
                  return -1;
                }

            case 94:
              if (XWINT (x6, 0) != 1LL)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[2] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[3] = x15;
              if (!const_0_to_255_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x4, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 2);
              operands[5] = x9;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[1] = x10;
              x11 = XVECEXP (x2, 0, 1);
              operands[6] = x11;
              if (!const48_operand (operands[6], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HFmode:
                  if (pattern1591 (x2, 
E_V8HFmode) != 0
                      || !(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14252 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 6595; /* avx512f_rndscalev8hf_mask_round */

                case E_V4SFmode:
                  if (pattern1591 (x2, 
E_V4SFmode) != 0
                      || !
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6599; /* avx512f_rndscalev4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1591 (x2, 
E_V2DFmode) != 0
                      || !(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14252 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6603; /* avx512f_rndscalev2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x14 = XVECEXP (x5, 0, 0);
          operands[1] = x14;
          x15 = XVECEXP (x5, 0, 1);
          operands[2] = x15;
          x16 = XVECEXP (x5, 0, 2);
          operands[3] = x16;
          switch (XINT (x5, 1))
            {
            case 192:
              switch (pattern1285 (x2))
                {
                case 0:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4040 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2703; /* reducesv8hf_mask_round */

                case 1:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4040 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))))))
                    return -1;
                  return 2707; /* reducesv4sf_mask_round */

                case 2:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4040 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2711; /* reducesv2df_mask_round */

                default:
                  return -1;
                }

            case 217:
              switch (pattern1286 (x2))
                {
                case 0:
                  if (!(
#line 460 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 394 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7487 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3880; /* avx512fp16_fma_fmaddcsh_v8hf_maskz_round */

                case 1:
                  if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 3886; /* avx512fp16_fmaddcsh_v8hf_mask_round */

                default:
                  return -1;
                }

            case 219:
              switch (pattern1286 (x2))
                {
                case 0:
                  if (!(
#line 460 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 394 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7487 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3884; /* avx512fp16_fma_fcmaddcsh_v8hf_maskz_round */

                case 1:
                  if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 3888; /* avx512fp16_fcmaddcsh_v8hf_mask_round */

                default:
                  return -1;
                }

            case 194:
              if (XWINT (x6, 0) != 1LL
                  || !const_0_to_15_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x4, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 2);
              operands[5] = x9;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[6] = x11;
              if (!const48_operand (operands[6], E_SImode))
                return -1;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1283 (x2, 
E_V4SFmode) != 0
                      || !(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29848 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ))))
                    return -1;
                  return 9349; /* avx512dq_rangesv4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1283 (x2, 
E_V2DFmode) != 0
                      || !(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29848 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 9353; /* avx512dq_rangesv2df_mask_round */

                default:
                  return -1;
                }

            case 166:
              if (XWINT (x6, 0) != 1LL
                  || !const_0_to_15_operand (operands[3], E_SImode))
                return -1;
              switch (pattern1284 (x2))
                {
                case 0:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29916 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 9411; /* avx512f_vgetmantv8hf_mask_round */

                case 1:
                  if (!
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 9415; /* avx512f_vgetmantv4sf_mask_round */

                case 2:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29916 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 9419; /* avx512f_vgetmantv2df_mask_round */

                default:
                  return -1;
                }

            case 278:
              switch (pattern1285 (x2))
                {
                case 0:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 10327; /* avx10_2_minmaxsv8hf_mask_round */

                case 1:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))))
                    return -1;
                  return 10331; /* avx10_2_minmaxsv4sf_mask_round */

                case 2:
                  if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 378 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 10335; /* avx10_2_minmaxsv2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          if (XINT (x5, 1) != 163)
            return -1;
          x14 = XVECEXP (x5, 0, 0);
          operands[1] = x14;
          x15 = XVECEXP (x5, 0, 1);
          operands[2] = x15;
          x16 = XVECEXP (x5, 0, 2);
          operands[3] = x16;
          x17 = XVECEXP (x5, 0, 3);
          operands[4] = x17;
          if (!const_0_to_255_operand (operands[4], E_SImode))
            return -1;
          x11 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x11, E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x6 = XEXP (x3, 2);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x9 = XEXP (x4, 2);
              operands[6] = x9;
              if (!register_operand (operands[6], E_QImode))
                return -1;
              operands[7] = x11;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1621 (x2, 
E_V4SFmode, 
E_V4SImode) != 0
                      || !
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6553; /* avx512f_sfixupimmv4sf_maskz_1_round */

                case E_V2DFmode:
                  if (pattern1621 (x2, 
E_V2DFmode, 
E_V2DImode) != 0
                      || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 154 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14207 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6557; /* avx512f_sfixupimmv2df_maskz_1_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[2]))
                return -1;
              x9 = XEXP (x4, 2);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x6 = XEXP (x3, 2);
              operands[5] = x6;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              operands[6] = x11;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1622 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6559; /* avx512f_sfixupimmv4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1622 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14226 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 6561; /* avx512f_sfixupimmv2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      return recog_202 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (GET_MODE (x5) != E_V2DFmode)
        return -1;
      x7 = XEXP (x5, 0);
      if (pattern828 (x7, 
2, 
E_V2SFmode) != 0)
        return -1;
      x18 = XEXP (x7, 1);
      x19 = XVECEXP (x18, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern1351 (x2, 
E_V2DFmode) != 0)
        return -1;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      if (!nonimm_or_0_operand (operands[3], E_V2DFmode))
        return -1;
      x6 = XEXP (x3, 2);
      operands[4] = x6;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      if (!const48_operand (operands[5], E_SImode)
          || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10060 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 4594; /* sse2_cvtss2sd_mask_round */

    default:
      return -1;
    }
}

 int
recog_217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      switch (pattern428 (x3))
        {
        case 0:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2159; /* *addv32hf3_round */

        case 1:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2167; /* *addv16hf3_round */

        case 2:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && 1 && ((V8HFmode == V16SFmode
							       || V8HFmode == V8DFmode
							       || V8HFmode == V8DImode
							       || V8HFmode == V16SImode
							       || V8HFmode == V32HImode
							       || V8HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8HFmode == V8SFmode
								       || V8HFmode == V4DFmode
								       || V8HFmode == V4DImode
								       || V8HFmode == V8SImode
								       || V8HFmode == V16HImode
								       || V8HFmode == V16HFmode)))) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2175; /* *addv8hf3_round */

        case 3:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && 1 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2183; /* *addv16sf3_round */

        case 4:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && 1 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2191; /* *addv8sf3_round */

        case 5:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && 1 && ((V4SFmode == V16SFmode
							       || V4SFmode == V8DFmode
							       || V4SFmode == V8DImode
							       || V4SFmode == V16SImode
							       || V4SFmode == V32HImode
							       || V4SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4SFmode == V8SFmode
								       || V4SFmode == V4DFmode
								       || V4SFmode == V4DImode
								       || V4SFmode == V8SImode
								       || V4SFmode == V16HImode
								       || V4SFmode == V16HFmode))))))
            return -1;
          return 2199; /* *addv4sf3_round */

        case 6:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && 1 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2207; /* *addv8df3_round */

        case 7:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && 1 && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2215; /* *addv4df3_round */

        case 8:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && 1 && ((V2DFmode == V16SFmode
							       || V2DFmode == V8DFmode
							       || V2DFmode == V8DImode
							       || V2DFmode == V16SImode
							       || V2DFmode == V32HImode
							       || V2DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V2DFmode == V8SFmode
								       || V2DFmode == V4DFmode
								       || V2DFmode == V4DImode
								       || V2DFmode == V8SImode
								       || V2DFmode == V16HImode
								       || V2DFmode == V16HFmode)))) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2223; /* *addv2df3_round */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_213 (x1, insn, pnum_clobbers);

    case MINUS:
      switch (pattern428 (x3))
        {
        case 0:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V32HFmode, operands)
   && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2163; /* *subv32hf3_round */

        case 1:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16HFmode, operands)
   && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2171; /* *subv16hf3_round */

        case 2:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8HFmode, operands)
   && 1 && ((V8HFmode == V16SFmode
							       || V8HFmode == V8DFmode
							       || V8HFmode == V8DImode
							       || V8HFmode == V16SImode
							       || V8HFmode == V32HImode
							       || V8HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8HFmode == V8SFmode
								       || V8HFmode == V4DFmode
								       || V8HFmode == V4DImode
								       || V8HFmode == V8SImode
								       || V8HFmode == V16HImode
								       || V8HFmode == V16HFmode)))) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2179; /* *subv8hf3_round */

        case 3:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16SFmode, operands)
   && 1 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2187; /* *subv16sf3_round */

        case 4:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8SFmode, operands)
   && 1 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2195; /* *subv8sf3_round */

        case 5:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4SFmode, operands)
   && 1 && ((V4SFmode == V16SFmode
							       || V4SFmode == V8DFmode
							       || V4SFmode == V8DImode
							       || V4SFmode == V16SImode
							       || V4SFmode == V32HImode
							       || V4SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4SFmode == V8SFmode
								       || V4SFmode == V4DFmode
								       || V4SFmode == V4DImode
								       || V4SFmode == V8SImode
								       || V4SFmode == V16HImode
								       || V4SFmode == V16HFmode))))))
            return -1;
          return 2203; /* *subv4sf3_round */

        case 6:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8DFmode, operands)
   && 1 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2211; /* *subv8df3_round */

        case 7:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4DFmode, operands)
   && 1 && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2219; /* *subv4df3_round */

        case 8:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V2DFmode, operands)
   && 1 && ((V2DFmode == V16SFmode
							       || V2DFmode == V8DFmode
							       || V2DFmode == V8DImode
							       || V2DFmode == V16SImode
							       || V2DFmode == V32HImode
							       || V2DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V2DFmode == V8SFmode
								       || V2DFmode == V4DFmode
								       || V2DFmode == V4DImode
								       || V2DFmode == V8SImode
								       || V2DFmode == V16HImode
								       || V2DFmode == V16HFmode)))) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2227; /* *subv2df3_round */

        default:
          return -1;
        }

    case MULT:
      switch (pattern428 (x3))
        {
        case 0:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2261; /* *mulv32hf3_round */

        case 1:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2265; /* *mulv16hf3_round */

        case 2:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && 1 && ((V8HFmode == V16SFmode
							       || V8HFmode == V8DFmode
							       || V8HFmode == V8DImode
							       || V8HFmode == V16SImode
							       || V8HFmode == V32HImode
							       || V8HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8HFmode == V8SFmode
								       || V8HFmode == V4DFmode
								       || V8HFmode == V4DImode
								       || V8HFmode == V8SImode
								       || V8HFmode == V16HImode
								       || V8HFmode == V16HFmode)))) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2269; /* *mulv8hf3_round */

        case 3:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && 1 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2273; /* *mulv16sf3_round */

        case 4:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && 1 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2277; /* *mulv8sf3_round */

        case 5:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && 1 && ((V4SFmode == V16SFmode
							       || V4SFmode == V8DFmode
							       || V4SFmode == V8DImode
							       || V4SFmode == V16SImode
							       || V4SFmode == V32HImode
							       || V4SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4SFmode == V8SFmode
								       || V4SFmode == V4DFmode
								       || V4SFmode == V4DImode
								       || V4SFmode == V8SImode
								       || V4SFmode == V16HImode
								       || V4SFmode == V16HFmode))))))
            return -1;
          return 2281; /* *mulv4sf3_round */

        case 6:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && 1 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2285; /* *mulv8df3_round */

        case 7:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && 1 && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2289; /* *mulv4df3_round */

        case 8:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && 1 && ((V2DFmode == V16SFmode
							       || V2DFmode == V8DFmode
							       || V2DFmode == V8DImode
							       || V2DFmode == V16SImode
							       || V2DFmode == V32HImode
							       || V2DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V2DFmode == V8SFmode
								       || V2DFmode == V4DFmode
								       || V2DFmode == V4DImode
								       || V2DFmode == V8SImode
								       || V2DFmode == V16HImode
								       || V2DFmode == V16HFmode)))) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2293; /* *mulv2df3_round */

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[3] = x7;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern427 (x3, 
E_V32HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2327; /* avx512fp16_divv32hf3_round */

        case E_V16HFmode:
          if (pattern427 (x3, 
E_V16HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2331; /* avx512fp16_divv16hf3_round */

        case E_V16SFmode:
          if (pattern427 (x3, 
E_V16SFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2337; /* avx512f_divv16sf3_round */

        case E_V8SFmode:
          if (pattern427 (x3, 
E_V8SFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2341; /* avx_divv8sf3_round */

        case E_V8DFmode:
          if (pattern427 (x3, 
E_V8DFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2347; /* avx512f_divv8df3_round */

        case E_V4DFmode:
          if (pattern427 (x3, 
E_V4DFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2351; /* avx_divv4df3_round */

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern931 (x3, 
E_V32HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2386; /* avx512fp16_sqrtv32hf2_round */

        case E_V16HFmode:
          if (pattern931 (x3, 
E_V16HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2390; /* avx512fp16_sqrtv16hf2_round */

        case E_V16SFmode:
          if (pattern931 (x3, 
E_V16SFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2396; /* avx512f_sqrtv16sf2_round */

        case E_V8SFmode:
          if (pattern931 (x3, 
E_V8SFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2400; /* avx_sqrtv8sf2_round */

        case E_V8DFmode:
          if (pattern931 (x3, 
E_V8DFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2406; /* avx512f_sqrtv8df2_round */

        case E_V4DFmode:
          if (pattern931 (x3, 
E_V4DFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2410; /* avx_sqrtv4df2_round */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern429 (x3))
        {
        case 0:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2470; /* *smaxv32hf3_round */

        case 1:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2478; /* *smaxv16hf3_round */

        case 2:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2490; /* *smaxv16sf3_round */

        case 3:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2498; /* *smaxv8sf3_round */

        case 4:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2510; /* *smaxv8df3_round */

        case 5:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2518; /* *smaxv4df3_round */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern429 (x3))
        {
        case 0:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2474; /* *sminv32hf3_round */

        case 1:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2482; /* *sminv16hf3_round */

        case 2:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2494; /* *sminv16sf3_round */

        case 3:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2502; /* *sminv8sf3_round */

        case 4:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2514; /* *sminv8df3_round */

        case 5:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2522; /* *sminv4df3_round */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_214 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_215 (x1, insn, pnum_clobbers);

    case FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HFmode:
          switch (pattern934 (x3))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
							       || V16HImode == V8DFmode
							       || V16HImode == V8DImode
							       || V16HImode == V16SImode
							       || V16HImode == V32HImode
							       || V16HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HImode == V8SFmode
								       || V16HImode == V4DFmode
								       || V16HImode == V4DImode
								       || V16HImode == V8SImode
								       || V16HImode == V16HImode
								       || V16HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3962; /* avx512fp16_vcvtw2ph_v16hi_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3986; /* avx512fp16_vcvtdq2ph_v16si_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern430 (x3, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
							       || V32HImode == V8DFmode
							       || V32HImode == V8DImode
							       || V32HImode == V16SImode
							       || V32HImode == V32HImode
							       || V32HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HImode == V8SFmode
								       || V32HImode == V4DFmode
								       || V32HImode == V4DImode
								       || V32HImode == V8SImode
								       || V32HImode == V16HImode
								       || V32HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3970; /* avx512fp16_vcvtw2ph_v32hi_round */

        case E_V8HFmode:
          switch (pattern935 (x3))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3978; /* avx512fp16_vcvtdq2ph_v8si_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3994; /* avx512fp16_vcvtqq2ph_v8di_round */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern430 (x3, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8650 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4258; /* floatv16siv16sf2_round */

        case E_V8SFmode:
          switch (pattern936 (x3))
            {
            case 0:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8650 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 4262; /* floatv8siv8sf2_round */

            case 1:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4392; /* floatv8div8sf2_round */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (pattern937 (x3, 
E_V8DFmode, 
E_V8DImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4372; /* floatv8div8df2_round */

        case E_V4DFmode:
          if (pattern937 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4380; /* floatv4div4df2_round */

        case E_V4SFmode:
          if (pattern937 (x3, 
E_V4SFmode, 
E_V4DImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4400; /* floatv4div4sf2_round */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HFmode:
          switch (pattern934 (x3))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
							       || V16HImode == V8DFmode
							       || V16HImode == V8DImode
							       || V16HImode == V16SImode
							       || V16HImode == V32HImode
							       || V16HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HImode == V8SFmode
								       || V16HImode == V4DFmode
								       || V16HImode == V4DImode
								       || V16HImode == V8SImode
								       || V16HImode == V16HImode
								       || V16HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3966; /* avx512fp16_vcvtuw2ph_v16hi_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3990; /* avx512fp16_vcvtudq2ph_v16si_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern430 (x3, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
							       || V32HImode == V8DFmode
							       || V32HImode == V8DImode
							       || V32HImode == V16SImode
							       || V32HImode == V32HImode
							       || V32HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HImode == V8SFmode
								       || V32HImode == V4DFmode
								       || V32HImode == V4DImode
								       || V32HImode == V8SImode
								       || V32HImode == V16HImode
								       || V32HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3974; /* avx512fp16_vcvtuw2ph_v32hi_round */

        case E_V8HFmode:
          switch (pattern935 (x3))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3982; /* avx512fp16_vcvtudq2ph_v8si_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3998; /* avx512fp16_vcvtuqq2ph_v8di_round */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern937 (x3, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 539 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4268; /* *floatunsv16siv16sf2_round */

        case E_V8SFmode:
          switch (pattern936 (x3))
            {
            case 0:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 539 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4272; /* *floatunsv8siv8sf2_round */

            case 1:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4396; /* floatunsv8div8sf2_round */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (pattern937 (x3, 
E_V8DFmode, 
E_V8DImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4376; /* floatunsv8div8df2_round */

        case E_V4DFmode:
          if (pattern937 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4384; /* floatunsv4div4df2_round */

        case E_V4SFmode:
          if (pattern937 (x3, 
E_V4SFmode, 
E_V4DImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4404; /* floatunsv4div4sf2_round */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_216 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern432 (x3))
        {
        case 0:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
									       || V16HImode == V8DFmode
									       || V16HImode == V8DImode
									       || V16HImode == V16SImode
									       || V16HImode == V32HImode
									       || V16HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HImode == V8SFmode
										       || V16HImode == V4DFmode
										       || V16HImode == V4DImode
										       || V16HImode == V8SImode
										       || V16HImode == V16HImode
										       || V16HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4080; /* avx512fp16_fix_truncv16hi2_round */

        case 1:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
									       || V32HImode == V8DFmode
									       || V32HImode == V8DImode
									       || V32HImode == V16SImode
									       || V32HImode == V32HImode
									       || V32HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HImode == V8SFmode
										       || V32HImode == V4DFmode
										       || V32HImode == V4DImode
										       || V32HImode == V8SImode
										       || V32HImode == V16HImode
										       || V32HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4088; /* avx512fp16_fix_truncv32hi2_round */

        case 2:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4096; /* avx512fp16_fix_truncv8si2_round */

        case 3:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4455; /* fix_truncv8dfv8si2_round */

        case 4:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4104; /* avx512fp16_fix_truncv16si2_round */

        case 5:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8786 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4326; /* fix_truncv16sfv16si2_round */

        case 6:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4112; /* avx512fp16_fix_truncv8di2_round */

        case 7:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4500; /* fix_truncv8dfv8di2_round */

        case 8:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4508; /* fix_truncv4dfv4di2_round */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern432 (x3))
        {
        case 0:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
									       || V16HImode == V8DFmode
									       || V16HImode == V8DImode
									       || V16HImode == V16SImode
									       || V16HImode == V32HImode
									       || V16HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HImode == V8SFmode
										       || V16HImode == V4DFmode
										       || V16HImode == V4DImode
										       || V16HImode == V8SImode
										       || V16HImode == V16HImode
										       || V16HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4084; /* avx512fp16_fixuns_truncv16hi2_round */

        case 1:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
									       || V32HImode == V8DFmode
									       || V32HImode == V8DImode
									       || V32HImode == V16SImode
									       || V32HImode == V32HImode
									       || V32HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HImode == V8SFmode
										       || V32HImode == V4DFmode
										       || V32HImode == V4DImode
										       || V32HImode == V8SImode
										       || V32HImode == V16HImode
										       || V32HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4092; /* avx512fp16_fixuns_truncv32hi2_round */

        case 2:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4100; /* avx512fp16_fixuns_truncv8si2_round */

        case 3:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4459; /* fixuns_truncv8dfv8si2_round */

        case 4:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4108; /* avx512fp16_fixuns_truncv16si2_round */

        case 5:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8786 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4330; /* fixuns_truncv16sfv16si2_round */

        case 6:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4116; /* avx512fp16_fixuns_truncv8di2_round */

        case 7:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4504; /* fixuns_truncv8dfv8di2_round */

        case 8:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4512; /* fixuns_truncv4dfv4di2_round */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[0], E_V8DFmode)
                  || GET_MODE (x3) != E_V8DFmode
                  || GET_MODE (x4) != E_V8DFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (!register_operand (operands[1], E_V8HFmode)
                      || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 4170; /* avx512fp16_float_extend_phv8df2_round */

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode)
                      || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 10234 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                    return -1;
                  return 4608; /* avx512f_cvtps2pd512_round */

                default:
                  return -1;
                }

            case E_V16SFmode:
              if (pattern430 (x3, 
E_V16HFmode, 
E_V16SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4174; /* avx512fp16_float_extend_phv16sf2_round */

            case E_V8SFmode:
              if (pattern430 (x3, 
E_V8HFmode, 
E_V8SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4178; /* avx512fp16_float_extend_phv8sf2_round */

            case E_V4DFmode:
              if (pattern430 (x3, 
E_V4SFmode, 
E_V4DFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10234 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode))))))
                return -1;
              return 4612; /* avx_cvtps2pd256_round */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x5) != E_V4HFmode)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 4)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x8, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XVECEXP (x8, 0, 2);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x12 = XVECEXP (x8, 0, 3);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || !register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || GET_MODE (x4) != E_V4DFmode)
            return -1;
          x13 = XEXP (x5, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_V8HFmode)
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8060 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode))))))
            return -1;
          return 4182; /* avx512fp16_float_extend_phv4df2_round */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || GET_MODE (x4) != E_V8HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4196; /* avx512fp16_vcvtpd2ph_v8df_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4204; /* avx512fp16_vcvtps2ph_v8sf_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (pattern430 (x3, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4200; /* avx512fp16_vcvtps2ph_v16sf_round */

        case E_V8SFmode:
          if (pattern430 (x3, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10099 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4597; /* *avx512f_cvtpd2ps512_round */

        case E_V4SFmode:
          if (pattern430 (x3, 
E_V4DFmode, 
E_V4SFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10109 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && (!true || TARGET_AVX10_2_256))))
            return -1;
          return 4601; /* avx_cvtpd2ps256_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern471 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4960; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4987; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5014; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5041; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5068; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5095; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5122; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5149; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5176; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5203; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5230; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5257; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4963; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4990; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5017; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5044; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5071; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5098; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5125; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5152; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5179; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5206; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5233; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5260; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4966; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4993; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5020; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5047; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5074; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5101; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5128; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5155; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5182; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5209; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5236; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5263; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6244; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6253; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6262; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6271; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6280; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6289; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6298; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6307; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6316; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6325; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6334; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6343; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern473 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5608; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5635; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5662; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5689; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5716; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5743; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5770; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5797; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5824; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5851; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5878; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5905; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern473 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5611; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5638; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5665; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5692; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5719; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5746; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5773; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5800; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5827; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5854; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5881; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5908; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern473 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5614; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5641; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5668; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5695; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5722; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5749; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5776; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5803; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5830; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5857; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5884; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5911; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BFmode:
          if (pattern26 (x2, 
E_V16BFmode) != 0
              || !(
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 3189; /* *iorv16bf3 */

        case E_V8BFmode:
          if (pattern26 (x2, 
E_V8BFmode) != 0
              || !(
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3192; /* *iorv8bf3 */

        case E_V16HFmode:
          if (pattern26 (x2, 
E_V16HFmode) != 0
              || !(
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 3195; /* *iorv16hf3 */

        case E_V8HFmode:
          if (pattern26 (x2, 
E_V8HFmode) != 0
              || !(
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3198; /* *iorv8hf3 */

        case E_V8SFmode:
          if (pattern26 (x2, 
E_V8SFmode) != 0
              || !(
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 3202; /* *iorv8sf3 */

        case E_V4SFmode:
          if (pattern26 (x2, 
E_V4SFmode) != 0
              || !
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 3208; /* *iorv4sf3 */

        case E_V4DFmode:
          if (pattern26 (x2, 
E_V4DFmode) != 0
              || !(
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 3214; /* *iorv4df3 */

        case E_V2DFmode:
          if (pattern26 (x2, 
E_V2DFmode) != 0
              || !(
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3220; /* *iorv2df3 */

        case E_V32BFmode:
          if (pattern5 (x2, 
E_V32BFmode) != 0
              || !(
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 491 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3225; /* *iorv32bf3 */

        case E_V32HFmode:
          if (pattern5 (x2, 
E_V32HFmode) != 0
              || !(
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 492 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3228; /* *iorv32hf3 */

        case E_V16SFmode:
          if (pattern5 (x2, 
E_V16SFmode) != 0
              || !(
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3232; /* *iorv16sf3 */

        case E_V8DFmode:
          if (pattern5 (x2, 
E_V8DFmode) != 0
              || !(
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3238; /* *iorv8df3 */

        case E_V16SImode:
          if (pattern171 (x2, 
E_V16SImode) != 0
              || !(
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (IOR, V16SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7422; /* *iorv16si3 */

        case E_V8SImode:
          if (pattern171 (x2, 
E_V8SImode) != 0
              || !(
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (IOR, V8SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7428; /* *iorv8si3 */

        case E_V4SImode:
          if (pattern171 (x2, 
E_V4SImode) != 0
              || !
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (IOR, V4SImode, operands)))
            return -1;
          return 7434; /* *iorv4si3 */

        case E_V8DImode:
          if (pattern171 (x2, 
E_V8DImode) != 0
              || !(
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (IOR, V8DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7440; /* *iorv8di3 */

        case E_V4DImode:
          if (pattern171 (x2, 
E_V4DImode) != 0
              || !(
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (IOR, V4DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7446; /* *iorv4di3 */

        case E_V2DImode:
          if (pattern171 (x2, 
E_V2DImode) != 0
              || !
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (IOR, V2DImode, operands)))
            return -1;
          return 7452; /* *iorv2di3 */

        case E_V64QImode:
          if (pattern26 (x2, 
E_V64QImode) != 0
              || !(
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7457; /* *iorv64qi3 */

        case E_V32QImode:
          if (pattern26 (x2, 
E_V32QImode) != 0
              || !(
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7460; /* *iorv32qi3 */

        case E_V16QImode:
          if (pattern26 (x2, 
E_V16QImode) != 0
              || !
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7463; /* *iorv16qi3 */

        case E_V32HImode:
          if (pattern26 (x2, 
E_V32HImode) != 0
              || !(
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7466; /* *iorv32hi3 */

        case E_V16HImode:
          if (pattern26 (x2, 
E_V16HImode) != 0
              || !(
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7469; /* *iorv16hi3 */

        case E_V8HImode:
          if (pattern26 (x2, 
E_V8HImode) != 0
              || !
#line 18846 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7472; /* *iorv8hi3 */

        case E_V1TImode:
          if (pattern608 (x2, 
E_V1TImode) != 0
              || !
#line 18943 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 7475; /* iorv1ti3 */

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern471 (x2))
            {
            case 0:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4941; /* *avx512bw_vpternlogv64qi_1 */

            case 1:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4968; /* *avx512vl_vpternlogv32qi_1 */

            case 2:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4995; /* *avx512vl_vpternlogv16qi_1 */

            case 3:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5022; /* *avx512bw_vpternlogv32hi_1 */

            case 4:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5049; /* *avx512vl_vpternlogv16hi_1 */

            case 5:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5076; /* *avx512vl_vpternlogv8hi_1 */

            case 6:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5103; /* *avx512f_vpternlogv16si_1 */

            case 7:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5130; /* *avx512vl_vpternlogv8si_1 */

            case 8:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5157; /* *avx512vl_vpternlogv4si_1 */

            case 9:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5184; /* *avx512f_vpternlogv8di_1 */

            case 10:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5211; /* *avx512vl_vpternlogv4di_1 */

            case 11:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5238; /* *avx512vl_vpternlogv2di_1 */

            case 12:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4944; /* *avx512bw_vpternlogv64qi_1 */

            case 13:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4971; /* *avx512vl_vpternlogv32qi_1 */

            case 14:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4998; /* *avx512vl_vpternlogv16qi_1 */

            case 15:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5025; /* *avx512bw_vpternlogv32hi_1 */

            case 16:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5052; /* *avx512vl_vpternlogv16hi_1 */

            case 17:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5079; /* *avx512vl_vpternlogv8hi_1 */

            case 18:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5106; /* *avx512f_vpternlogv16si_1 */

            case 19:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5133; /* *avx512vl_vpternlogv8si_1 */

            case 20:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5160; /* *avx512vl_vpternlogv4si_1 */

            case 21:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5187; /* *avx512f_vpternlogv8di_1 */

            case 22:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5214; /* *avx512vl_vpternlogv4di_1 */

            case 23:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5241; /* *avx512vl_vpternlogv2di_1 */

            case 24:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4947; /* *avx512bw_vpternlogv64qi_1 */

            case 25:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4974; /* *avx512vl_vpternlogv32qi_1 */

            case 26:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5001; /* *avx512vl_vpternlogv16qi_1 */

            case 27:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5028; /* *avx512bw_vpternlogv32hi_1 */

            case 28:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5055; /* *avx512vl_vpternlogv16hi_1 */

            case 29:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5082; /* *avx512vl_vpternlogv8hi_1 */

            case 30:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5109; /* *avx512f_vpternlogv16si_1 */

            case 31:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5136; /* *avx512vl_vpternlogv8si_1 */

            case 32:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5163; /* *avx512vl_vpternlogv4si_1 */

            case 33:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5190; /* *avx512f_vpternlogv8di_1 */

            case 34:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5217; /* *avx512vl_vpternlogv4di_1 */

            case 35:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5244; /* *avx512vl_vpternlogv2di_1 */

            case 36:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6237; /* *avx512bw_vpternlogv64qi_3 */

            case 37:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6246; /* *avx512vl_vpternlogv32qi_3 */

            case 38:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6255; /* *avx512vl_vpternlogv16qi_3 */

            case 39:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6264; /* *avx512bw_vpternlogv32hi_3 */

            case 40:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6273; /* *avx512vl_vpternlogv16hi_3 */

            case 41:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6282; /* *avx512vl_vpternlogv8hi_3 */

            case 42:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6291; /* *avx512f_vpternlogv16si_3 */

            case 43:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6300; /* *avx512vl_vpternlogv8si_3 */

            case 44:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6309; /* *avx512vl_vpternlogv4si_3 */

            case 45:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6318; /* *avx512f_vpternlogv8di_3 */

            case 46:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6327; /* *avx512vl_vpternlogv4di_3 */

            case 47:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6336; /* *avx512vl_vpternlogv2di_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern473 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5589; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5616; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5643; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5670; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5697; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5724; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5751; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5778; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5805; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5832; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5859; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5886; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern473 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5592; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5619; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5646; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5673; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5700; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5727; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5754; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5781; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5808; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5835; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5862; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5889; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern473 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5595; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5622; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5649; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5676; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5703; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5730; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5757; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5784; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5811; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5838; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5865; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5892; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      return recog_290 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_289 (x1, insn, pnum_clobbers);

    case NOT:
      switch (pattern294 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern854 (x2, 
E_V16SImode) != 0
                  || !(
#line 18970 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7477; /* *iornotv16si3 */

            case E_V8DImode:
              if (pattern854 (x2, 
E_V8DImode) != 0
                  || !(
#line 18970 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7478; /* *iornotv8di3 */

            case E_V64QImode:
              if (pattern854 (x2, 
E_V64QImode) != 0
                  || !(
#line 18970 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7479; /* *iornotv64qi3 */

            case E_V32QImode:
              if (pattern854 (x2, 
E_V32QImode) != 0
                  || !(
#line 18970 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7480; /* *iornotv32qi3 */

            case E_V16QImode:
              if (pattern854 (x2, 
E_V16QImode) != 0
                  || !
#line 18970 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
                return -1;
              return 7481; /* *iornotv16qi3 */

            case E_V32HImode:
              if (pattern854 (x2, 
E_V32HImode) != 0
                  || !(
#line 18970 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7482; /* *iornotv32hi3 */

            case E_V16HImode:
              if (pattern854 (x2, 
E_V16HImode) != 0
                  || !(
#line 18970 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7483; /* *iornotv16hi3 */

            case E_V8HImode:
              if (pattern854 (x2, 
E_V8HImode) != 0
                  || !
#line 18970 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
                return -1;
              return 7484; /* *iornotv8hi3 */

            case E_V8SImode:
              if (pattern854 (x2, 
E_V8SImode) != 0
                  || !(
#line 18970 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7485; /* *iornotv8si3 */

            case E_V4SImode:
              if (pattern854 (x2, 
E_V4SImode) != 0
                  || !
#line 18970 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
                return -1;
              return 7486; /* *iornotv4si3 */

            case E_V4DImode:
              if (pattern854 (x2, 
E_V4DImode) != 0
                  || !(
#line 18970 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7487; /* *iornotv4di3 */

            case E_V2DImode:
              if (pattern854 (x2, 
E_V2DImode) != 0
                  || !
#line 18970 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
                return -1;
              return 7488; /* *iornotv2di3 */

            default:
              return -1;
            }

        case 1:
          if (!(
#line 19034 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7502; /* *nandv16si3 */

        case 2:
          if (!(
#line 19034 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7504; /* *nandv8di3 */

        case 3:
          if (!(
#line 19034 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7506; /* *nandv64qi3 */

        case 4:
          if (!(
#line 19034 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7508; /* *nandv32qi3 */

        case 5:
          if (!
#line 19034 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
            return -1;
          return 7510; /* *nandv16qi3 */

        case 6:
          if (!(
#line 19034 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7512; /* *nandv32hi3 */

        case 7:
          if (!(
#line 19034 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7514; /* *nandv16hi3 */

        case 8:
          if (!
#line 19034 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
            return -1;
          return 7516; /* *nandv8hi3 */

        case 9:
          if (!(
#line 19034 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7518; /* *nandv8si3 */

        case 10:
          if (!
#line 19034 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
            return -1;
          return 7520; /* *nandv4si3 */

        case 11:
          if (!(
#line 19034 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7522; /* *nandv4di3 */

        case 12:
          if (!
#line 19034 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
            return -1;
          return 7524; /* *nandv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!(
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2473; /* *sminv32hf3 */

    case 1:
      if (!(
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2481; /* *sminv16hf3 */

    case 2:
      if (!(
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2487; /* *sminv8hf3 */

    case 3:
      if (!(
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2493; /* *sminv16sf3 */

    case 4:
      if (!(
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2501; /* *sminv8sf3 */

    case 5:
      if (!
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1))
        return -1;
      return 2507; /* *sminv4sf3 */

    case 6:
      if (!(
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2513; /* *sminv8df3 */

    case 7:
      if (!(
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2521; /* *sminv4df3 */

    case 8:
      if (!(
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2527; /* *sminv2df3 */

    case 9:
      if (
#line 17680 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7175; /* *avx2_sminv32qi3 */
      if (!(
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7252; /* *avx512bw_sminv32qi3 */

    case 10:
      if (
#line 17680 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7179; /* *avx2_sminv16hi3 */
      if (!(
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7268; /* *avx512bw_sminv16hi3 */

    case 11:
      if (
#line 17680 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7183; /* *avx2_sminv8si3 */
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7196; /* *avx512f_sminv8si3 */

    case 12:
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7188; /* *avx512f_sminv16si3 */

    case 13:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7204; /* *avx512f_sminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17824 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7288; /* *sse4_1_sminv4si3 */

    case 14:
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7212; /* *avx512f_sminv8di3 */

    case 15:
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7220; /* *avx512f_sminv4di3 */

    case 16:
      if (!(
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7228; /* *avx512f_sminv2di3 */

    case 17:
      if (!(
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7236; /* *avx512bw_sminv64qi3 */

    case 18:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7244; /* *avx512bw_sminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17824 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7284; /* *sse4_1_sminv16qi3 */

    case 19:
      if (!(
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7260; /* *avx512bw_sminv32hi3 */

    case 20:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7276; /* *avx512bw_sminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17843 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7291; /* *sminv8hi3 */

    case 21:
      if (!(
#line 32113 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 9954; /* avx10_2_sminbf16_v32bf */

    case 22:
      if (!
#line 32113 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 9958; /* avx10_2_sminbf16_v16bf */

    case 23:
      if (!
#line 32113 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 9962; /* avx10_2_sminbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern453 (x3, 
E_V32HFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2326; /* avx512fp16_divv32hf3 */

    case E_V16HFmode:
      if (pattern453 (x3, 
E_V16HFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2330; /* avx512fp16_divv16hf3 */

    case E_V8HFmode:
      if (pattern453 (x3, 
E_V8HFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2334; /* avx512fp16_divv8hf3 */

    case E_V16SFmode:
      if (pattern453 (x3, 
E_V16SFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2336; /* avx512f_divv16sf3 */

    case E_V8SFmode:
      if (pattern453 (x3, 
E_V8SFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2340; /* avx_divv8sf3 */

    case E_V4SFmode:
      if (pattern453 (x3, 
E_V4SFmode) != 0
          || !
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1))
        return -1;
      return 2344; /* sse_divv4sf3 */

    case E_V8DFmode:
      if (pattern453 (x3, 
E_V8DFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2346; /* avx512f_divv8df3 */

    case E_V4DFmode:
      if (pattern453 (x3, 
E_V4DFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2350; /* avx_divv4df3 */

    case E_V2DFmode:
      if (pattern453 (x3, 
E_V2DFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2354; /* sse2_divv2df3 */

    case E_V32BFmode:
      if (pattern27 (x3, 
E_V32BFmode) != 0
          || !(
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 9970; /* avx10_2_divbf16_v32bf */

    case E_V16BFmode:
      if (pattern27 (x3, 
E_V16BFmode) != 0
          || !
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 9978; /* avx10_2_divbf16_v16bf */

    case E_V8BFmode:
      if (pattern27 (x3, 
E_V8BFmode) != 0
          || !
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 9986; /* avx10_2_divbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case CLOBBER:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MEM:
          if (GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SCRATCH)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (push_operand (operands[0], E_SImode)
                  && general_no_elim_operand (operands[1], E_SImode)
                  && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode))
                return 68; /* *pushsi2_prologue */
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !pop_operand (operands[1], E_SImode)
                  || !
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode))
                return -1;
              return 72; /* *popsi1_epilogue */

            case E_DImode:
              if (push_operand (operands[0], E_DImode)
                  && general_no_elim_operand (operands[1], E_DImode)
                  && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode))
                return 69; /* *pushdi2_prologue */
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !pop_operand (operands[1], E_DImode)
                  || !
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode))
                return -1;
              return 73; /* *popdi1_epilogue */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (const0_operand (operands[1], E_SImode))
                {
                  if (register_operand (operands[0], E_SImode)
                      && 
#line 2424 "../../../gcc/config/i386/i386.md"
(reload_completed))
                    return 78; /* *movsi_xor */
                  if (memory_operand (operands[0], E_SImode)
                      && 
#line 2434 "../../../gcc/config/i386/i386.md"
(reload_completed))
                    return 80; /* *movsi_and */
                }
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !constm1_operand (operands[1], E_SImode)
                  || !
#line 2444 "../../../gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 82; /* *movsi_or */

            case E_HImode:
              if (memory_operand (operands[0], E_HImode)
                  && const0_operand (operands[1], E_HImode)
                  && 
#line 2434 "../../../gcc/config/i386/i386.md"
(reload_completed))
                return 79; /* *movhi_and */
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || !constm1_operand (operands[1], E_HImode)
                  || !
#line 2444 "../../../gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 81; /* *movhi_or */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 98; /* swapsi */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 99; /* *swapqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 100; /* *swaphi */

            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 4644 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 145; /* *swapxf */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 72
              || GET_MODE (x8) != E_XFmode
              || !register_operand (operands[0], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!const1_operand (operands[3], E_SFmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_XFmode)
              || !
#line 23937 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1376; /* fptanxf4_i387 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 108
          || GET_MODE (x4) != E_DImode)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (!pop_operand (operands[1], E_DImode)
          || !
#line 3918 "../../../gcc/config/i386/i386.md"
(TARGET_APX_PPX))
        return -1;
      return 135; /* popp_di */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern297 (x2, 
E_CCmode, 
17) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !general_operand (operands[2], E_QImode)
              || !
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 227; /* *addqi_1_zexthi */

        case E_SImode:
          switch (pattern1308 (x4, 
E_SImode))
            {
            case 0:
              if (!
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 229; /* *addqi_1_zextsi */

            case 1:
              if (!
#line 6715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 233; /* *addhi_1_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern1308 (x4, 
E_DImode))
            {
            case 0:
              if (!
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 231; /* *addqi_1_zextdi */

            case 1:
              if (!
#line 6715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 235; /* *addhi_1_zextdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case LTU:
        case UNLT:
          operands[3] = x8;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 17)
            return -1;
          x10 = XEXP (x8, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x6, 1);
          operands[1] = x11;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode
                  || GET_MODE (x5) != E_QImode
                  || pattern1521 (x6, 
E_QImode) != 0
                  || !
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 387; /* *addqi3_carry_zexthi */

            case E_SImode:
              switch (pattern1522 (x4, 
E_SImode))
                {
                case 0:
                  if (!
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 388; /* *addqi3_carry_zextsi */

                case 1:
                  if (!
#line 8914 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 390; /* *addhi3_carry_zextsi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1522 (x4, 
E_DImode))
                {
                case 0:
                  if (!
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 389; /* *addqi3_carry_zextdi */

                case 1:
                  if (!
#line 8914 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 391; /* *addhi3_carry_zextdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern1052 (x5))
        {
        case 0:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_QImode
              || !ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 392; /* *addqi3_carry_zexthi_0 */

        case 1:
          switch (pattern1426 (x4, 
E_SImode))
            {
            case 0:
              if (!
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 393; /* *addqi3_carry_zextsi_0 */

            case 1:
              if (!
#line 8966 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 395; /* *addhi3_carry_zextsi_0 */

            default:
              return -1;
            }

        case 2:
          switch (pattern1426 (x4, 
E_DImode))
            {
            case 0:
              if (!
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 394; /* *addqi3_carry_zextdi_0 */

            case 1:
              if (!
#line 8966 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 396; /* *addhi3_carry_zextdi_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern1052 (x5))
        {
        case 0:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_QImode
              || !ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 397; /* *addqi3_carry_zexthi_0r */

        case 1:
          switch (pattern1427 (x4, 
E_SImode))
            {
            case 0:
              if (!
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 398; /* *addqi3_carry_zextsi_0r */

            case 1:
              if (!
#line 9011 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 400; /* *addhi3_carry_zextsi_0r */

            default:
              return -1;
            }

        case 2:
          switch (pattern1427 (x4, 
E_DImode))
            {
            case 0:
              if (!
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 399; /* *addqi3_carry_zextdi_0r */

            case 1:
              if (!
#line 9011 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 401; /* *addhi3_carry_zextdi_0r */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern1053 (x6) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 23083 "../../../gcc/config/i386/i386.md"
(TARGET_X32))
        return -1;
      return 1325; /* *add_tp_x32_zext */

    default:
      return -1;
    }
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[3], E_SFmode)
          || !nonimmediate_operand (operands[4], E_V4SFmode)
          || !
#line 5911 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)))
        return -1;
      *pnum_clobbers = 2;
      return 177; /* *fixuns_truncsf_1 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[3], E_DFmode)
          || !nonimmediate_operand (operands[4], E_V2DFmode)
          || !
#line 5911 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)))
        return -1;
      *pnum_clobbers = 2;
      return 178; /* *fixuns_truncdf_1 */

    default:
      return -1;
    }
}

 int
recog_355 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (scratch_operand (operands[2], E_XFmode))
        {
          switch (pattern483 (x4))
            {
            case 0:
              if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
	&& TARGET_SSE_MATH)))
                return 181; /* fix_trunchi_i387_fisttp */
              break;

            case 1:
              if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
	&& TARGET_SSE_MATH)))
                return 182; /* fix_truncsi_i387_fisttp */
              break;

            case 2:
              if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
	&& TARGET_SSE_MATH)))
                return 183; /* fix_truncdi_i387_fisttp */
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCmode)
        return -1;
      switch (pattern483 (x4))
        {
        case 0:
          if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
   && ix86_pre_reload_split ()))
            return -1;
          return 184; /* *fix_trunchi_i387_1 */

        case 1:
          if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
   && ix86_pre_reload_split ()))
            return -1;
          return 185; /* *fix_truncsi_i387_1 */

        case 2:
          if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
   && ix86_pre_reload_split ()))
            return -1;
          return 186; /* *fix_truncdi_i387_1 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern622 (x1, 
E_V2SFmode, 
E_V2SImode) != 0
          || !
#line 1558 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 1640; /* mmx_fix_truncv2sfv2si2 */

    default:
      return -1;
    }
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      if (pnum_clobbers == NULL
          || !register_operand (operands[1], E_DImode))
        return -1;
      switch (pattern858 (x1))
        {
        case 0:
          if (!
#line 6206 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          *pnum_clobbers = 2;
          return 202; /* floatdisf2_i387_with_xmm */

        case 1:
          if (!
#line 6206 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          *pnum_clobbers = 2;
          return 203; /* floatdidf2_i387_with_xmm */

        case 2:
          if (!
#line 6206 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          *pnum_clobbers = 2;
          return 204; /* floatdixf2_i387_with_xmm */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern622 (x1, 
E_V2SImode, 
E_V2SFmode) != 0
          || !
#line 1600 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 1641; /* mmx_floatv2siv2sf2 */

    default:
      return -1;
    }
}

 int
recog_359 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      res = recog_358 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern505 (x4) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern519 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      switch (pattern1487 (x2))
        {
        case 0:
          if (
#line 6995 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 242; /* *addqi_exthi_1_slp */
          break;

        case 1:
          if (
#line 6995 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 243; /* *addqi_extsi_1_slp */
          break;

        case 2:
          if ((
#line 6995 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 244; /* *addqi_extdi_1_slp */
          break;

        case 3:
          return 263; /* *addqi_exthi_0 */

        case 4:
          return 264; /* *addqi_extsi_0 */

        default:
          break;
        }
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != SUBREG)
        return -1;
      switch (pattern1488 (x2))
        {
        case 0:
          if (!
#line 7028 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 245; /* *addqi_exthi_2_slp */

        case 1:
          if (!
#line 7028 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 246; /* *addqi_extsi_2_slp */

        case 2:
          if (!(
#line 7028 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 247; /* *addqi_extdi_2_slp */

        case 3:
          return 265; /* *addqi_ext2hi_0 */

        case 4:
          return 266; /* *addqi_ext2si_0 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern298 (x5) != 0)
        return -1;
      switch (pattern860 (x2))
        {
        case 0:
          if (!(
#line 6511 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 214; /* *adddi3_doubleword_zext */

        case 1:
          if (!(
#line 6511 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 215; /* *addti3_doubleword_zext */

        default:
          return -1;
        }

    case PLUS:
      if (pattern299 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          switch (pattern1054 (x3))
            {
            case 0:
              if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 216; /* *adddi3_doubleword_concat */

            case 1:
              if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 219; /* *adddi3_doubleword_concat_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          operands[4] = x6;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1489 (x3, 
E_QImode) != 0
                  || !
#line 8793 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 375; /* addqi3_carry */

            case E_HImode:
              if (pattern1489 (x3, 
E_HImode) != 0
                  || !
#line 8793 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 376; /* addhi3_carry */

            case E_SImode:
              if (pattern1490 (x3, 
E_SImode) != 0
                  || !
#line 8793 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 377; /* addsi3_carry */

            case E_DImode:
              if (pattern1490 (x3, 
E_DImode) != 0
                  || !(
#line 8793 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 378; /* adddi3_carry */

            default:
              return -1;
            }

        case EQ:
          switch (pattern1057 (x3))
            {
            case 0:
              if (!
#line 10136 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 463; /* *addqi3_eq */

            case 1:
              if (!
#line 10136 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 464; /* *addhi3_eq */

            case 2:
              if (!
#line 10136 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 465; /* *addsi3_eq */

            case 3:
              if (!(
#line 10136 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 466; /* *adddi3_eq */

            default:
              return -1;
            }

        case NE:
          switch (pattern1060 (x3))
            {
            case 0:
              if (!
#line 10157 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 467; /* *addqi3_ne */

            case 1:
              if (!
#line 10157 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 468; /* *addhi3_ne */

            case 2:
              if (!
#line 10157 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 469; /* *addsi3_ne */

            case 3:
              if (!(
#line 10157 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 470; /* *adddi3_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern302 (x1))
        {
        case 0:
          if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 217; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 220; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern302 (x1))
        {
        case 0:
          if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 218; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 221; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern303 (x1))
        {
        case 0:
          if (pattern1391 (x3, 
E_QImode) != 0
              || !
#line 8865 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 379; /* *addqi3_carry_0 */

        case 1:
          if (pattern1391 (x3, 
E_HImode) != 0
              || !
#line 8865 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 380; /* *addhi3_carry_0 */

        case 2:
          if (pattern1391 (x3, 
E_SImode) != 0
              || !
#line 8865 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 381; /* *addsi3_carry_0 */

        case 3:
          if (pattern1391 (x3, 
E_DImode) != 0
              || !(
#line 8865 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 382; /* *adddi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern303 (x1))
        {
        case 0:
          if (pattern1392 (x3, 
E_QImode) != 0
              || !
#line 8879 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 383; /* *addqi3_carry_0r */

        case 1:
          if (pattern1392 (x3, 
E_HImode) != 0
              || !
#line 8879 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 384; /* *addhi3_carry_0r */

        case 2:
          if (pattern1392 (x3, 
E_SImode) != 0
              || !
#line 8879 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 385; /* *addsi3_carry_0r */

        case 3:
          if (pattern1392 (x3, 
E_DImode) != 0
              || !(
#line 8879 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 386; /* *adddi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern307 (x1))
        {
        case 0:
          if (!
#line 10183 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 471; /* *addqi3_eq_0 */

        case 1:
          if (!
#line 10183 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 472; /* *addhi3_eq_0 */

        case 2:
          if (!
#line 10183 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 473; /* *addsi3_eq_0 */

        case 3:
          if (!(
#line 10183 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 474; /* *adddi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern307 (x1))
        {
        case 0:
          if (!
#line 10204 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 475; /* *addqi3_ne_0 */

        case 1:
          if (!
#line 10204 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 476; /* *addhi3_ne_0 */

        case 2:
          if (!
#line 10204 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 477; /* *addsi3_ne_0 */

        case 3:
          if (!(
#line 10204 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 478; /* *adddi3_ne_0 */

        default:
          return -1;
        }

    case MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern297 (x5, 
E_CCmode, 
17) != 0)
        return -1;
      switch (pattern864 (x2))
        {
        case 0:
          if (!
#line 10252 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 483; /* *subqi3_ne */

        case 1:
          if (!
#line 10252 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 484; /* *subhi3_ne */

        case 2:
          if (!
#line 10252 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 485; /* *subsi3_ne */

        case 3:
          if (!(
#line 10252 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 486; /* *subdi3_ne */

        case 4:
          if (!
#line 10281 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 487; /* *subqi3_eq_1 */

        case 5:
          if (!
#line 10281 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 488; /* *subhi3_eq_1 */

        case 6:
          if (!
#line 10281 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 489; /* *subsi3_eq_1 */

        case 7:
          if (!(
#line 10281 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 490; /* *subdi3_eq_1 */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != ASHIFT
          || GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (pattern865 (x11, 
E_SImode) != 0)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_MODE (x12) != E_CCCmode)
        return -1;
      x13 = XEXP (x11, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x8, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern632 (x1) != 0)
        return -1;
      return 1142; /* rcrsi2 */

    case UNSPEC:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern298 (x5) != 0)
        return -1;
      switch (pattern867 (x2))
        {
        case 0:
          if (!
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          return 1323; /* *add_tp_si */

        case 1:
          if (!
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          return 1324; /* *add_tp_di */

        case 2:
          if (!
#line 23158 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
            return -1;
          return 1328; /* *tls_dynamic_gnu2_combine_32 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_378 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern518 (x1))
        {
        case 0:
          if (
#line 12741 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 589; /* *xorqi_1_slp */
          break;

        case 1:
          if (
#line 12741 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 592; /* *xorhi_1_slp */
          break;

        case 2:
          if (x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 13527 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 663; /* *xordi3_doubleword */
          if (x86_64_general_operand (operands[2], E_DImode)
              && (
#line 13585 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 677; /* *xordi_1 */
          break;

        case 3:
          if ((
#line 13527 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 665; /* *xorti3_doubleword */
          break;

        case 4:
          if (
#line 13585 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)
   && true))
            return 669; /* *xorhi_1 */
          break;

        case 5:
          if (
#line 13585 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)
   && true))
            return 673; /* *xorsi_1 */
          break;

        case 6:
          if (
#line 4713 "../../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V4QImode, operands)))
            return 1803; /* *xorv4qi3 */
          break;

        case 7:
          if (
#line 4713 "../../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V2QImode, operands)))
            return 1806; /* *xorv2qi3 */
          break;

        case 8:
          if (
#line 4713 "../../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V2HImode, operands)))
            return 1809; /* *xorv2hi3 */
          break;

        case 9:
          if (
#line 2093 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2058; /* kxorqi */
          break;

        case 10:
          if (
#line 2093 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2061; /* kxorhi */
          break;

        case 11:
          if ((
#line 2093 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2074 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2064; /* kxorsi */
          break;

        case 12:
          if ((
#line 2093 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2074 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2067; /* kxordi */
          break;

        default:
          break;
        }
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern519 (x1) != 0)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern505 (x4) == 0)
        {
          x6 = XEXP (x4, 0);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (pattern1487 (x2))
            {
            case 0:
              if (
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 595; /* *xorqi_exthi_1_slp */
              break;

            case 1:
              if (
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 598; /* *xorqi_extsi_1_slp */
              break;

            case 2:
              if ((
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 601; /* *xorqi_extdi_1_slp */
              break;

            case 3:
              return 617; /* *xorqi_exthi_0 */

            case 4:
              return 620; /* *xorqi_extsi_0 */

            default:
              break;
            }
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) == SUBREG)
            {
              switch (pattern1488 (x2))
                {
                case 0:
                  if (
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 604; /* *xorqi_exthi_2_slp */
                  break;

                case 1:
                  if (
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 607; /* *xorqi_extsi_2_slp */
                  break;

                case 2:
                  if ((
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 610; /* *xorqi_extdi_2_slp */
                  break;

                case 3:
                  return 623; /* *xorqi_ext2hi_0 */

                case 4:
                  return 626; /* *xorqi_ext2si_0 */

                default:
                  break;
                }
            }
        }
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      if (!nonimmediate_operand (operands[0], E_QImode))
        return -1;
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!general_operand (operands[2], E_QImode)
          || !
#line 13775 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      return 707; /* *xorqi_1 */

    case AND:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != XOR)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern298 (x5) != 0)
        return -1;
      switch (pattern956 (x2))
        {
        case 0:
          if (!
#line 13684 "../../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()))
            return -1;
          return 681; /* *xor2andn */

        case 1:
          if (!
#line 13684 "../../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()))
            return -1;
          return 682; /* *xor2andn */

        case 2:
          if (!(
#line 13684 "../../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 683; /* *xor2andn */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern319 (x1, 
1))
        {
        case 0:
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          if (pattern1222 (x3) == 0
              && 
#line 18805 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT))
            return 1146; /* *btcsi */
          if (GET_CODE (x10) != SUBREG)
            return -1;
          switch (pattern1223 (x3))
            {
            case 0:
              if (!
#line 18824 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1148; /* *btcsi_mask */

            case 1:
              if (!(
#line 18824 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1150; /* *btcdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18852 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          return 1152; /* *btcsi_mask_1 */

        case 2:
          if (!(
#line 18852 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1154; /* *btcdi_mask_1 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      if (GET_CODE (x10) != CONST_INT
          || pattern520 (x1) != 0)
        return -1;
      switch (XWINT (x10, 0))
        {
        case -1LL:
          if (!
#line 21800 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1282; /* *bmi_blsmsk_si */

        case 1LL:
          if (!
#line 22061 "../../../gcc/config/i386/i386.md"
(TARGET_TBM))
            return -1;
          return 1296; /* *tbm_blcmsk_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          x4 = XEXP (x2, 1);
          if (GET_MODE (x4) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && nonmemory_operand (operands[2], E_QImode))
            return 922; /* ashrdi3_doubleword */
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if (const_int_operand (operands[2], E_QImode)
              && (
#line 17244 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 946; /* ashrdi3_cvt */
          if (!nonmemory_operand (operands[2], E_QImode)
              || !(
#line 17323 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 952; /* *ashrdi3_1 */

        case E_SImode:
          x4 = XEXP (x2, 1);
          if (pattern1370 (x4, 
E_SImode) != 0
              || !
#line 17323 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 950; /* *ashrsi3_1 */

        case E_QImode:
          x4 = XEXP (x2, 1);
          if (pattern1370 (x4, 
E_QImode) != 0
              || !
#line 17532 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 978; /* *ashrqi3_1 */

        case E_HImode:
          x4 = XEXP (x2, 1);
          if (pattern1370 (x4, 
E_HImode) != 0
              || !
#line 17532 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 980; /* *ashrhi3_1 */

        case E_V2QImode:
          x4 = XEXP (x2, 1);
          if (pattern1234 (x4) != 0
              || !
#line 4007 "../../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
            return -1;
          return 1745; /* ashrv2qi3 */

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      switch (pattern1228 (x2))
        {
        case 0:
          if (!
#line 17638 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 986; /* *ashrqi3_1_slp */

        case 1:
          if (!
#line 17638 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 988; /* *ashrhi3_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern199 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || GET_MODE (x3) != E_CCmode
          || !
#line 21500 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
        return -1;
      return 1258; /* clzsi2_lzcnt */

    case 1:
      x2 = XVECEXP (x1, 0, 1);
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 38)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      if (
#line 21525 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT))
        return 1259; /* *clzsi2_lzcnt_falsedep_nf */
      if (pnum_clobbers == NULL
          || !
#line 21538 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
        return -1;
      *pnum_clobbers = 1;
      return 1260; /* *clzsi2_lzcnt_falsedep */

    default:
      return -1;
    }
}

 int
recog_389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 2:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern297 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !(
#line 27048 "../../../gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1501; /* allocate_stack_worker_probe_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 27048 "../../../gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1502; /* allocate_stack_worker_probe_di */

            default:
              return -1;
            }

        case 10:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern620 (x5, 
E_SImode, 
10, 
UNSPEC_VOLATILE) != 0
              || !register_operand (operands[0], E_DImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 1531; /* rdtscp */

        case 44:
          switch (pattern644 (x1, 
44))
            {
            case 0:
              if (!
#line 29335 "../../../gcc/config/i386/i386.md"
(TARGET_RDRND))
                return -1;
              return 1553; /* rdrandhi */

            case 1:
              if (!
#line 29335 "../../../gcc/config/i386/i386.md"
(TARGET_RDRND))
                return -1;
              return 1554; /* rdrandsi */

            default:
              return -1;
            }

        case 45:
          switch (pattern644 (x1, 
45))
            {
            case 0:
              if (!
#line 29345 "../../../gcc/config/i386/i386.md"
(TARGET_RDSEED))
                return -1;
              return 1555; /* rdseedhi */

            case 1:
              if (!
#line 29345 "../../../gcc/config/i386/i386.md"
(TARGET_RDSEED))
                return -1;
              return 1556; /* rdseedsi */

            default:
              return -1;
            }

        case 56:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 29588 "../../../gcc/config/i386/i386.md"
(TARGET_PKU))
            return -1;
          return 1578; /* *rdpkru */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x4, 1))
        {
        case 3:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern297 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1315 (x4, 
E_SImode) != 0
                  || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))
                return -1;
              return 1507; /* probe_stack_range_si */

            case E_DImode:
              if (pattern1315 (x4, 
E_DImode) != 0
                  || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))
                return -1;
              return 1508; /* probe_stack_range_di */

            default:
              return -1;
            }

        case 99:
          if (pattern645 (x1, 
99) != 0
              || !
#line 31361 "../../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9721; /* aesdec128klu8 */

        case 101:
          if (pattern645 (x1, 
101) != 0
              || !
#line 31361 "../../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9722; /* aesdec256klu8 */

        case 100:
          if (pattern645 (x1, 
100) != 0
              || !
#line 31361 "../../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9723; /* aesenc128klu8 */

        case 102:
          if (pattern645 (x1, 
102) != 0
              || !
#line 31361 "../../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9724; /* aesenc256klu8 */

        case 110:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          x9 = XVECEXP (x4, 0, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x8 = XEXP (x5, 1);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pnum_clobbers == NULL)
                return -1;
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              x11 = XEXP (x8, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1437 (x1, 
E_QImode) != 0
                      || !
#line 703 "../../../gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10377; /* atomic_fetch_addqi */

                case E_HImode:
                  if (pattern1437 (x1, 
E_HImode) != 0
                      || !
#line 703 "../../../gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10378; /* atomic_fetch_addhi */

                case E_SImode:
                  if (pattern1437 (x1, 
E_SImode) != 0
                      || !
#line 703 "../../../gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10379; /* atomic_fetch_addsi */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1371 (x4, 
E_QImode) != 0)
                    return -1;
                  return 10383; /* atomic_exchangeqi */

                case E_HImode:
                  if (pattern1371 (x4, 
E_HImode) != 0)
                    return -1;
                  return 10384; /* atomic_exchangehi */

                case E_SImode:
                  if (pattern1371 (x4, 
E_SImode) != 0)
                    return -1;
                  return 10385; /* atomic_exchangesi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 111:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern297 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x6))
            {
            case PLUS:
              switch (pattern1317 (x4))
                {
                case 0:
                  return 10390; /* atomic_addqi */

                case 1:
                  return 10391; /* atomic_addhi */

                case 2:
                  return 10392; /* atomic_addsi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern1317 (x4))
                {
                case 0:
                  return 10393; /* atomic_subqi */

                case 1:
                  return 10394; /* atomic_subhi */

                case 2:
                  return 10395; /* atomic_subsi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern1317 (x4))
                {
                case 0:
                  return 10396; /* atomic_andqi */

                case 1:
                  return 10399; /* atomic_andhi */

                case 2:
                  return 10402; /* atomic_andsi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern1317 (x4))
                {
                case 0:
                  return 10397; /* atomic_orqi */

                case 1:
                  return 10400; /* atomic_orhi */

                case 2:
                  return 10403; /* atomic_orsi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern1317 (x4))
                {
                case 0:
                  return 10398; /* atomic_xorqi */

                case 1:
                  return 10401; /* atomic_xorhi */

                case 2:
                  return 10404; /* atomic_xorsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_CODE (operands[0]))
    {
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (push_operand (operands[0], E_DImode))
            {
              if (general_gr_operand (operands[1], E_DImode)
                  && (
#line 2199 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return gen_split_3 (insn, operands);
              if (sse_reg_operand (operands[1], E_DImode))
                {
                  if ((
#line 2269 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return gen_split_5 (insn, operands);
                  if ((
#line 2269 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return gen_split_7 (insn, operands);
                }
            }
          break;

        case E_SImode:
          if (push_operand (operands[0], E_SImode)
              && sse_reg_operand (operands[1], E_SImode))
            {
              if ((
#line 2269 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_4 (insn, operands);
              if ((
#line 2269 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_6 (insn, operands);
            }
          break;

        case E_TFmode:
          if (push_operand (operands[0], E_TFmode)
              && sse_reg_operand (operands[1], E_TFmode))
            {
              if ((
#line 3779 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_15 (insn, operands);
              if ((
#line 3779 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_16 (insn, operands);
            }
          break;

        case E_XFmode:
          if (push_operand (operands[0], E_XFmode)
              && fp_register_operand (operands[1], E_XFmode))
            {
              if ((
#line 3814 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_17 (insn, operands);
              if ((
#line 3814 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_18 (insn, operands);
            }
          break;

        case E_DFmode:
          if (push_operand (operands[0], E_DFmode)
              && any_fp_register_operand (operands[1], E_DFmode))
            {
              if ((
#line 3848 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_19 (insn, operands);
              if ((
#line 3848 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_20 (insn, operands);
            }
          break;

        case E_SFmode:
          if (push_operand (operands[0], E_SFmode))
            {
              if (any_fp_register_operand (operands[1], E_SFmode))
                {
                  if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return gen_split_21 (insn, operands);
                  if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return gen_split_24 (insn, operands);
                }
              if (memory_operand (operands[1], E_SFmode)
                  && 
#line 4002 "../../../gcc/config/i386/i386.md"
(reload_completed
   && find_constant_src (insn)))
                return gen_split_27 (insn, operands);
            }
          break;

        case E_HFmode:
          if (push_operand (operands[0], E_HFmode)
              && any_fp_register_operand (operands[1], E_HFmode))
            {
              if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_22 (insn, operands);
              if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_25 (insn, operands);
            }
          break;

        case E_BFmode:
          if (push_operand (operands[0], E_BFmode)
              && any_fp_register_operand (operands[1], E_BFmode))
            {
              if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_23 (insn, operands);
              if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_26 (insn, operands);
            }
          break;

        default:
          break;
        }
      break;

    case REG:
      if (general_reg_operand (operands[0], E_DImode)
          && sse_reg_operand (operands[1], E_DImode)
          && (
#line 2755 "../../../gcc/config/i386/i386.md"
(TARGET_SSE4_1
   && reload_completed) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return gen_split_8 (insn, operands);
      break;

    default:
      break;
    }
  if (nonimmediate_gr_operand (operands[0], E_DImode)
      && general_gr_operand (operands[1], E_DImode)
      && (
#line 2772 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
    return gen_split_9 (insn, operands);
  if (sse_reg_operand (operands[0], E_DImode)
      && general_reg_operand (operands[1], E_DImode)
      && 
#line 2779 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE4_1
   && reload_completed))
    return gen_split_10 (insn, operands);
  if (push_operand (operands[0], E_VOIDmode)
      && general_gr_operand (operands[1], E_VOIDmode)
      && 
#line 4010 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode)))
    return gen_split_28 (insn, operands);
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (nonimmediate_gr_operand (operands[0], E_TFmode)
          && general_gr_operand (operands[1], E_TFmode)
          && 
#line 4083 "../../../gcc/config/i386/i386.md"
(reload_completed))
        return gen_split_29 (insn, operands);
      break;

    case E_XFmode:
      if (nonimmediate_gr_operand (operands[0], E_XFmode)
          && general_gr_operand (operands[1], E_XFmode)
          && 
#line 4156 "../../../gcc/config/i386/i386.md"
(reload_completed))
        return gen_split_30 (insn, operands);
      break;

    case E_DFmode:
      if (nonimmediate_gr_operand (operands[0], E_DFmode)
          && general_gr_operand (operands[1], E_DFmode)
          && 
#line 4334 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_31 (insn, operands);
      break;

    default:
      break;
    }
  if (any_fp_register_operand (operands[0], E_VOIDmode)
      && memory_operand (operands[1], E_VOIDmode)
      && 
#line 4602 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode
       || GET_MODE (operands[0]) == SFmode)
   && ix86_standard_x87sse_constant_load_p (insn, operands[0])))
    return gen_split_32 (insn, operands);
  if (fp_register_operand (operands[0], E_SFmode)
      && immediate_operand (operands[1], E_SFmode)
      && 
#line 4626 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return gen_split_34 (insn, operands);
  if (fp_register_operand (operands[0], E_DFmode)
      && immediate_operand (operands[1], E_DFmode)
      && 
#line 4626 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return gen_split_35 (insn, operands);
  if (!fp_register_operand (operands[0], E_XFmode)
      || !immediate_operand (operands[1], E_XFmode)
      || !
#line 4626 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return NULL;
  return gen_split_36 (insn, operands);
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      switch (pattern535 (x3))
        {
        case 0:
          if (!
#line 18166 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode) - 1))
   == GET_MODE_BITSIZE (QImode) - 1))
            return NULL;
          return gen_split_562 (insn, operands);

        case 1:
          if (!
#line 18166 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode) - 1))
   == GET_MODE_BITSIZE (HImode) - 1))
            return NULL;
          return gen_split_564 (insn, operands);

        case 2:
          if (!
#line 18166 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1))
   == GET_MODE_BITSIZE (SImode) - 1))
            return NULL;
          return gen_split_566 (insn, operands);

        case 3:
          if (!(
#line 18166 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1))
   == GET_MODE_BITSIZE (DImode) - 1) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_568 (insn, operands);

        case 4:
          if (!
#line 18239 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_594 (insn, operands);

        case 5:
          if (!
#line 18239 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_596 (insn, operands);

        case 6:
          if (!
#line 18239 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_598 (insn, operands);

        case 7:
          if (!
#line 18308 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_622 (insn, operands);

        case 8:
          if (!
#line 18308 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_624 (insn, operands);

        case 9:
          if (!
#line 18308 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_626 (insn, operands);

        case 10:
          if (!
#line 18201 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode) - 1))
  == GET_MODE_BITSIZE (QImode) - 1))
            return NULL;
          return gen_split_578 (insn, operands);

        case 11:
          if (!
#line 18201 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode) - 1))
  == GET_MODE_BITSIZE (HImode) - 1))
            return NULL;
          return gen_split_580 (insn, operands);

        case 12:
          if (!
#line 18201 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1))
  == GET_MODE_BITSIZE (SImode) - 1))
            return NULL;
          return gen_split_582 (insn, operands);

        case 13:
          if (!(
#line 18201 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1))
  == GET_MODE_BITSIZE (DImode) - 1) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_584 (insn, operands);

        case 14:
          if (!
#line 18271 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_608 (insn, operands);

        case 15:
          if (!
#line 18271 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_610 (insn, operands);

        case 16:
          if (!
#line 18271 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_612 (insn, operands);

        case 17:
          if (!
#line 18340 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_636 (insn, operands);

        case 18:
          if (!
#line 18340 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_638 (insn, operands);

        case 19:
          if (!
#line 18340 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_640 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return NULL;
      if (XWINT (x5, 0) == 32LL
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x3) == E_DImode
          && register_operand (operands[1], E_DImode)
          && (
#line 18427 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT) && 
#line 18429 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return gen_split_644 (insn, operands);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_QImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 18536 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)
   && !TARGET_APX_NDD))
            return NULL;
          return gen_split_648 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 18536 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)
   && !TARGET_APX_NDD) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_649 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return split_6 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      switch (GET_CODE (x2))
        {
        case REG:
          if (REGNO (x2) != 17
              || pattern59 (x1, 
E_CCCmode) != 0
              || !(
#line 9883 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9885 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_161 (insn, operands);

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x2), 0))
            return NULL;
          x3 = XEXP (x2, 0);
          switch (GET_CODE (x3))
            {
            case NOT:
              if (GET_MODE (x3) != E_QImode)
                return NULL;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x4), 0)
                  || GET_MODE (x4) != E_QImode)
                return NULL;
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case SIGN_EXTRACT:
                case ZERO_EXTRACT:
                  operands[2] = x5;
                  if (pattern227 (x1) != 0)
                    return NULL;
                  x6 = XEXP (x1, 0);
                  switch (GET_MODE (x6))
                    {
                    case E_HImode:
                      if (GET_MODE (x2) != E_HImode
                          || !extract_operator (operands[2], E_HImode)
                          || !
#line 15143 "../../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                        return NULL;
                      return gen_split_454 (insn, operands);

                    case E_SImode:
                      if (GET_MODE (x2) != E_SImode
                          || !extract_operator (operands[2], E_SImode)
                          || !
#line 15143 "../../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                        return NULL;
                      return gen_split_455 (insn, operands);

                    case E_DImode:
                      if (GET_MODE (x2) != E_DImode
                          || !extract_operator (operands[2], E_DImode)
                          || !(
#line 15143 "../../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return NULL;
                      return gen_split_456 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case LSHIFTRT:
              if (pattern532 (x1) != 0
                  || !((
#line 16736 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16738 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_493 (insn, operands);

            case ASHIFTRT:
              if (pattern532 (x1) != 0
                  || !((
#line 16736 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16738 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_494 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      return split_8 (x1, insn);

    case IOR:
      return split_7 (x1, insn);

    case XOR:
      return split_10 (x1, insn);

    case FLOAT_EXTEND:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case SUBREG:
        case MEM:
          if (memory_operand (operands[1], E_VOIDmode)
              && any_fp_register_operand (operands[0], E_VOIDmode)
              && 
#line 4614 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode)
   && ix86_standard_x87sse_constant_load_p (insn, operands[0])))
            return gen_split_33 (insn, operands);
          break;

        case REG:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[1], E_SFmode)
          || !sse_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode)
        return NULL;
      if (
#line 5339 "../../../gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_51 (insn, operands);
      if (!
#line 5402 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_52 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          switch (GET_CODE (operands[1]))
            {
            case SUBREG:
            case MEM:
              if (memory_operand (operands[1], E_SImode)
                  && memory_operand (operands[0], E_DImode)
                  && 
#line 4784 "../../../gcc/config/i386/i386.md"
(reload_completed))
                return gen_split_37 (insn, operands);
              break;

            case REG:
              if (general_reg_operand (operands[1], E_SImode)
                  && general_reg_operand (operands[0], E_DImode)
                  && 
#line 4791 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && REGNO (operands[0]) == REGNO (operands[1])))
                return gen_split_38 (insn, operands);
              break;

            default:
              break;
            }
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !nonimmediate_gr_operand (operands[0], E_DImode)
              || !
#line 4799 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return NULL;
          return gen_split_39 (insn, operands);

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 19
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XVECEXP (x3, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || !(
#line 23045 "../../../gcc/config/i386/i386.md"
(TARGET_X32) && 
#line 23047 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_747 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!sse_reg_operand (operands[0], E_SFmode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return NULL;
      if (
#line 5578 "../../../gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_53 (insn, operands);
      if (!
#line 5632 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_54 (insn, operands);

    case FLOAT:
      return split_12 (x1, insn);

    case MULT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!general_reg_operand (operands[0], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      if (!const1248_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0])
          || !
#line 6428 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed))
        return NULL;
      return gen_split_76 (insn, operands);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x8 = XEXP (x2, 1);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = split_3 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (nonimmediate_operand (operands[0], E_QImode))
        {
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[1] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !ix86_comparison_operator (operands[1], E_HImode)
              || !(
#line 19514 "../../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19517 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_713 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !ix86_comparison_operator (operands[1], E_SImode)
              || !(
#line 19514 "../../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19517 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_714 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      switch (XVECLEN (x2, 0))
        {
        case 2:
          switch (XINT (x2, 1))
            {
            case 40:
              if (GET_MODE (x2) != E_CCCmode)
                return NULL;
              x9 = XVECEXP (x2, 0, 0);
              if (GET_CODE (x9) != LTU
                  || pattern652 (x9) != 0
                  || pattern225 (x1) != 0)
                return NULL;
              x10 = XEXP (x9, 0);
              switch (GET_MODE (x10))
                {
                case E_CCmode:
                  if (!(
#line 9904 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9906 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case E_CCCmode:
                  if (!(
#line 9904 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9906 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                default:
                  return NULL;
                }

            case 45:
              if (pattern257 (x2) != 0)
                return NULL;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              x11 = XVECEXP (x2, 0, 1);
              operands[2] = x11;
              if (!register_operand (operands[2], E_SImode)
                  || !(
#line 19556 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 19558 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_715 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          switch (XINT (x2, 1))
            {
            case 97:
              if (GET_MODE (x2) != E_SImode
                  || !register_operand (operands[0], E_SImode))
                return NULL;
              x9 = XVECEXP (x2, 0, 0);
              operands[1] = x9;
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !((
#line 21642 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 21644 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                return NULL;
              return gen_split_736 (insn, operands);

            case 96:
              if (GET_MODE (x2) != E_SImode
                  || !register_operand (operands[0], E_SImode))
                return NULL;
              x9 = XVECEXP (x2, 0, 0);
              operands[1] = x9;
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !((
#line 21642 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 21644 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                return NULL;
              return gen_split_737 (insn, operands);

            case 19:
              x9 = XVECEXP (x2, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern57 (x2))
                {
                case 0:
                  if (!
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
                    return NULL;
                  return gen_split_745 (insn, operands);

                case 1:
                  if (!
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
                    return NULL;
                  return gen_split_746 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          switch (pattern342 (x2))
            {
            case 0:
              return gen_split_332 (insn, operands);

            case 1:
              return gen_split_335 (insn, operands);

            case 2:
              return gen_split_338 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern342 (x2))
            {
            case 0:
              return gen_split_333 (insn, operands);

            case 1:
              return gen_split_336 (insn, operands);

            case 2:
              return gen_split_339 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern342 (x2))
            {
            case 0:
              return gen_split_334 (insn, operands);

            case 1:
              return gen_split_337 (insn, operands);

            case 2:
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      switch (pattern42 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 14976 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14978 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_445 (insn, operands);

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !((
#line 14976 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14978 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_446 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 15059 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15063 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_447 (insn, operands);

        case 2:
          if (!(
#line 15059 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15063 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_448 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (pattern653 (x2, 
E_QImode) != 0
              || !
#line 15978 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
            return NULL;
          return gen_split_468 (insn, operands);

        case CONST_INT:
          if (!const_0_to_3_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!general_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !index_reg_operand (operands[1], E_QImode)
                  || !
#line 16300 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_476 (insn, operands);

            case E_HImode:
              if (!general_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !index_reg_operand (operands[1], E_HImode)
                  || !
#line 16300 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_477 (insn, operands);

            case E_SImode:
              if (!general_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !index_reg_operand (operands[1], E_SImode)
                  || !
#line 16300 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_478 (insn, operands);

            case E_DImode:
              if (!general_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !index_reg_operand (operands[1], E_DImode)
                  || !(
#line 16300 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_479 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 17425 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
        return NULL;
      return gen_split_501 (insn, operands);

    case ASHIFTRT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return NULL;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 17425 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
            return NULL;
          return gen_split_502 (insn, operands);

        case ASHIFT:
          if (GET_MODE (x3) != E_V2DImode
              || pattern235 (x2, 
E_V2DImode) != 0)
            return NULL;
          if ((
#line 18006 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_STV && TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32) && 
#line 18010 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_552 (insn, operands);
          if (!(
#line 18023 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32
   && ix86_pre_reload_split ()) && 
#line 18028 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_553 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      return split_9 (x1, insn);

    case ROTATERT:
      return split_11 (x1, insn);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
          operands[5] = x3;
          if (bt_comparison_operator (operands[5], E_VOIDmode))
            {
              res = split_5 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          x4 = XEXP (x3, 0);
          if (!ix86_comparison_operator (x4, E_VOIDmode))
            return NULL;
          operands[0] = x4;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 17)
            return NULL;
          x12 = XEXP (x4, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x13 = XEXP (x3, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != LABEL_REF)
            return NULL;
          x14 = XEXP (x2, 2);
          if (GET_CODE (x14) != PC)
            return NULL;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != PC)
            return NULL;
          x15 = XEXP (x8, 0);
          operands[1] = x15;
          switch (GET_CODE (x3))
            {
            case NE:
              return gen_split_723 (insn, operands);

            case EQ:
              return gen_split_724 (insn, operands);

            default:
              return NULL;
            }

        case GEU:
        case LTU:
          operands[1] = x3;
          if (!add_comparison_operator (operands[1], E_VOIDmode))
            return NULL;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != NOT)
            return NULL;
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != LABEL_REF)
            return NULL;
          x14 = XEXP (x2, 2);
          if (GET_CODE (x14) != PC)
            return NULL;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != PC)
            return NULL;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x13 = XEXP (x3, 1);
          operands[3] = x13;
          x15 = XEXP (x8, 0);
          operands[0] = x15;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode)
                  || !nonimmediate_operand (operands[3], E_QImode))
                return NULL;
              return gen_split_720 (insn, operands);

            case E_HImode:
              if (!register_operand (operands[2], E_HImode)
                  || !nonimmediate_operand (operands[3], E_HImode))
                return NULL;
              return gen_split_721 (insn, operands);

            case E_SImode:
              if (!register_operand (operands[2], E_SImode)
                  || !nonimmediate_operand (operands[3], E_SImode))
                return NULL;
              return gen_split_722 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != XOR
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x15 = XEXP (x8, 0);
      if (GET_CODE (x15) != MINUS
          || GET_MODE (x15) != E_SImode)
        return NULL;
      x16 = XEXP (x15, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return NULL;
      x17 = XEXP (x15, 1);
      if (GET_CODE (x17) != CLZ
          || GET_MODE (x17) != E_SImode)
        return NULL;
      x18 = XEXP (x8, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x19 = XEXP (x17, 0);
      operands[1] = x19;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21379 "../../../gcc/config/i386/i386.md"
(!TARGET_LZCNT && ix86_pre_reload_split ()))
        return NULL;
      return gen_split_733 (insn, operands);

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 21481 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 21483 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_734 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 22138 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 22146 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_740 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return NULL;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !ix86_comparison_operator (operands[1], E_VOIDmode))
        return NULL;
      if (nonimmediate_operand (operands[2], E_HImode)
          && nonimmediate_operand (operands[3], E_HImode)
          && 
#line 26227 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()))
        return gen_split_771 (insn, operands);
      if (!register_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode)
          || !
#line 26257 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL
   && reload_completed))
        return NULL;
      return gen_split_775 (insn, operands);

    case E_SImode:
      if (pattern1089 (x2, 
E_SImode) != 0
          || !
#line 26227 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_772 (insn, operands);

    case E_DImode:
      if (pattern1089 (x2, 
E_DImode) != 0
          || !(
#line 26227 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_773 (insn, operands);

    case E_QImode:
      if (pattern1090 (x2) != 0
          || !
#line 26257 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL
   && reload_completed))
        return NULL;
      return gen_split_774 (insn, operands);

    case E_DFmode:
      if (GET_MODE (x2) != E_DFmode
          || !nonimmediate_operand (operands[2], E_DFmode)
          || !nonimmediate_operand (operands[3], E_DFmode))
        return NULL;
      if (general_reg_operand (operands[0], E_DFmode)
          && fcmov_comparison_operator (operands[1], E_VOIDmode)
          && 
#line 26473 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_776 (insn, operands);
      if (!register_operand (operands[0], E_DFmode)
          || !ix86_comparison_operator (operands[1], E_VOIDmode)
          || !
#line 26507 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_80387 && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_778 (insn, operands);

    case E_SFmode:
      if (pattern1089 (x2, 
E_SFmode) != 0
          || !
#line 26507 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_80387 && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_777 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_41 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return NULL;
  switch (XWINT (x4, 0))
    {
    case 0LL:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern893 (x2))
            {
            case 0:
              if ((
#line 1783 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1786 "../../../gcc/config/i386/mmx.md"
( reload_completed)))
                return gen_split_833 (insn, operands);
              break;

            case 1:
              if ((
#line 12336 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 12338 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1328 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (nonimmediate_operand (operands[1], E_V2SImode)
                      && (
#line 5729 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 5732 "../../../gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_900 (insn, operands);
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 21217 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
                    return gen_split_3157 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_HFmode:
          switch (pattern894 (x2))
            {
            case 0:
              if (((
#line 13245 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 548 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13247 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1351 (insn, operands);
              break;

            case 1:
              if ((
#line 13245 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13247 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1352 (insn, operands);
              break;

            case 2:
              if ((
#line 13245 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13247 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1353 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_BFmode:
          switch (pattern895 (x2))
            {
            case 0:
              if (((
#line 13245 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 549 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13247 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1354 (insn, operands);
              break;

            case 1:
              if ((
#line 13245 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13247 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1355 (insn, operands);
              break;

            case 2:
              if ((
#line 13245 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13247 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1356 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && nonimmediate_operand (operands[1], E_V2DFmode)
              && 
#line 14683 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
            return gen_split_2945 (insn, operands);
          break;

        case E_QImode:
          if (memory_operand (operands[0], E_QImode)
              && GET_MODE (x2) == E_QImode
              && register_operand (operands[1], E_V16QImode)
              && ((
#line 21077 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()) && 
#line 21070 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1)) && 
#line 21083 "../../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3154 (insn, operands);
          break;

        case E_HImode:
          if (memory_operand (operands[0], E_HImode)
              && GET_MODE (x2) == E_HImode
              && register_operand (operands[1], E_V8HImode)
              && (
#line 21077 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()) && 
#line 21083 "../../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3155 (insn, operands);
          break;

        case E_TImode:
          if (nonimmediate_operand (operands[0], E_TImode)
              && GET_MODE (x2) == E_TImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4TImode:
                  if (register_operand (operands[1], E_V4TImode)
                      && (
#line 21451 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && reload_completed
   && (TARGET_AVX512VL || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 21444 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3164 (insn, operands);
                  break;

                case E_V2TImode:
                  if (register_operand (operands[1], E_V2TImode)
                      && 
#line 21451 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && reload_completed
   && (TARGET_AVX512VL || !EXT_REX_SSE_REG_P (operands[1]))))
                    return gen_split_3165 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      break;

    case 1LL:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && GET_MODE (x2) == E_SFmode
              && memory_operand (operands[1], E_V2SFmode)
              && 
#line 1827 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && reload_completed))
            return gen_split_834 (insn, operands);
          break;

        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && memory_operand (operands[1], E_V2SImode)
              && 
#line 5816 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && reload_completed))
            return gen_split_902 (insn, operands);
          break;

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && memory_operand (operands[1], E_V2DFmode)
              && 
#line 14630 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
            return gen_split_2943 (insn, operands);
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      if (nonimmediate_operand (operands[0], E_SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && const_0_to_3_operand (operands[2], E_SImode)
          && (
#line 12347 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 12354 "../../../gcc/config/i386/sse.md"
( reload_completed && SSE_REG_P (operands[0]))))
        return gen_split_1329 (insn, operands);
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode)
          || !(
#line 12390 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 12392 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1330 (insn, operands);

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || !memory_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_VOIDmode)
          || !
#line 21404 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3160 (insn, operands);

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !memory_operand (operands[1], E_V8HImode)
          || !const_0_to_7_operand (operands[2], E_VOIDmode)
          || !
#line 21404 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3161 (insn, operands);

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !memory_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode)
          || !
#line 21404 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3162 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x4, operands[1]))
        return NULL;
      x5 = XEXP (x2, 1);
      if (XVECLEN (x5, 0) != 2)
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != CONST_INT
          || GET_MODE (x2) != E_V2DFmode
          || GET_MODE (x3) != E_V4DFmode)
        return NULL;
      if (XWINT (x6, 0) == 0LL)
        {
          x7 = XVECEXP (x5, 0, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 2]
              && memory_operand (operands[0], E_V2DFmode)
              && register_operand (operands[1], E_V2DFmode)
              && 
#line 13592 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && reload_completed))
            return gen_split_1357 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return NULL;
      operands[2] = x6;
      if (!const_0_to_1_operand (operands[2], E_SImode))
        return NULL;
      x7 = XVECEXP (x5, 0, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 13610 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && INTVAL (operands[2]) + 2 == INTVAL (operands[3])))
        return NULL;
      return gen_split_1358 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (pattern745 (x2))
        {
        case 0:
          if (!(
#line 24145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24147 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3244 (insn, operands);

        case 1:
          if (!(
#line 24198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 24200 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3248 (insn, operands);

        case 2:
          if (!(
#line 24294 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24296 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3256 (insn, operands);

        case 3:
          if (!(
#line 24542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512) && 
#line 24544 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3268 (insn, operands);

        case 4:
          if (!(
#line 24596 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24598 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3272 (insn, operands);

        case 5:
          if (!(
#line 24701 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24703 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3280 (insn, operands);

        case 6:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && (
#line 25098 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512) && 
#line 25100 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return gen_split_3303 (insn, operands);
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3496 (insn, operands);

        case 7:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && (
#line 25150 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 25152 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return gen_split_3305 (insn, operands);
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3497 (insn, operands);

        case 8:
          if (vector_operand (operands[1], E_V4SImode)
              && pmovzx_parallel (operands[3], E_VOIDmode)
              && (
#line 25235 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 25237 "../../../gcc/config/i386/sse.md"
( reload_completed)))
            return gen_split_3311 (insn, operands);
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !movq_parallel (operands[3], E_VOIDmode)
              || !(
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3498 (insn, operands);

        case 9:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3499 (insn, operands);

        case 10:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3500 (insn, operands);

        case 11:
          if (!(
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3501 (insn, operands);

        case 12:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3502 (insn, operands);

        case 13:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3503 (insn, operands);

        case 14:
          if (!(
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3504 (insn, operands);

        case 15:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3505 (insn, operands);

        case 16:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3506 (insn, operands);

        case 17:
          if (!(
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3507 (insn, operands);

        case 18:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3508 (insn, operands);

        case 19:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3509 (insn, operands);

        case 20:
          if (!(
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3510 (insn, operands);

        case 21:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3511 (insn, operands);

        case 22:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3512 (insn, operands);

        case 23:
          if (!((
#line 29072 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 29074 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3513 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern471 (x2))
        {
        case 0:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1440 (insn, operands);

        case 1:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1467 (insn, operands);

        case 2:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1494 (insn, operands);

        case 3:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1521 (insn, operands);

        case 4:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1548 (insn, operands);

        case 5:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1575 (insn, operands);

        case 6:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1602 (insn, operands);

        case 7:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1629 (insn, operands);

        case 8:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1656 (insn, operands);

        case 9:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1683 (insn, operands);

        case 10:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1710 (insn, operands);

        case 11:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1737 (insn, operands);

        case 12:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1443 (insn, operands);

        case 13:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1470 (insn, operands);

        case 14:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1497 (insn, operands);

        case 15:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1524 (insn, operands);

        case 16:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1551 (insn, operands);

        case 17:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1578 (insn, operands);

        case 18:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1605 (insn, operands);

        case 19:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1632 (insn, operands);

        case 20:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1659 (insn, operands);

        case 21:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1686 (insn, operands);

        case 22:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1713 (insn, operands);

        case 23:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1740 (insn, operands);

        case 24:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1446 (insn, operands);

        case 25:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1473 (insn, operands);

        case 26:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1500 (insn, operands);

        case 27:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1527 (insn, operands);

        case 28:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1554 (insn, operands);

        case 29:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1581 (insn, operands);

        case 30:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1608 (insn, operands);

        case 31:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1635 (insn, operands);

        case 32:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1662 (insn, operands);

        case 33:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1689 (insn, operands);

        case 34:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1716 (insn, operands);

        case 35:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1743 (insn, operands);

        case 36:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2730 (insn, operands);

        case 37:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2739 (insn, operands);

        case 38:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2748 (insn, operands);

        case 39:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2757 (insn, operands);

        case 40:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2766 (insn, operands);

        case 41:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2775 (insn, operands);

        case 42:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2784 (insn, operands);

        case 43:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2793 (insn, operands);

        case 44:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2802 (insn, operands);

        case 45:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2811 (insn, operands);

        case 46:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2820 (insn, operands);

        case 47:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2829 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern473 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2088 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2115 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2142 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2169 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2196 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2223 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2250 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2277 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2304 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2331 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2358 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2385 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern473 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2091 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2118 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2145 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2172 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2199 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2226 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2253 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2280 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2307 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2334 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2361 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2388 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern473 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2094 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2121 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2148 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2175 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2202 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2229 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2256 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2283 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2310 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2337 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2364 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2391 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_67 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern475 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1756 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1783 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1810 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1837 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1864 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1891 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1918 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1945 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1972 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1999 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2026 (insn, operands);

            case 11:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2053 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1759 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1786 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1813 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1840 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1867 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1894 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1921 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1948 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1975 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2002 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2029 (insn, operands);

            case 23:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2056 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1762 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1789 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1816 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1843 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1870 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1897 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1924 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1951 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1978 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2005 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2032 (insn, operands);

            case 35:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2059 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2836 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2845 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2854 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2863 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2872 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2881 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2890 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2899 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2908 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2917 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2926 (insn, operands);

            case 47:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2935 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern476 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2404 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2431 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2458 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2485 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2512 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2539 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2566 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2593 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2620 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2647 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2674 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2701 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern476 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2407 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2434 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2461 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2488 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2515 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2542 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2569 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2596 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2623 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2650 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2677 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2704 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern476 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2410 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2437 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2464 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2491 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2518 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2545 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2572 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2599 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2626 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2653 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2680 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2707 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern475 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1765 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1792 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1819 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1846 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1873 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1900 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1927 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1954 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1981 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2008 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2035 (insn, operands);

            case 11:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2062 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1768 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1795 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1822 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1849 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1876 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1903 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1930 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1957 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1984 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2011 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2038 (insn, operands);

            case 23:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2065 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1771 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1798 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1825 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1852 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1879 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1906 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1933 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1960 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1987 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2014 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2041 (insn, operands);

            case 35:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2068 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2839 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2848 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2857 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2866 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2875 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2884 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2893 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2902 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2911 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2920 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2929 (insn, operands);

            case 47:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2938 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern476 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2413 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2440 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2467 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2494 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2521 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2548 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2575 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2602 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2629 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2656 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2683 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2710 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern476 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2416 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2443 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2470 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2497 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2524 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2551 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2578 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2605 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2632 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2659 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2686 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2713 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern476 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2419 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2446 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2473 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2500 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2527 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2554 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2581 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2608 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2635 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2662 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2689 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2716 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      return split_63 (x1, insn);

    default:
      return NULL;
    }
}
